#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef	MSDOS
#include <io.h>
#include <ctype.h>
#include <dir.h>
#include <conio.h>
#include <dos.h>
#endif

#include "hex.h"
#include "profile.h"
#include "control.h"
#include "filename.h"

#ifdef	STRICMP
#include	"stricmp.h"
#endif
#ifdef	STRNICMP
#include	"strnicmp.h"
#endif

extern "C" {
#include "tty.h"
}

/* 2000/07/15  */
/* 2001/01/15 Ver.1.40 */
/* 2001/03/25 Ver.1.41 zϐւ̏lǉ */
/* 2001/07/01 Ver.1.50 RpCOɐ؂o */


#define	VERSION	"Universal H8 Controller Version 1.50 Copyright (C) 2000-2001 T.Sagae\n"

#ifdef	MSDOS
extern	unsigned	_stklen = 10000;	/* X^bNTCY傫 */
#endif

#define	FUNCTION_MAX	14
#define	MESSAGE_MAX		100

/* ֐ƃAhXi[ϐ */
static	struct	{
	char	*func;	/* ֐ */
	char	*com;	/*  */
	char	flg;		/* smFL */
	char	fcheck;		/* t@CLmF */
	unsigned	long	adr;	/* sJnAhX */
}	Func[FUNCTION_MAX];
int		FunctionCount = 0;

char    Msg1[128];

/* s֐ */
char	*AutoRun[2];
unsigned	long	AutoAdr[2];
int		AutoRunCount = 0;

/* bZ[Wi[ϐ */
struct	{
	char	*Msg;			/* bZ[W */
	unsigned	int	num;	/* bZ[Wԍ */
}	MsgData[MESSAGE_MAX];
int		MsgCount = 0;

char	controlfile[512];	/* control.dat ւ̃pX */

int		Cid = -1;			/* RS232CʐM|[gID */

static	struct	{	/* RS232CMf[^i[p */
	unsigned	int		event;
	unsigned	int		msgno;
	unsigned	long	address;
	unsigned	long	length;
	unsigned	char	ComBuff[1024];
} coms;

unsigned	int	ProgSum = 0;
char    EditFile[512];		/* ȈՌt@C */
char	InfFile[512];		/* xxx.inf t@C */
char	RomFile[512];		/* xxx.rom t@C */
int		KeyMode = 0;

int	AsmModeDos = 0;	/* compile switch 0:contents of fileA1:always onA2:always off */
int	Optimize = 1;	/* 0:offA1:on */
char	OptimizeCommand[256];
char	AssemblerCommand[256];
char	CompilerCommand[256];
char	MakeasmCommand[256];
char	SymbolUpdateCommand[256];


int	HexFile_Checked = 0;	/* 0:ʏA1:ȈՌHEXt@C쐬ꍇ */
char	DataFile[1024];		/* f[^t@C */
FILE	*Rdfp = NULL;		/* ǂݍݗpt@C|C^ */
FILE	*Wrfp = NULL;		/* ݗpt@C|C^ */

unsigned	char	*image;	// ݃C[W
int		image_ptr;

/* I[oCt[ */
long	frame_start[16];	/* t[f[^̊i[JnAhX */
long	frame_length[16];	/* t[f[^ */
int	overlay_frame;

extern  int	ReadData(		/* 0:A-1:ُ */
	int		flg,			/* 0:A1:p */
	FILE	*fp,			/* ǂݍ݃t@C|C^ */
	long	*radr,			/* ǂݍ񂾃f[^̊JnAhX */
	unsigned char	*data,	/* ǂݍ񂾃f[^ */
	int 	*len );			/* :őǂݍݒAo:ۂ̓ǂݍݒ */


/* vg^Cv錾 */
int	ProgLoad( char *filename );
int	RsOpen( int speed );
void	DispFunc( void );
int	AutoExecute( void );
int	ExecuteCommand( int num );
int	ComRequest( char *param, int length );
int	RunChild( char *exec );
void	MessageList( char *msg );

void	MessageList( char *msg )
{
	printf( "%s\n", msg );
}

int	YesNo( char *msg )	/* Yes/NomFp֐ */
{
	int		k;

	printf( msg );
	while( 1 ) {
		if( kbhit() ) {
			k = toupper( getch() );
			if( k == 'Y' ) {
				printf( "Y\n" );
				return(1);
			}
			if( k == 'N' ) {
				printf( "N\n" );
				return(0);
			}
		}
	}
}

void	DispFunc()	/* j[\ */
{
	int		i;

	printf( "\n" );
	for( i=0; i<FunctionCount; i++ ) {
		if( (i%2) == 0 ) {
			if( i >= 10 ) {
				printf( " %c:%-37s", i-10+'a', Func[i].com );
			} else {
				printf( "%2d:%-37s", i+1, Func[i].com );
			}
		} else {
			if( i >= 10 ) {
				printf( " %c:%s\n", i-10+'a', Func[i].com );
			} else {
				printf( "%2d:%s\n", i+1, Func[i].com );
			}
		}
	}
	if( (FunctionCount%2) == 1 ) {
		printf( "\n" );
	}
	printf( " f:f[^t@C [%s]\n", DataFile );
	printf( " q:I\n" );
	printf( ">" );
}

int	RsGetChar(void)
{
	int	dt;

	while( 1 ) {
		if( kbhit() ) {
			if( (dt=getch()) == 0x1b ) {
				closetty( Cid );
printf( "[ ESC ] L[ɂI܂\n" );
				exit(1);
			}
			if( ttyputc( Cid, (unsigned char)dt ) == -1 ) {
printf( "L[͂̑MŎs܂\n" );
				closetty( Cid );
				exit(1);
			}
			if( dt >= 0x20 && dt < 0x7f ) {
				printf( "char(%d:%c)\n", dt, dt );
			} else {
				printf( "char(%d)\n", dt );
			}
		}
		if( (dt=ttygetc(Cid)) >= 0 ) {
			return( dt );
		}
	}
}

int	WriteRs232c( int port, char *buff, int len )
{
	int		i;

	for( i=0; i<len; i++ ) {
		if( ttyputc( port, buff[i] ) == -1 ) {
printf( "R}hMŎs܂\n" );
			return(-1);
		}
	}
	return(0);
}

void	TransmitData( int flg, unsigned int length )
{
	int		rc;
	long	adr;
	unsigned	int		ad, sum;
	unsigned	char	ad1, ad2, ad3, ad4, l1, l2;
	static	unsigned	char	buff[128], data[3600];

	// tO̊mF
	if( flg == 0 ) {
		/* ̃f[^v */
		if( Rdfp != NULL ) {
			fclose( Rdfp );
		}
		Rdfp = fopen( DataFile, "r" );
	}
	if( Rdfp == NULL ) {
		MessageList( "t@CI[vo܂" );
		// ɓǂݍ݃f[^TCY[ŕԂ */
		sprintf( (char *)data, "+++%c%c%c%c%c%c%c", EV_DATA, 0,0,0,0, 0, 0 );
		data[10] = 0;
		data[11] = 0;
		WriteRs232c( Cid, (char *)buff, 12 );
		return;
	}
	rc = ReadData( flg, Rdfp, &adr, &data[10], (int *)&length );
	if( rc != 0 ) {
		if( Rdfp != NULL ) {
			fclose( Rdfp );
		}
		Rdfp = NULL;
		MessageList( "t@Cǂݍ݂ňُ킪܂" );
		// ɓǂݍ݃f[^TCY[ŕԂ */
		sprintf( (char *)data, "+++%c%c%c%c%c%c%c", EV_DATA, 0,0,0,0, 0, 0 );
		data[10] = 0;
		data[11] = 0;
		WriteRs232c( Cid, (char *)buff, 12 );
		return;
	} else if( length == 0 ) {
		if( Rdfp != NULL ) {
			fclose( Rdfp );
		}
		Rdfp = NULL;
	}
	sum = 0;
	ad1 = (unsigned char)((adr>>24)&0xff);
	sum += ad1;
	ad2 = (unsigned char)((adr>>16)&0xff);
	sum += ad2;
	ad3 = (unsigned char)((adr>>8)&0xff);
	sum += ad3;
	ad4 = (unsigned char)(adr&0xff);
	sum += ad4;
	l1 = (unsigned char)((length>>8)&0xff);
	sum += l1;
	l2 = (unsigned char)(length&0xff);
	sum += l2;

	if( length == 0 ) {
		sprintf( (char *)buff, "f[^ǂݏoIʒm𑗐M܂" );
	} else {
		sprintf( (char *)buff, "%lX(H)  %d oCg̃f[^𑗐M܂", adr, length );
	}
	MessageList( buff );

	sprintf( (char *)buff, "+++%c%c%c%c%c%c%c", EV_DATA, ad1,ad2,ad3,ad4, l1, l2 );
	memcpy( data, buff, 10 );
	for( ad = 0; ad<length; ad++ ) {
		sum += data[ad+10];
	}
	data[length+10] = (unsigned char)((sum>>8)&0xff);
	data[length+11] = (unsigned char)(sum&0xff);
	WriteRs232c( Cid, (char *)data, length+12 );
}

void	TransmitProg( int frame )
{
	unsigned	int		ad, sum;
	unsigned	char	data[4096], ad1, ad2, ead1, ead2, l1, l2;

	if( frame < 0 || frame > overlay_frame ) {
		/* frame͈͊Ô߃I[[ԑ */
		sprintf( (char *)data, "+++%c%c%c%c%c%c%c%c%c",
				EV_LOAD, 0,0, 0,0, 0,0, 0,0 );
		WriteRs232c( Cid, (char *)data, 12 );
		return;
	}
	sum = 0;
	/* [̃AhXݒ肷 */
	if( frame == 0 ) {
		ad1 = 0;
		ad2 = 0;
	} else {
		ad1 = (unsigned char)((frame_length[0]>>8)&0xff);
		sum += ad1;
		ad2 = (unsigned char)(frame_length[0]&0xff);
		sum += ad2;
	}
	/* EEPROM[̃AhXݒ肷 */
	ad = frame_start[frame]+64;	/* 64=(adr1(2)+adr2(2)) * 16 */
	ead1 = (unsigned char)((ad>>8)&0xff);
	sum += ead1;
	ead2 = (unsigned char)(ad&0xff);
	sum += ead2;
	/* f[^ݒ肷 */
	l1 = (unsigned char)((frame_length[frame]>>8)&0xff);
	sum += l1;
	l2 = (unsigned char)(frame_length[frame]&0xff);
	sum += l2;

	sprintf( (char *)data, "frame %d", frame );
	MessageList( (char *)data );

	sprintf( (char *)data, "+++%c%c%c%c%c%c%c",
			EV_LOAD, ad1,ad2, ead1,ead2, l1,l2 );
	for( ad = 0; ad<(unsigned int)frame_length[frame]; ad++ ) {
		data[ad+10] = image[frame_start[frame]+ad];
		sum += data[ad+10];
	}
	data[frame_length[frame]+10] = (unsigned char)((sum>>8)&0xff);
	data[frame_length[frame]+11] = (unsigned char)(sum&0xff);
	WriteRs232c( Cid, (char *)data, frame_length[frame]+12 );
}

int	ComRequest( char *param, int length )
{
	int	i, cnt;
	long	ad, m;

	/* R}hM */
	if( length > 0 ) {
		if( WriteRs232c( Cid, param, length ) == -1 ) {
			return(-1);
		}
	}
	/* R}hI҂ */
	cnt = 0;
	while( 1 ) {
		if( RsGetChar() != '+' ) {
			cnt = 0;
			continue;
		}
		if( (++cnt) < 3 ) {
			continue;
		}
		/* +++ ̃wb_[M̂ł{̂M */
		coms.event = RsGetChar();
		switch( coms.event ) {
		case	EV_STR:
			i = 0;
			while( (coms.ComBuff[i++] = (unsigned char)RsGetChar()) != 0 );
			printf( "%s\n", coms.ComBuff );
			break;
		case	EV_CODE:
			coms.msgno = (unsigned int)(RsGetChar()<<8);
			coms.msgno += (unsigned int)(RsGetChar());
			switch( coms.msgno ) {
			case	0:	// Xg{bNX
			case	1:	// L[{[h͗L
			case	2:	// L[{[h͖
			case	3:	// 
				KeyMode = 0;
				break;
			case	4:	// 16i
				KeyMode = 1;
				break;
			case	5:	// {^L
			case	6:	// {^
				break;
			default:
				for( i=0; i<MsgCount; i++ ) {
					if( MsgData[i].num == coms.msgno ) {
						printf( "%s\n", MsgData[i].Msg );
						break;
					}
				}
				break;
			}
			break;
		case	EV_DUMP:
//     XXXXXXXX XXXX XX`XX XXXX  AhX + f[^ + f[^ + SUM
			coms.address  = (unsigned long)RsGetChar()<<24L;
			coms.address += (unsigned long)RsGetChar()<<16L;
			coms.address += (unsigned long)RsGetChar()<<8L;
			coms.address += (unsigned long)RsGetChar();
			coms.length   = (unsigned long)RsGetChar()<<8L;
			coms.length  += (unsigned long)RsGetChar();
			if( coms.length == 0L ) {
				coms.length = 0x10000L;
			}
			if( Wrfp == NULL ) {	// ݗpt@C|C^
				if( *DataFile == 0 ) {
					printf( "݃t@C͂Ă܂\n" );
				} else {
					if( (Wrfp=fopen(DataFile,"w")) == NULL ) {
						printf( "݃t@CI[vł܂\n" );
					}
				}
			}
			for( m=0; m<(long)coms.length; m++ ) {
				if( Wrfp != NULL ) {
					// t@CɊi[
					ihex( 0, (long)(coms.address+m), (unsigned char)RsGetChar(), Wrfp );
				}
				if( (m%0x40) == 0 ) {
					printf( "%ld/%ld   \r", coms.address+m, coms.address+coms.length );
				}
			}
			RsGetChar();	/* `FbNTj */
			printf( "%lX(H)  %lX(H) ܂ł̃f[^M܂\n",
				coms.address, coms.address+coms.length );
			break;
		case	EV_DUMPEND:
			printf( "\n" );
			if( Wrfp != NULL ) {
				ihex_out( 0, Wrfp );
				ihex_end( Wrfp );
				fclose( Wrfp );	// ݗpt@C|C^
				Wrfp = NULL;
			}
			printf( "_vIʒmM܂\n" );
			break;
		case	EV_VER:
			coms.ComBuff[0] = (unsigned char)RsGetChar();
			coms.ComBuff[1] = (unsigned char)RsGetChar();
			coms.ComBuff[2] = (unsigned char)RsGetChar();
			coms.ComBuff[3] = (unsigned char)RsGetChar();
			coms.ComBuff[4] = (unsigned char)RsGetChar();
			printf( "t@[EFAo[W %d.%02d           ",
					coms.ComBuff[0]/100, coms.ComBuff[0]%100 );
			printf( "{[hʔԍ %d\n", coms.ComBuff[1] );
			printf( "ȈՌi[JnAhX %X%02X%02X\n",
				coms.ComBuff[2], coms.ComBuff[3], coms.ComBuff[4] );
			/* Version check */
			if( coms.ComBuff[0] < 130 ) {
				printf( "{[h\tg̃o[Wグĉ\n" );
				return(-1);
			}
			return(0);
		case	EV_PROG:
			coms.ComBuff[0] = (unsigned char)RsGetChar();
			if( coms.ComBuff[0] == 0 ) {
				printf( "ȈՌAbv[h\n" );
				return(0);
			}
			printf( "ȈՌAbv[hs\n" );
			return(-1);
		case	EV_EXEC:
			coms.ComBuff[0] = (unsigned char)RsGetChar();
			coms.ComBuff[1] = (unsigned char)RsGetChar();
			coms.ComBuff[2] = (unsigned char)RsGetChar();
			coms.ComBuff[3] = (unsigned char)RsGetChar();
			coms.ComBuff[4] = (unsigned char)RsGetChar();
			if( coms.ComBuff[0] == 0 ) {
				if( coms.ComBuff[1] == 0 ) {
//					printf( "ȈՌsw\n" );
				} else {
					printf( "ȈՌsws\n" );
				}
			} else if( coms.ComBuff[0] == 1 ) {
				if( coms.ComBuff[1] == 0 ) {
					printf( "ȈՌsI\n" );
					return(0);
				} else {
					printf( "ȈՌsُI\n" );
					return(-1);
				}
			} else {
				printf( "ȈՌI( %d )\n", coms.ComBuff[1] );
				return(0);
			}
			break;
		case	EV_DATA:	// f[^v
//     XX XXXX                       tO + ő]f[^
			coms.ComBuff[0] = (unsigned char)RsGetChar();
			// őMf[^̎擾
			coms.length = (unsigned int)(RsGetChar()<<8);
			coms.length += (unsigned int)(RsGetChar());
			TransmitData( (int)coms.ComBuff[0], coms.length );
			break;
		case	EV_LOAD:	// I[oCvOv
			coms.ComBuff[0] = (unsigned char)RsGetChar();
			TransmitProg( (int)coms.ComBuff[0] );
			break;
		}
	}
}

int	MainLoop()
{
	int		k;

	if( AutoExecute() != 0 ) {	/* ŏ̎s */
		return(-1);
	}

	while( 1 ) {
		DispFunc();		/* Ij[̕\ */
		while( 1 ) {
			/* L[̓`FbN */
			if( kbhit() ) {
				k = toupper( getch() );
				if( isdigit( k ) ) {
					printf( "%c\n", k );
					/* l̃[ɒēn */
					ExecuteCommand( k-'1' );
					break;
				} else if( strchr( "ABCDE", (char)k ) != NULL ) {
					/* l̃[ɒēn(A -> 9) */
					ExecuteCommand( k-'A'+10-1 );
					break;
				} else if( k == 'F' ) {	/* t@Cݒ */
					GetFileName( "FileName : ", DataFile );
					break;
				} else if( k == 'Q' ) {	/* I */
					printf( "I܂\n" );
					return(0);
				} else if( k == '\r' ) {
					break;	/* ʍĕ\ */
				}	/* ͖̓͂ */
			}
		}
	}
}

int	ExecuteCommand( int num )	/* w֐̎s */
{
	unsigned	char	buff[100];

	if( num < 0 || num >= FunctionCount ) {
		return(-1);
	}

	if( Func[num].fcheck & 0x01 ) {
		/* ǂݏot@CLmF */
		if( *DataFile == 0 ) {
			printf( "ǂݏot@Cw肳Ă܂\n" );
			return(-1);
		}
		if( access( DataFile, 0 ) != 0 ) {
			printf( "ǂݏot@C܂[ %s ]\n", DataFile );
			return(-1);
		}
	}

	if( Func[num].fcheck & 0x02 ) {
		// ݃t@CLmF
		if( *DataFile == 0 ) {
			printf( "݃t@Cw肳Ă܂\n" );
			return(-1);
		}
		if( access( DataFile, 0 ) == 0 ) {
			if( YesNo( "㏑Ă낵ł (Y/N) : " ) == 0 ) {
				return(-1);
			}
		}
	}

	if( Func[num].flg ) {
		if( YesNo( "sĂ낵ł (Y/N) : " ) == 0 ) {
			return(-1);
		}
	}

	printf( "[ %s ] s܂\n", Func[num].com );
	sprintf( (char *)buff, "+++%c%c%c%c%c%c%c%c%c", EV_EXEC,
			(unsigned char)(Func[num].adr>>16),
			(unsigned char)((Func[num].adr>>8)&0xff),
			(unsigned char)(Func[num].adr&0xff),
			(unsigned char)(ProgSum>>8),
			(unsigned char)(ProgSum&0xff), 0, 0, 0 );
	if( ComRequest( buff, 12 ) != 0 ) {
		printf( "[ %s ] ̎sُł\n", Func[num].com );
		return(-1);
	}
//	printf( "[ %s ] ̎sI܂\n", Func[num].com );
	return(0);
}

int		AutoExecute(void)	/* s֐̎s */
{
	int	j, flg;
	unsigned	char	buff[100];

	for( j=0; j<AutoRunCount; j++ ) {
		if( AutoAdr[j] == 0 ) {
			printf( "s֐܂\n" );
			return(-1);
		}
		printf( "[ %s ] s܂\n", AutoRun[j] );
		sprintf( (char *)buff, "+++%c%c%c%c%c%c%c%c%c", EV_EXEC,
			(unsigned char)(AutoAdr[j]>>16),
			(unsigned char)((AutoAdr[j]>>8)&0xff),
			(unsigned char)(AutoAdr[j]&0xff),
			(unsigned char)(ProgSum>>8),
			(unsigned char)(ProgSum&0xff), 0, 0, 0 );
		if( ComRequest( buff, 12 ) != 0 ) {
			printf( "[ %s ] ̎sُł\n", AutoRun[j] );
			return(-1);
		}
		printf( "[ %s ] ̎sI܂\n", AutoRun[j] );
	}
	printf( "\n" );
	return(0);
}

/* t@C̐VrāAȂ[Ԃ */
int	NewFile( char *oldfile, char *newfile )
{
	struct	ffblk	oldffblk, newffblk;

	if( findfirst(oldfile,&oldffblk,FA_RDONLY|FA_SYSTEM|FA_ARCH) != 0 ) {
		return(-1);
	}
	if( findfirst(newfile,&newffblk,FA_RDONLY|FA_SYSTEM|FA_ARCH) != 0 ) {
		return(-1);
	}
	if( oldffblk.ff_fdate > newffblk.ff_fdate ) {
		return(-1);
	}
	if( oldffblk.ff_fdate == newffblk.ff_fdate ) {
		if( oldffblk.ff_ftime > newffblk.ff_ftime ) {
			return(-1);
		}
	}
	return(0);
}

int		InfLoad( char *inffile )	/* xxx.inf t@C̏ǂݏo */
{
	int		status, i;
	unsigned	long	udt;
	FILE	*fp;
	char	buff[256], pr[256], dmy[256];


	if( (fp=fopen( inffile, "r" )) == NULL ) {
		sprintf( buff, "file open error [%s]\n", inffile );
		MessageList( buff );
		return(-1);
	}

	overlay_frame = 0;

	status = 0;
	while( fgets( buff, 256, fp ) != NULL ) {
		if( strnicmp( buff, "[Common]", 8 ) == 0 ) {
			status = 1;
			continue;
		} else if( strnicmp( buff, "[Function]", 10 ) == 0 ) {
			status = 2;
			continue;
		} else if( strnicmp( buff, "[Overlay]", 9 ) == 0 ) {
			status = 3;
			continue;
		}

		if( sscanf( buff, "%s %s %ld", pr, dmy, &udt ) != 3 ) {
			continue;
		}
		switch( status ) {
		case	1:	// TCY(gp)
			break;
		case	2:	// ֐AhX
			for( i=0; i<FunctionCount; i++ ) {
				if( strcmp( Func[i].func, pr ) == 0 ) {
					Func[i].adr = udt;
					break;
				}
			}
			for( i=0; i<AutoRunCount; i++ ) {
				if( strcmp( AutoRun[i], pr ) == 0 ) {
					AutoAdr[i] = udt;
					break;
				}
			}
			break;
		case	3:	// t[
			if( strnicmp( pr, "frame", 5 ) == 0 ) {
				if( !isdigit(pr[5]) || !isdigit(pr[6]) ) {
					fclose( fp );
					sprintf( buff, "file format error [%s]\n", inffile );
					MessageList( buff );
					return(-1);
				}
				i = (pr[5]-'0')*10+pr[6]-'0';
				if( stricmp( &pr[7], "length" ) == 0 ) {
					frame_length[i] = udt;
				} else {
					frame_start[i] = udt;
				}
				if( (i+1) > overlay_frame ) {
					overlay_frame = i+1;
				}
			}
			break;
		default:
			break;
		}
	}
	fclose( fp );
	return(0);
}

int	ProgLoad()
{
	int	i, mode, compile, flg;
	FILE	*fp;
	char	*p, buff[512], bf1[512], bf2[256], bf3[256];
	char	FileName[512];

	unsigned	int	length;
	long	adr, offset;
	unsigned	char	data[512];

	*InfFile = *RomFile = 0;
	if( (fp=fopen(EditFile,"r")) == NULL ) {
		sprintf( buff, "File open error [ %s ]", EditFile );
		MessageList( buff );
		return(-1);
	}

	/* et@C𐶐 */
	strcpy( FileName, EditFile );
	if( (p=strrchr(FileName,'.')) != NULL ) {
		strcpy( p, "" );
	} else {
		sprintf( buff, "File name error [ %s ]", EditFile );
		MessageList( buff );
		fclose(fp);
		return(-1);
	}
	sprintf( InfFile, "%s.inf", FileName );
	sprintf( RomFile, "%s.rom", FileName );

	compile = AsmModeDos;

	FunctionCount = 0;
	AutoRunCount = 0;
	MsgCount = 0;

	mode = 0;
	while( fgets( buff, 256, fp ) != NULL ) {
		if( (p=strrchr(buff,'\n')) != NULL ) {
			*p = 0;
		}
		if( strnicmp( buff, "[AUTORUN]", 9 ) == 0 ) {
			mode = 1;
		} else if( strnicmp( buff, "[MENU]", 6 ) == 0 ) {
			mode = 2;
		} else if( strnicmp( buff, "[MESSAGE]", 9 ) == 0 ) {
			mode = 3;
		} else if( strnicmp( buff, "[TITLE]", 7 ) == 0 ) {
			mode = 4;
		} else if( strnicmp( buff, "[COMPILE]", 9 ) == 0 ) {
			mode = 5;
		} else if( strnicmp( buff, "[CODE]", 6 ) == 0 ) {
			break;
		}
		if( *buff == '[' || !isalnum( *buff ) ) {
			continue;
		}
		if( sscanf( buff, "%s", bf1 ) != 1 ) {
			continue;
		}
		switch( mode ) {
		case	1:	/* [AUTORUN] */
			if( AutoRunCount >2 ) {
				MessageList( "s֐̓o^͂Q܂łł" );
				break;
			}
			AutoAdr[AutoRunCount] = 0;
			AutoRun[AutoRunCount] = (char *)malloc(strlen(bf1)+1);
			strcpy( AutoRun[AutoRunCount], bf1 );
			AutoRunCount++;
			break;
		case	2:	/* [MENU] */
			if( FunctionCount >= FUNCTION_MAX ) {
				MessageList( "j[̍őo^\𒴂Ă܂" );
				break;
			}
			if( (p=strchr(buff,',')) == NULL ) {
				break;
			}
			*p = ' ';
			if( (p=strchr(buff,',')) == NULL ) {
				break;
			}
			*p = ' ';
			if( (p=strchr(buff,',')) == NULL ) {
				break;
			}
			*p = 0;
			p++;	//main,1,,
			*bf3 = 0;	// bf3͎Ȃꍇ
			if( sscanf( buff, "%s %s %s", bf1, bf2, bf3 ) < 2 ) {
				break;
			}
			Func[FunctionCount].flg = 0;
			if( strcmp( bf2, "1" ) == 0 ) {
				Func[FunctionCount].flg = 1;
			}
			Func[FunctionCount].fcheck = 0;
			if( strchr( bf3, 'r' ) != NULL ) {
				Func[FunctionCount].fcheck |= 1;
			}
			if( strchr( bf3, 'w' ) != NULL ) {
				Func[FunctionCount].fcheck |= 2;
			}
			Func[FunctionCount].func = (char *)malloc(strlen(bf1)+1);
			strcpy( Func[FunctionCount].func, bf1 );
			Func[FunctionCount].com = (char *)malloc(strlen(p)+1);
			strcpy( Func[FunctionCount].com, p );
			Func[FunctionCount].adr = 0;
			FunctionCount++;
			break;
		case	3:	/* [MESSAGE] */
			if( MsgCount >= MESSAGE_MAX ) {
				MessageList( "bZ[W̍őo^\𒴂Ă܂" );
				break;
			}
			p = buff;
			while( isspace(*p) ) p++;
			while( isdigit(*p) ) p++;
//			while( isspace(*p) ) p++;
			while( *p == ' ' || *p == '\t' ) p++;
			if( sscanf( buff, "%d", &MsgData[MsgCount].num ) != 1 ) {
				MessageList( "bZ[W̃tH[}bgɈُ킪܂" );
				break;
			}
			MsgData[MsgCount].Msg = p;
			MsgCount++;
			break;
		case	4:	/* [TITLE] */
			break;
		case	5:	/* [COMPILE] */
			if( compile == 0 ) {	/* t@Cɏ] */
				if( stricmp( bf1, "on" ) == 0 ) {
					compile = 1;	/* RpC */
				}
			}
			break;
		default:
			break;
		}
	}
	fclose(fp);

	getprofilestring( InfFile, "Common", "compile", buff, "" );
	if( compile == 1 && strcmp( buff, "0" ) == 0 ) {
		unlink( InfFile );	/* t@Cčč\z */
	}
	if( compile == 2 && strcmp( buff, "1" ) == 0 ) {
		unlink( InfFile );	/* t@Cčč\z */
	}

	/* t@C̃^CX^v`FbNēK؂ȏs */
	if( NewFile( EditFile, InfFile ) != 0 || NewFile( EditFile, RomFile ) != 0 ) {
		if( compile == 1 ) {
			strcpy( buff, MakeasmCommand );
		} else {
			strcpy( buff, CompilerCommand );
		}
		while( (p=strstr(buff,"$1")) != NULL ) {
			strcpy( bf1, p+2 );
			strcpy( p, controlfile );
			strcat( p, bf1 );
		}
		while( (p=strstr(buff,"$0")) != NULL ) {
			strcpy( bf1, p+2 );
			strcpy( p, FileName );
			strcat( p, bf1 );
		}
		if( *buff == 0 ) {
			sprintf( bf1, "RpC̎sR}hw肳Ă܂" );
			MessageList( bf1 );
			return(-1);
		}
		MessageList( "compile start !" );
		if( RunChild( buff ) != 0 ) {
			return(-1);
		}

		if( compile == 1 ) {
			/* RpCꍇ */
			/* KvȂœK */
			if( Optimize ) {
				strcpy( buff, OptimizeCommand );
				while( (p=strstr(buff,"$0")) != NULL ) {
					strcpy( bf1, p+2 );
					strcpy( p, FileName );
					strcat( p, bf1 );
				}
				if( *buff == 0 ) {
					sprintf( bf1, "œK̎sR}hw肳Ă܂" );
					MessageList( bf1 );
					return(-1);
				}
				MessageList( "optimize start !" );
				if( RunChild( buff ) != 0 ) {
					return(-1);
				}
			}
			/* AZu */
			strcpy( buff, AssemblerCommand );
			while( (p=strstr(buff,"$0")) != NULL ) {
				strcpy( bf1, p+2 );
				strcpy( p, FileName );
				strcat( p, bf1 );
			}
			if( *buff == 0 ) {
				sprintf( buff, "AZu̎sR}hw肳Ă܂" );
				MessageList( buff );
				return(-1);
			}
			MessageList( "assemble start !" );
			if( RunChild( buff ) != 0 ) {
				return(-1);
			}
			/* InfFile ̃AhXXV */
			strcpy( buff, SymbolUpdateCommand );
			while( (p=strstr(buff,"$0")) != NULL ) {
				strcpy( bf1, p+2 );
				strcpy( p, FileName );
				strcat( p, bf1 );
			}
			if( *buff == 0 ) {
				sprintf( buff, "V{XVR}hw肳Ă܂" );
				MessageList( buff );
				return(-1);
			}
			MessageList( "symbol update start !" );
			if( RunChild( buff ) != 0 ) {
				return(-1);
			}
		}
	}

	/* InfFile AhXǍ */
	/* AhX̏ */
	for( i=0; i<FunctionCount; i++ ) {
		Func[i].adr = 0;
	}
	for( i=0; i<AutoRunCount; i++ ) {
		AutoAdr[i] = 0;
	}

	if( InfLoad( InfFile ) != 0 ) {	/* xxx.inf t@C̏ǂݏo */
		return(-1);
	}

	/* RomFile 烁[ɓǍ */
	if( (fp=fopen( RomFile, "r" )) == NULL ) {
		sprintf( buff, "t@CI[vł܂[ %s ]", RomFile );
		MessageList( buff );
		return(-1);
	}
	flg = 0;	/* f[^v */
	for( ;; ) {
		length = 500;	/* xɓǂݍލőf[^ */
		if( ReadData( flg, fp, &adr, data, (int *)&length ) != 0 ) {
			fclose( fp );
			sprintf( buff, "t@Cǂݍ݂ňُ킪܂[ %s ]", RomFile );
			MessageList( buff );
			return(-1);
		}
		if( length == 0 ) {
			break;
		}
		flg = 1;	/* pf[^vɕύX */
		/* ǂݍ񂾃f[^imageɊi[ */
		/* RpCt@CɃAhX̓VtgĂ */
		offset = adr;
		/* ɂłĂ64ROMC[WɊi[Ăt[Ȃ̂ */
		/* ǂݍݎɍ폜 */
		if( overlay_frame ) {
			if( (offset+length) >= (OVERLAY_MAX+64) ) {
				fclose( fp );
				sprintf( buff, "mۂĂ郁[TCY𒴂܂ [ %ld ] ( max = %d )", offset+length-64, OVERLAY_MAX );
				MessageList( buff );
				return(-1);
			}
		} else {
			if( (offset+length) >= (PROG_MAX+64) ) {
				fclose( fp );
				sprintf( buff, "mۂĂ郁[TCY𒴂܂ [ %ld ] ( max = %d )", offset+length-64, PROG_MAX );
				MessageList( buff );
				return(-1);
			}
		}
		for( i=0; i<(int)length; i++ ) {
			if( (offset+i) < 64 ) {
				continue;
			}
			image[offset+i-64] = data[i];
		}
		if( (int)(offset+length) > image_ptr ) {
			image_ptr = offset+length;
		}
	}
	image_ptr -= 64;
	fclose( fp );

	/* m̃AhX`FbN */
	for( i=0; i<FunctionCount; i++ ) {
		if( Func[i].adr == 0 ) {
			sprintf( buff, "[ %s ] not found", Func[i].func );
			MessageList( buff );
			return(-1);
		}
	}
	for( i=0; i<AutoRunCount; i++ ) {
		if( AutoAdr[i] == 0 ) {
			sprintf( buff, "[ %s ] not found", AutoRun[i] );
			MessageList( buff );
			return(-1);
		}
	}

	if( overlay_frame ) {
		for( i=0; i<overlay_frame; i++ ) {
			sprintf( buff, "frame %d   adr = %d(%XH)   length = %d", i, frame_start[i], frame_start[i], frame_length[i] );
			MessageList( buff );
		}
		sprintf( buff, "Ŝ̃vOTCY %d oCgł", image_ptr );
		MessageList( buff );
	} else {
		sprintf( buff, "vOTCY %d oCgł", image_ptr );
		MessageList( buff );
	}

	return(0);
}

int	RunChild( char *exec )
{
	return( system( exec ) );
}

int	RsOpen( long speed )
{
	/* opentty()̃^[CidƓȂ̂Ń^[l͌Ȃ */
	switch( Cid ) {
#ifdef	MSDOS
	case	0:	opentty("COM1:");	break;
	case	1:	opentty("COM2:");	break;
	case	2:	opentty("COM3:");	break;
	case	3:	opentty("COM4:");	break;
#else
	case	0:	opentty("/dev/ttyd1");	break;
	case	1:	opentty("/dev/ttyd2");	break;
#endif
	default:	return(-1);
	}
	ttyinit( Cid, speed );
	return(0);
}

void	help()
{
#ifdef	MSDOS
	printf( "> h8con [programfile.c] [-n] [-wn] [datafile]\n" );
	printf( "   -n  : -1=COM1 ` -4=COM4\n" );
	printf( "   -wn : -w0 ` -w9999 rs232c Wait\n" );
#else
	printf( "> h8con [programfile.c] [-n] [-wn] [datafile]\n" );
	printf( "   -n  : -1=/dev/ttyd1 ` -2=/dev/ttyd2\n" );
	printf( "   -wn : -w0 ` -w9999 rs232c Wait\n" );
#endif
}

int	GetVersion()
{
	char	buff[10];

	printf( "{[h̃o[W擾܂( [ ESC ] L[Œ~܂ )\n" );
	sprintf( (char *)buff, "+++%c", EV_VER );
	if( ComRequest( buff, 4 ) != 0 ) {
		printf( "{[h̃o[W擾ł܂ł\n" );
		return(-1);
	}
	printf( "\n" );
	return(0);
}

int	TransProg()
{
	int		i;
	char	buff[10];

	/* vO] */
	ProgSum = 0;
	for( i=0; i<(int)image_ptr; i++ ) {
		ProgSum += image[i];	/* `FbNŤvZ */
	}
	sprintf( (char *)buff, "+++%c%c%c", EV_PROG,
			(unsigned char)((image_ptr>>8)&0xff),
			(unsigned char)(image_ptr&0xff) );
	WriteRs232c( Cid, (char *)buff, 6 );
	image[image_ptr] = (unsigned char)((ProgSum>>8)&0xff);
	image[image_ptr+1] = (unsigned char)(ProgSum&0xff);
	WriteRs232c( Cid, (char *)image, image_ptr+2 );
	if( ComRequest( NULL, 0 ) != 0 ) {
		return(-1);
	}
	printf( "\n" );
	return(0);
}

void	Rs232cWaitSet( long RsWait )
{
	char	buff[10];

	printf( "RS232C̒ʐM҂Ԃݒ肵܂( %ld ʕb)\n", RsWait );
	sprintf( (char *)buff, "+++%c%c%c", EV_SPEED,
			(unsigned char)((RsWait>>8)&0xff),
			(unsigned char)(RsWait&0xff) );
	WriteRs232c( Cid, (char *)buff, 6 );
}

int	main( int ar, char *av[] )
{
	int		i;
	char	ans[128], *p, board;
	long	RsWait = -1;


	image = (unsigned char *)malloc(OVERLAY_MAX+256);	// ݃C[W
	if( image == NULL ) {
		printf( "malloc error\n" );
		return(1);
	}
	image_ptr = 0;
	memset( image, 0, OVERLAY_MAX+256 );

	printf( VERSION );
	*EditFile = 0;
	strcpy( DataFile, "" );
	if( access( "control.dat", 0 ) == 0 ) {
		strcpy( controlfile, "control.dat" );
	} else {
		strcpy( controlfile, av[0] );
		p = strrchr( controlfile, '\\' );
		if( p != NULL ) {
			p++;
			strcpy( p, "control.dat" );
		} else {
			p = strrchr( controlfile, '/' );
			if( p != NULL ) {
				p++;
				strcpy( p, "control.dat" );
			}
		}
	}
	/* gpCOM|[g̓ǂݏo */
	getprofilestring( controlfile, "Setting", "COM", ans, "1" );
	Cid = *ans - '1';	/* ftHg COM1(0) */
	/* o͂HEXt@CtH[}bg̓ǂݏo */
	getprofilestring( controlfile, "Setting", "HEX", ans, "2" );
	if( strcmp( ans, "1" ) == 0 ) {
		ihex_mode( 1 );
	} else if( strcmp( ans, "3" ) == 0 ) {
		ihex_mode( 3 );
	} else if( strcmp( ans, "4" ) == 0 ) {
		ihex_mode( 4 );
	} else {
		ihex_mode( 2 );
	}
	/* RS232C̃EFCglǂݏo */
	getprofilestring( controlfile, "Setting", "COMWAIT", ans, "" );
	if( *ans ) {
		RsWait = 0;
		sscanf( ans, "%ld", &RsWait );	/* RS232C WAIT */
	}

	/* compile */
	getprofilestring( CONTROL_DATA, "Setting", "CompilerDos",
			CompilerCommand, "h8cc.exe $0.c -$1" );
	getprofilestring( CONTROL_DATA, "Setting", "MakeasmDos",
			MakeasmCommand, "h8cc.exe $0.c -$1 -a" );
	getprofilestring( CONTROL_DATA, "Setting", "AssemblerDos",
			AssemblerCommand, "aasm -s -m -mh8.mac $0.asm" );
	getprofilestring( CONTROL_DATA, "Setting", "OptimizeDos",
			OptimizeCommand, "optim h8.tbl $0.asm $0.as1" );
	getprofilestring( CONTROL_DATA, "Setting", "OptimizeStatus", ans, "on" );
	if( toupper(ans[0]) == 'O' && toupper(ans[1]) == 'N' && ans[2] == 0 ) {
		Optimize = 1;
	} else {
		Optimize = 0;
	}
	getprofilestring( CONTROL_DATA, "Setting", "SymbolUpdateDos",
			SymbolUpdateCommand, "h8cc.exe $0.hex" );
	getprofilestring( CONTROL_DATA, "Setting", "AsmModeDos", ans, "0" );
	if( *ans ) {
		sscanf( ans, "%d", &AsmModeDos );
	} else {
		AsmModeDos = 0;
	}

	for( i=1; i<ar; i++ ) {
		if( strcmp( av[i], "-1" ) == 0 || strcmp( av[i], "-2" ) == 0 ||
				strcmp( av[i], "-3" ) == 0 ) {
			Cid = av[i][1]-'1';	/* COM1-3̎ʗp */
		} else if( strncmp( av[i], "-w", 2 ) == 0 || strncmp( av[i], "-W", 2 ) == 0 ) {
			RsWait = 0;
			sscanf( &av[i][2], "%ld", &RsWait );	/* RS232C WAIT */
		} else {
			if( *EditFile == 0 ) {
				strcpy( EditFile, av[i] );
			} else {
				if( *DataFile || *av[i] == '-' ) {
					help();
					return(1);
				}
				strcpy( DataFile, av[i] );
			}
		}
	}
	if( Cid == -1 ) {
		help();
		printf( "COM|[gԍw肳Ă܂\n" );
		return(1);
	}
	if( *EditFile == 0 ) {
		help();
		printf( "----------------------------------------------------------\n" );
		GetFileName( "ȈՌt@C͂ĉ : ", EditFile );
		if( *EditFile == 0 ) {
			return(1);
		}
	}
	if( access( EditFile, 0 ) != 0 ) {
		help();
		printf( "t@C܂ [%s]\n", EditFile );
		return(1);
	}

	if( RsOpen( 38400L ) != 0 ) {
		printf( "COM%dI[vł܂ł\n", Cid+1 );
		return(1);
	}

	if( RsWait != -1 ) {
		Rs232cWaitSet( RsWait );
	}

	if( GetVersion() != 0 ) {	/* o[WƎʔԍ擾 */
		closetty( Cid );
		return(1);
	}

	if( ProgLoad() != 0 ) {	/* vOǂݍ */
		closetty( Cid );
		return(1);
	}
	printf( "\n" );

	if( TransProg() != 0 ) {	/* vO] */
		closetty( Cid );
		return(1);
	}

	/* Cj[Ɉڂ */
	MainLoop();
	closetty( Cid );
	return(0);
}
