/*
Sp̋ʂȂɊȒPȕf[^x[X@\񋟂B
t@C̃ZNVŎf[^Ao^肷B

̐ݒ
setprofilestring(filename,[section],search-string,setting-data);

̎o
Ȃf[^Ȃdefaults̕Ԃ
getprofilestring(filename,[section],search-string,read-buffer,defaults:string);
*/

#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	"profile.h"

static	int filecopy( FILE *fp, FILE *tp, char *name );


static	int	upperlowercmp( char *str1, char *str2 )
{
	while( *str1 || *str2 ) {
		if( toupper(*str1) != toupper(*str2) ) {
			return(-1);
		}
		str1++;
		str2++;
	}
	return(0);
}

static	int	upperlowerncmp( char *str1, char *str2, int len )
{
	int		n;

	for( n=0; n<len; n++ ) {
		if( toupper(*str1) != toupper(*str2) ) {
			return(-1);
		}
		if( *str1 == 0 && *str2 == 0 ) {
			break;
		}
		str1++;
		str2++;
	}
	return(0);
}

int		getprofilestring( char *name, char *sec, char *str, char *ans, char *def )
/* t@C   ZNV      ʊi[GA   ftHǧ */
{
	FILE	*fp;
	char	bf[256], *p;
	int		len;

	strcpy( ans, def );
	if( (fp=fopen(name,"r")) == NULL ) {
		return(0);
	}
	while( fgets( bf, 256, fp ) != NULL ) {
		if( *bf != '[' ) {
			continue;
		}
		if( (p=strchr( bf, ']' )) == NULL ) {
			continue;
		}
		*p = 0;
		if( upperlowercmp( bf+1, sec ) != 0 ) {
			continue;
		}
		len = strlen(str);
		while( fgets( bf, 256, fp ) != NULL ) {
			if( *bf == '[' ) {
				fclose( fp );
				return( 0 );
			}
			if( upperlowerncmp( bf, str, len ) != 0 ) {
				continue;
			}
			p = bf+len;
			while( *p == ' ' || *p == '\t' )	p++;
			if( *p != '=' ) {
				continue;
			}
			p++;
			if( strrchr( p, '\n' ) != NULL ) {
				*strrchr( p, '\n' ) = 0;
			}
			while( *p == ' ' || *p == '\t' )	p++;
			strcpy( ans, p );
			fclose( fp );
			return( 0 );
		}
	}
	fclose( fp );
	return( 0 );
}

int		getprofiles( char *name, char *sec, char *ans )
/* t@C   ZNV   ʊi[GA */
{
	static	FILE	*fp = NULL;
	char	bf[256], *p;
	int		init_flg;

	init_flg = 0;
	if( strcmp( ans, "start" ) == 0 ) {
		if( fp != NULL ) {
			fclose( fp );
		}
		if( (fp=fopen( name, "r" )) == NULL ) {
			return( -1 );
		}
		init_flg = 1;
	}
	if( strcmp( ans, "end" ) == 0 ) {
		if( fp != NULL ) {
			fclose( fp );
			fp = NULL;
		}
		return( 0 );
	}
	*ans = 0;
	if( fp == NULL ) {
		return( -1 );
	}
	if( init_flg == 1 ) {
		init_flg = 0;
		while( fgets( bf, 256, fp ) != NULL ) {
			if( *bf != '[' ) {
				continue;
			}
			if( (p=strchr( bf, ']' )) == NULL ) {
				continue;
			}
			*p = 0;
			if( upperlowercmp( bf+1, sec ) != 0 ) {
				continue;
			}
			init_flg = 1;
			break;
		}
		if( init_flg == 0 ) {
			fclose( fp );
			fp = NULL;
			return( -1 );
		}
//		init_flg = 0;
	}
	while( fgets( bf, 256, fp ) != NULL ) {
		if( *bf == '[' ) {
			return( -1 );
		}
		if( strchr( bf, '=' ) == NULL ) {
			continue;
		}
		*strchr( bf, '=' ) = ' ';
		if( strrchr( bf, '\n' ) != NULL ) {
			*strrchr( bf, '\n' ) = 0;
		}
		strcpy( ans, bf );
		return( 0 );
	}
	return( -1 );
}

int		setprofilestring( char *name, char *sec, char *str, char *ans )
/* t@C   ZNV      ݒ肷e */
{
	FILE	*fp, *tp;
	char	bf[256], *p;
	int		len;

	if( (fp=fopen(name,"r")) == NULL ) {
		if( (fp=fopen(name,"w")) == NULL ) {
			return(-1);
		}
		/* ݒ肷ZNV͖o^̂ߐVKo^ */
		fprintf( fp, "\n[%s]\n", sec );
		fprintf( fp, "%s=%s\n", str, ans );
		fclose( fp );
		return( 0 );
	}
	if( (tp=(FILE *)tmpfile()) == NULL ) {
		fclose( fp );
		return(-1);
	}
	while( fgets( bf, 256, fp ) != NULL ) {
		fprintf( tp, bf );
		if( *bf != '[' ) {
			continue;
		}
		if( (p=strchr( bf, ']' )) == NULL ) {
			continue;
		}
		*p = 0;
		if( upperlowercmp( bf+1, sec ) != 0 ) {
			continue;
		}
		/* ݒ肷ZNV𔭌 */
		len = strlen(str);
		while( fgets( bf, 256, fp ) != NULL ) {
/*			if( *bf == '\n' || *bf == '[' ) {	*/
			/* s͔肩珜O */
			if( *bf == '[' ) {
				/* ݖo^Ȃ̂Œǉo^ */
				fprintf( tp, "%s=%s\n", str, ans );
				fprintf( tp, bf );
				/* c̓eSăRs[Ċ */
				return( filecopy( fp, tp, name ) );
			}
			if( upperlowerncmp( bf, str, len ) != 0 ) {
				fprintf( tp, bf );
				continue;
			}
			fprintf( tp, str );
			p = bf+len;
			while( *p == ' ' || *p == '\t' ) {
				fprintf( tp, "%c", *p );
				p++;
			}
			if( *p != '=' ) {
				fprintf( tp, p );
				continue;
			}
			fprintf( tp, "=" );
			p++;
			while( *p == ' ' || *p == '\t' ) {
				fprintf( tp, "%c", *p );
				p++;
			}
			if( strrchr( p, '\n' ) != NULL ) {
				*strrchr( p, '\n' ) = 0;
			}
			/* ݒ肷鍀ڂ𔭌 */
			fprintf( tp, "%s\n", ans );
			/* c̓eSăRs[Ċ */
			return( filecopy( fp, tp, name ) );
		}
		/* ݖo^Ȃ̂Œǉo^ */
		fprintf( tp, "%s=%s\n", str, ans );
		/* c̓eSăRs[Ċ */
		return( filecopy( fp, tp, name ) );
	}
	/* ݒ肷ZNV͖o^̂ߐVKo^ */
	fprintf( tp, "\n[%s]\n", sec );
	fprintf( tp, "%s=%s\n", str, ans );
	/* c̓eSăRs[Ċ */
	return( filecopy( fp, tp, name ) );
}

int		setprofiles( char *name, char *sec, char *ans )
/* t@C   ZNV   ݒ肷e */
{
	static  FILE	*fp = NULL, *tp = NULL;
	char	bf[256], *p;
    int flg;

	if( strcmp( ans, "start" ) == 0 ) {
		if( fp != NULL ) {
			fclose( fp );
		}
		if( (fp=fopen( name, "r" )) == NULL ) {
			return( -1 );
		}
    	if( (tp=(FILE *)tmpfile()) == NULL ) {
    		fclose( fp );
            fp = NULL;
    		return(-1);
    	}
        flg = 0;
    	while( fgets( bf, 256, fp ) != NULL ) {
    		fprintf( tp, bf );
    		if( *bf != '[' ) {
    			continue;
    		}
    		if( (p=strchr( bf, ']' )) == NULL ) {
    			continue;
    		}
    		*p = 0;
    		if( upperlowercmp( bf+1, sec ) != 0 ) {
    			continue;
    		}
            flg = 1;
            break;
        }
        if( flg == 0 ) {
        	fprintf( tp, "[%s]\n", sec );
        }
        return( 0 );
	}
	if( strcmp( ans, "end" ) == 0 ) {
		if( fp != NULL ) {
        	while( fgets( bf, 256, fp ) != NULL ) {
        		if( *bf == '[' ) {
            		fprintf( tp, bf );
    	    		break;
    		    }
            }
			/* c̓eSăRs[Ċ */
			return( filecopy( fp, tp, name ) );
		}
		return( 0 );
	}
	fprintf( tp, "%s\n", ans );
	return( 0 );
}

static	int		filecopy( FILE *fp, FILE *tp, char *name )
{
	int		dt;

	/* c̓eSăRs[Ċ */
	while( (dt=fgetc(fp)) != -1 ) {
		fprintf( tp, "%c", dt );
	}
	fclose( fp );
	rewind( tp );
	if( (fp=fopen(name,"w")) == NULL ) {
		fclose( tp );
		return(-1);
	}
	while( (dt=fgetc(tp)) != -1 ) {
		fprintf( fp, "%c", dt );
	}
	fclose( fp );
	fclose( tp );
	return(0);
}
