#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	<malloc.h>
#include	"control.h"

#ifndef SYM_REPLACE
#define	SYM_REPLACE	0
#endif
#include	"sym.h"
#include	"sym2.h"
#include	"hash.h"
#include	"hex.h"
#include	"syscall.h"	/* compile */

#define	TITLE	"ȈCRpC Ver.1.00 Copyright (C) 2001 T.Sagae\n"

#define	MATH_OFFSET		(MATH_START-M_START)

int		SymRc;
unsigned	long	Code;		/* GetSym()ɐlŎꂽ̒l */
char	Sym[1024], Sym2[1024];	/* GetSym()̕񓙊i[p */
char	Temp[512], Temp2[512];
char	ErrMsg1[80], ErrMsg2[80];/* G[bZ[W\p */
FILE	*Rfp;					/* ǂݍݗpt@C|C^ */
int		Pass;
int		GlobalStatus;
char	OutputPort[3];	/* |[g`o͂ǂ̃`FbNp */
int		PortCounter;
int		BoardNum = 0;		/* n[hEFA{[hԍ */

#define	LOOP_NEST_MAX	50
int		LoopCounter;
int		LoopNest;
int		LoopNestCounter[LOOP_NEST_MAX];		/* break/continue p */

/* ϊrSĂŃI[o[t[`FbN킯ł͂Ȃ̂+256Ă */
/* PROG_MAX -> OVERLAY_MAX ɕύX*/
#ifdef	MALLOC
unsigned	char	*image;	/* ݃C[W */
#else
unsigned	char	image[OVERLAY_MAX+256];	/* ݃C[W */
#endif
int	image_ptr;
int	code_start;
/* overlayΉ */
/* I[oCt[ */
long	frame_start[16];	/* t[f[^̊i[JnAhX */
long	frame_length[16];	/* t[f[^ */
int		overlay_frame = 0;
int		overlay_frame_count = 0;

#define	PC_MAX	100						/* ͎X^bN̍ő */
int		Pc;								/* t|[h͌ʐ */
unsigned	char	*Pp[PC_MAX];		/* t|[h͗p */
unsigned	char	Pd[PC_MAX][100];	/* L̎̊i[GA */

int		func_ptr;
char	func_name[FUNC_MAX][50];
unsigned	long	func_adr[FUNC_MAX];

int		ReplaceFlg = 1;		/* #define̒utO */

/* compile */
char	*Reg[] = { "R2","R3","R4","R5","E2","E3" };

/********************************************************************/
/* compile */
static	FILE	*Wfp1 = NULL, *Wfp2 = NULL;			/* RpCʏop */
static	int		MsgCount = 0;
/********************************************************************/

int	do_asm(void);
int	do_if(void);
int	do_while(void);
int	do_do(void);
int	do_goto(void);
int	do_break(void);
int	do_continue(void);
int	do_statement3(int);
int	output_function(int);
unsigned	char	adr2port(unsigned int);
int	do_statement2(void);
int	do_statement(void);
void	SetFunc(char *,int,char *);
extern  int	GetSym( unsigned char *sym, unsigned long *code );
extern  int pinno2port(int pin);
extern  int pol_init(void);
extern  int pol(char **dat, int cnt);
extern  int DAC(int board,int side,char *dt);
extern  int deffileload(char *name);
extern  unsigned    long GetLineNumber(void);
extern  char    *GetLineBuff(void);

extern	void	SetLineNumber( unsigned long num );
extern	unsigned	long	GetLineNumber( void );
extern	void	SetSymFp( FILE *fp );
extern	int	SetSymData( unsigned char *data );
extern	int	GetSym( unsigned char *sym, unsigned long *code );

/* overlay ֘Aϐ(C^[v^) */
int	real_high;
int	real_low;

/* overlay ֘Aϐ(RpC) */
#define	MAX_UPDATE_COUNT	500
long	update_adrs[MAX_UPDATE_COUNT];
int		update_counter = 0;

/* AhXt[ΉAhX߂ */
int	get_real_adrs_asm(long adr)
{
	int		ad, frame;

	for( frame=0; frame<overlay_frame; frame++ ) {
		if( adr < (frame_start[frame]+frame_length[frame]) ) {
			break;
		}
	}
	/* AhXɕϊ */
	if( frame == 0 ) {
		/* ̂܂܂ŎAhX */
		return( adr );
	}
	ad = (frame<<20) + adr - (frame_start[frame] -frame_start[1]);
	return( ad );
}

/* tbgȃAhXt[ƎAhXɕϊ */
int	get_real_adrs(int adr)
{
	int		ad, frame;

	if( Pass == 1 ) {
		real_high = adr>>8;
		real_low = adr&0xff;
		return( adr );
	}
	for( frame=0; frame<overlay_frame; frame++ ) {
		if( adr < (frame_start[frame]+frame_length[frame]) ) {
			break;
		}
	}
	/* AhXɕϊ */
	if( frame == 0 ) {
		/* ̂܂܂ŎAhX */
		real_high = adr>>8;
		real_low = adr&0xff;
		return( adr );
	}
	ad = (frame<<12) + adr - frame_start[frame] + frame_length[0];
	real_high = ad>>8;
	real_low = ad&0xff;
	return( ad );
}

int	do_asm(void)	/* AZu[`o */
{
	char	buff[256];

	if( Wfp1 == NULL ) {
sprintf( ErrMsg1, "#asm ̓C^v^Ŏg͂ł܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	/* s܂Ői߂ */
	SetSymFp( Rfp );
	/* #endasm ܂œeo͂ */
	while( fgets( buff, 256, Rfp ) != NULL ) {
		if( strncmp( buff, "#endasm", 7 ) == 0 ) {
			/* s܂Ői߂ */
			SetSymFp( Rfp );
			SymRc = GetSym( (unsigned char *)Sym, &Code );
			return(0);
		}
		if( Pass == 2 && Wfp1 != NULL ) {
			fprintf( Wfp2, buff );
		}
	}
sprintf( ErrMsg1, "#endasm ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
	return(-1);
}

/* define`Ăeu */
int	devicec_replace( char *data )
{
	char	temp[256];

	if( ReplaceFlg == 0 ) {	/* #define̒utO */
		return(-1);
	}
	if( SearchHashData( data, (unsigned char *)temp ) != ID_DEFINE ) {
		return( -1 );
	}
//printf( "define [%s] -> [%s]\n", data, &temp[1] );
	strcpy( data, &temp[1] );
	return( temp[0] );
}

int	getbit( char *data )
{
	int	bit;

	for( ;; ) {
		if( *data == 0 ) {
			return(-1);
		}
		if( isdigit(*data) ) {
			if( isdigit( *(data+1) ) ) {
				bit = ((*data)-'0')*10 + (*(data+1)-'0');
				data+=2;
			} else {
				bit = (*data)-'0';
				data++;
			}
			if( *data == 0 || *data == '.' ) {
				return(bit);
			}
		}
		data++;
	}
}

int	getbit2( char *data )	/* Pxx`p */
{
	int	H, L;

	if( isdigit(*data) ) {
		if( !isdigit( *(data+1) ) ) {
			return(-1);
		}
		H = (*data)-'0';
		L = (*(data+1))-'0';
		if( H < 1 || H == 7 || H == 9 || L > 7 ) {
			return(-1);
		}
		if( H == 8 ) {
			H-=2;
		} else {
			H--;
		}
		return( (H<<3) + L );
	}
	if( strchr( "AB", toupper(*data) ) != NULL ) {
		if( !isdigit( *(data+1) ) ) {
			return(-1);
		}
		H = (toupper(*data))-'A'+10-3;
		L = (*(data+1))-'0';
		if( L > 7 ) {
			return(-1);
		}
		return( (H<<3) + L );
	}
	return(-1);
}

/* rbgw̕ϐƃAhX|[gwf[^ɕϊďo */
int	get_bit_data( char *name, unsigned int adr )
{
	int 	bit, ptr;

	bit = getbit( name );
	if( bit == -1 ) {
sprintf( ErrMsg1, "rbgԍԈĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( adr < (Port1Adr+20) ) {
		ptr = Port1Adr;
	} else if( adr < (Port2Adr+20) ) {
		ptr = Port2Adr;
	} else if( adr < (Port3Adr+20) ) {
		ptr = Port3Adr;
	} else {
sprintf( ErrMsg1, "|[gwɊԈႢ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	adr = image[ptr + 4 + 15 - bit];
	if( strstr( name, ".dir" ) != NULL ) {
		/* f[^w */
		return( adr+80 );
	} else {
		/* f[^w */
		return( adr );
	}
}

int	output_sub( int type, unsigned int adr )
{
	switch( type ) {
	case	M_CHAR:
		image[image_ptr++] = CONST1;
		image[image_ptr++] = (unsigned char)adr;
		break;
	case	M_INT:
		image[image_ptr++] = CONST2;
		image[image_ptr++] = (unsigned char)((adr>>8)&0xff);
		image[image_ptr++] = (unsigned char)(adr&0xff);
		break;
	case	S_BOOL:
	case	S_BOOLD:	/* |[gf[^̒ڎw */
		image[image_ptr++] = (unsigned char)adr;
		break;
	case	S_BYTE:
		image[image_ptr++] = VAL1;
		image[image_ptr++] = (unsigned char)((adr>>8)&0xff);
		image[image_ptr++] = (unsigned char)(adr&0xff);
		break;
	case	S_WORD:
		switch( adr ) {
		case	Port1Adr:	image[image_ptr++] = A_DT;	break;
		case	Port2Adr:	image[image_ptr++] = B_DT;	break;
		case	Port3Adr:	image[image_ptr++] = C_DT;	break;
		case	Port1Adr+2:	image[image_ptr++] = A_DIR;	break;
		case	Port2Adr+2:	image[image_ptr++] = B_DIR;	break;
		case	Port3Adr+2:	image[image_ptr++] = C_DIR;	break;
		default:
			image[image_ptr++] = VAL2;
			image[image_ptr++] = (unsigned char)((adr>>8)&0xff);
			image[image_ptr++] = (unsigned char)(adr&0xff);
			break;
		}
		break;
	default:
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	return(0);
}

int	calc_output_sub(int rc, char *val, unsigned int adr)
{
	int		adr_m;
	char	*p;
	unsigned	char	port_id;

	switch( rc ) {
	case	S_BOOL:
		/* rbgw̕ϐƃAhX|[gwf[^ɕϊďo */
		if( (adr_m=get_bit_data( val, adr )) == -1 ) {
			return(-1);
		}
		adr = (unsigned int)adr_m;
		if( (adr >= 80 && adr < 160) ||
				adr == A_DIR || adr == B_DIR || adr == C_DIR ) {
sprintf( ErrMsg1, "o͕w|[g̓ǂݏo͂ł܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}

		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			fprintf( Wfp2, ";S_BOOL line=%d\n", __LINE__ );
			fprintf( Wfp2, "\tMOV.B\t#H'%X,R0L\n\tJSR\t@fGetData:24\n\tPUSH.W\tR0\n", adr );
		}

		if( output_sub( rc, adr ) == -1 ) {
			return(-1);
		}
		break;
	case	S_BOOLD:
		if( (adr >= 80 && adr < 160) ||
				adr == A_DIR || adr == B_DIR || adr == C_DIR ) {
sprintf( ErrMsg1, "o͕w|[g̓ǂݏo͂ł܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}

		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			fprintf( Wfp2, ";S_BOOLD line=%d\n", __LINE__ );
			fprintf( Wfp2, "\tMOV.B\t#H'%X,R0L\n\tJSR\t@fGetData:24\n\tPUSH.W\tR0\n", adr );
		}

		if( output_sub( rc, adr ) == -1 ) {
			return(-1);
		}
		break;
	case	M_INT:
		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			p = strstr( val, "," );
			if( p != NULL ) {
				/* zϐ */
				/* Sym , SymRc XXX 0x00 */
				*p = 0;
				fprintf( Wfp2, ";S_BYTE line=%d\n", __LINE__ );
				/* SymRc ͖Č */

				/* 2001/06 A = B[l] `ŏC */
				if( isdigit( *(p+2) ) ) {
					/* A = B[l] `̏ꍇ */
					sscanf( p+2, "%u", &adr );
					fprintf( Wfp2, "\tMOV.W\t#H'%X,R0\n", adr );
				} else {
					rc = SearchHashData( p+2, (unsigned char *)Temp );
					sscanf( Temp, "%u", &adr );
					switch( rc ) {
					case	S_BOOL:
						if( calc_output_sub( rc, p+2, adr ) != 0 ) {
							return(-1);
						}
						break;
					case	S_BOOLD:	/* |[gf[^̒ڎw */
						if( calc_output_sub( rc, "", adr ) != 0 ) {
							return(-1);
						}
						break;
					case	S_BYTE:
						if( calc_output_sub( rc, p+2, adr ) != 0 ) {
							return(-1);
						}
						break;
					case	S_WORD:
						if( calc_output_sub( rc, p+2, adr ) != 0 ) {
							return(-1);
						}
						break;
					case	ID_INFUNC:
						break;
					default:
						return(-1);
					}
					fprintf( Wfp2, "\tPOP.W\tR0\n" );
				}

				fprintf( Wfp2, "\tXOR.W\tE0,E0\n" );
				fprintf( Wfp2, "\tMOV.L\t#_%s:32,ER1\n", val );
				fprintf( Wfp2, "\tADD.L\tER0,ER1\n" );
				/* wAhX̓eR0Lɓǂݍpush */
				fprintf( Wfp2, "\tMOV.B\t@ER1,R0L\n" );
				fprintf( Wfp2, "\tXOR.B\tR0H,R0H\n" );
				fprintf( Wfp2, "\tPUSH.W\tR0\n" );
				*p = ',';
			} else {
				fprintf( Wfp2, ";S_INT line=%d\n", __LINE__ );
				fprintf( Wfp2, "\tMOV.W\t#H'%X,R0\n\tPUSH.W\tR0\n", adr );
			}
		}
		if( output_sub( rc, adr ) == -1 ) {
			return(-1);
		}
		break;
	case	S_BYTE:
		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			p = strstr( val, "," );
			if( p != NULL ) {
				/* zϐ */
				/* Sym , SymRc XXX 0x00 */
				*p = 0;
				fprintf( Wfp2, ";S_BYTE line=%d\n", __LINE__ );
				/* SymRc ͖Č */
				rc = SearchHashData( p+2, (unsigned char *)Temp );
				sscanf( Temp, "%u", &adr );
				switch( rc ) {
				case	S_BOOL:
					if( calc_output_sub( rc, p+2, adr ) != 0 ) {
						return(-1);
					}
					break;
				case	S_BOOLD:	/* |[gf[^̒ڎw */
					if( calc_output_sub( rc, "", adr ) != 0 ) {
						return(-1);
					}
					break;
				case	S_BYTE:
					if( calc_output_sub( rc, p+2, adr ) != 0 ) {
						return(-1);
					}
					break;
				case	S_WORD:
					if( calc_output_sub( rc, p+2, adr ) != 0 ) {
						return(-1);
					}
					break;
				case	ID_INFUNC:
					break;
				default:
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				fprintf( Wfp2, "\tPOP.W\tR0\n" );
				fprintf( Wfp2, "\tXOR.W\tE0,E0\n" );
				fprintf( Wfp2, "\tMOV.L\t#_%s:32,ER1\n", val );
				fprintf( Wfp2, "\tADD.L\tER0,ER1\n" );
				/* wAhX̓eR0Lɓǂݍpush */
				fprintf( Wfp2, "\tMOV.B\t@ER1,R0L\n" );
				fprintf( Wfp2, "\tXOR.B\tR0H,R0H\n" );
				fprintf( Wfp2, "\tPUSH.W\tR0\n" );
				*p = ',';
			} else {
				fprintf( Wfp2, "\tMOV.B\t@_%s,R0L\n", val );
				fprintf( Wfp2, "\tXOR.B\tR0H,R0H\n" );
				fprintf( Wfp2, "\tPUSH.W\tR0\n" );
			}
		}
		if( output_sub( rc, adr ) == -1 ) {
			return(-1);
		}
		break;
	case	S_WORD:
		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			p = strstr( val, "," );
			if( p != NULL ) {
				/* zϐ */
				/* Sym , SymRc XXX 0x00 */
				*p = 0;
				fprintf( Wfp2, ";ARRAY line=%d\n", __LINE__ );
				/* SymRc ͖Č */
				rc = SearchHashData( p+2, (unsigned char *)Temp );
				sscanf( Temp, "%u", &adr );
				switch( rc ) {
				case	S_BOOL:
					if( calc_output_sub( rc, p+2, adr ) != 0 ) {
						return(-1);
					}
					break;
				case	S_BOOLD:	/* |[gf[^̒ڎw */
					if( calc_output_sub( rc, "", adr ) != 0 ) {
						return(-1);
					}
					break;
				case	S_BYTE:
					if( calc_output_sub( rc, p+2, adr ) != 0 ) {
						return(-1);
					}
					break;
				case	S_WORD:
					if( calc_output_sub( rc, p+2, adr ) != 0 ) {
						return(-1);
					}
					break;
				case	ID_INFUNC:
					break;
				default:
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				fprintf( Wfp2, "\tPOP.W\tR0\n" );
				fprintf( Wfp2, "\tXOR.W\tE0,E0\n" );
				fprintf( Wfp2, "\tMOV.L\t#_%s:32,ER1\n", val );
				fprintf( Wfp2, "\tADD.L\tER0,ER1\n" );
				/* wAhX̓eR0Lɓǂݍpush */
				fprintf( Wfp2, "\tMOV.B\t@ER1,R0L\n" );
				fprintf( Wfp2, "\tXOR.B\tR0H,R0H\n" );
				fprintf( Wfp2, "\tPUSH.W\tR0\n" );
				*p = ',';
			} else {
				port_id = adr2port( adr );
				fprintf( Wfp2, ";S_WORD line=%d\n", __LINE__ );
				if( port_id != 0 ) {
					fprintf( Wfp2, "\tMOV.B\t#H'%X,R0L\n", port_id );
					fprintf( Wfp2, "\tJSR\t@fGetData:24\n" );
				} else {
					fprintf( Wfp2, "\tMOV.W\t@_%s,R0\n", val );
				}
				fprintf( Wfp2, "\tPUSH.W\tR0\n" );
			}
		}

		if( output_sub( rc, adr ) == -1 ) {
			return(-1);
		}
		break;
	default:
sprintf( ErrMsg2, "line %d", __LINE__ );
printf( "rc = %d\n", rc );
		return(-1);
	}
	return(0);
}

/* vZo͂ */
int	calc_output(void)
{
	int		i, rc, type, cnt;
	unsigned	int	adr;
	unsigned	char	funcnum;
	char	*p, *p2, *pn;
	unsigned	char	port_id;

	/* vZ̏o */
	for( i=0; i<Pc; i++ ) {
		if( Pp[i][0] > M_START && Pp[i][0] < M_END ) {

			/* compile */
			if( Pass == 2 && Wfp1 != NULL ) {
				switch( Pp[i][0] ) {
				case	M_BITREV:	/*  ~   */
					fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
					fprintf( Wfp2, "\tNOT.W\tR0\n" );
					fprintf( Wfp2, "\tPUSH.W\tR0\n" );
					break;
				case	M_NOT:		/*  !   */
					fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
					fprintf( Wfp2, "\tJSR\t@H8_M_NOT:24\n" );
					fprintf( Wfp2, "\tPUSH.W\tR0\n" );
					break;
				case	M_PLUS:		/*  +   */
				case	M_MINUS:	/*  -   */
				case	M_SLASH:	/*  /   */
				case	M_TIMES:	/*  *   */
				case	M_MOD:		/*  %   */
				case	M_NEQ:		/*  !=  */
				case	M_GEQ:		/*  >=  */
				case	M_GTR:		/*  >   */
				case	M_LEQ:		/*  <=  */
				case	M_LSS:		/*  <   */
				case	M_CMP:		/*  ==  */
				case	M_SHIFTL:	/*  <<  */
				case	M_SHIFTR:	/*  >>  */
				case	M_AND:		/*  &&  */
				case	M_BITAND:	/*  &   */
				case	M_OR:		/*  ||  */
				case	M_BITOR:	/*  |   */
					/* f[^̕ۑ */
					/* pop A */
					/* pop B */
					/* ans = B / A */
					switch( Pp[i][0] ) {
					case	M_PLUS:
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tADD.W\tR1,R0\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_MINUS:
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tSUB.W\tR1,R0\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_SLASH:
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tXOR.W\tE0,E0\n" );
						fprintf( Wfp2, "\tDIVXS.W\tR1,ER0\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_TIMES:
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tMULXU.W\tR1,ER0\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_MOD:
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tJSR\t@H8_M_MOD:24\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_NEQ:
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tJSR\t@H8_M_NEQ:24\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_GEQ:
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tJSR\t@H8_M_GEQ:24\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_GTR:
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tJSR\t@H8_M_GTR:24\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_LEQ:
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* Qڂ̃f[^擾 */
						/* R0,R1M_GEQƋtɂē[`R[ */
						fprintf( Wfp2, "\tJSR\t@H8_M_GEQ:24\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_LSS:
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* Qڂ̃f[^擾 */
						/* R0,R1M_GTRƋtɂē[`R[ */
						fprintf( Wfp2, "\tJSR\t@H8_M_GTR:24\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_CMP:
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tJSR\t@H8_M_CMP:24\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_SHIFTL:
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tJSR\t@H8_M_SHIFTL:24\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_SHIFTR:
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tJSR\t@H8_M_SHIFTR:24\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_AND:
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tMULXU.W\tR1,ER0\n" );
						fprintf( Wfp2, "\tOR.W\tE0,R0\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_BITAND:
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tAND.W\tR1,R0\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					case	M_OR:
						/* M_BITORƓŖ薳 */
					case	M_BITOR:
						fprintf( Wfp2, "\tPOP.W\tR0\n" );	/* f[^P擾 */
						fprintf( Wfp2, "\tPOP.W\tR1\n" );	/* Qڂ̃f[^擾 */
						fprintf( Wfp2, "\tOR.W\tR1,R0\n" );
						fprintf( Wfp2, "\tPUSH.W\tR0\n" );
						break;
					}
					break;
				default:
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
			}

			/* Zq͔ԍ̌nVtgĊi[ */
			image[image_ptr++] = (unsigned char)(Pp[i][0]-M_START+MATH_START);
		} else if( Pp[i][0] > M_NUM_START && Pp[i][0] < M_NUM_END ) {
			/* 萔 */
			sscanf( (char *)&Pp[i][1], "%u", (int *)&adr );
			switch( Pp[i][0] ) {
			case	M_CHAR:
			case	M_INT:

				/* compile */
				if( Pass == 2 && Wfp1 != NULL ) {
					fprintf( Wfp2, ";M_CHAR/M_INT line=%d\n", __LINE__ );
					fprintf( Wfp2, "\tMOV.W\t#H'%X,R0\n", adr );
					fprintf( Wfp2, "\tPUSH.W\tR0\n" );
				}

				if( output_sub( Pp[i][0], adr ) == -1 ) {
					return(-1);
				}
				break;
			default:
sprintf( ErrMsg1, "͈͊O̒萔ł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
		} else if( Pp[i][0] == S_STR ) {
			/* ϐ */
			switch( Pp[i][1] ) {
			case	ID_INFUNC:
				/* ֐𔲂o */
				strcpy( (char *)Temp2, (char *)&Pp[i][2] );
				if( (p2=strchr( Temp2, ',' )) != NULL ) {
					*p2 = 0;
					p2++;	/* p2̓p[^wĂ */
				}
				/* p[^̏ڍׂ𒊏o */
				if( SearchHashData( Temp2, (unsigned char *)Temp ) == -1 ) {
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				p = Temp;
				funcnum = 0;
				while( isdigit( *p ) ) {
					funcnum = (unsigned char)(funcnum*10 + (*p-'0'));
					p++;
				}
				if( funcnum < 1 ) {
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				if( *p == ' ' ) {
sprintf( ErrMsg1, "^[lĂȂ֐gpĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				p++;
				image[image_ptr++] = CALLIN;
				image[image_ptr++] = funcnum;
				/* p[^̃`FbNƏo */
				cnt = 0;
				while( *p ) {
					/* p[^[v */
					if( p2 == NULL ) {
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					type = *p2;	/* p2̓p[^wĂ */
					p2++;
					pn = p2;	/* ϐ̓e */
					p2 = strchr( pn, ',' );
					if( p2 != NULL ) {
						*p2 = 0;
						p2++;
					}
					if( toupper(*p) == 'P' && type != S_STR ) {
sprintf( ErrMsg1, "p[^ԈĂ܂([hϐK{)" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					if( toupper(*p) == 'A' && type != S_STR ) {
sprintf( ErrMsg1, "p[^ԈĂ܂(zϐK{)" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					switch( type ) {
					case	M_CHAR:
					case	M_INT:
						sscanf( pn, "%u", &adr );
						if( output_sub( type, adr ) == -1 ) {
							return(-1);
						}
						/* compile */
						if( Pass == 2 && Wfp1 != NULL ) {
							fprintf( Wfp2, ";M_CHAR/M_INT line=%d\n", __LINE__ );
							fprintf( Wfp2, "\tMOV.W\t#H'%X,%s\n", (unsigned int)adr, Reg[cnt] );
						}
						break;
					case	S_STR:
						rc = SearchHashData( pn, (unsigned char *)Temp );
						if( toupper(*p) == 'P' && rc != S_WORD ) {
sprintf( ErrMsg1, "p[^ԈĂ܂([hϐK{)" );
sprintf( ErrMsg2, "line %d", __LINE__ );
							return(-1);
						}
						if( toupper(*p) == 'A' && rc != ID_ARRAY ) {
sprintf( ErrMsg1, "p[^ԈĂ܂(zϐK{)" );
sprintf( ErrMsg2, "line %d", __LINE__ );
							return(-1);
						}
						switch( rc ) {
						case	S_BYTE:
							sscanf( Temp, "%u", &adr );
							if( output_sub( rc, adr ) == -1 ) {
								return(-1);
							}
							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								fprintf( Wfp2, ";S_BYTE line=%d\n", __LINE__ );
								fprintf( Wfp2, "\tMOV.B\t@_%s,%sL\n", pn, Reg[cnt] );
								fprintf( Wfp2, "\tXOR.B\t%sH,%sH\n", Reg[cnt], Reg[cnt] );
							}
							break;
						case	S_WORD:
							sscanf( Temp, "%u", &adr );
							if( output_sub( rc, adr ) == -1 ) {
								return(-1);
							}
							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								port_id = adr2port( adr );
								fprintf( Wfp2, ";S_WORD line=%d\n", __LINE__ );
								if( funcnum == fDataReq && cnt > 0 ) {
									if( port_id != 0 ) {
										return(-1);
									} else {
										/* |C^̉16bitn */
										fprintf( Wfp2, "\tMOV.W\t#_%s,%s\n", pn, Reg[cnt] );
									}
								} else {
									/* ln */
									if( port_id != 0 ) {
										fprintf( Wfp2, "\tMOV.B\t#H'%X,R0L\n", port_id );
										fprintf( Wfp2, "\tJSR\t@fGetData:24\n" );
										fprintf( Wfp2, "\tMOV.W\tR0,%s\n", Reg[cnt] );
									} else {
										fprintf( Wfp2, "\tMOV.W\t@_%s,%s\n", pn, Reg[cnt] );
									}
								}
							}
							break;
						case	ID_ARRAY:
							sscanf( Temp, "%u", &adr );
							/* ł͔z̃AhXɂ̂M_INTɂ */
							if( output_sub( M_INT, adr ) == -1 ) {
								return(-1);
							}
							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								fprintf( Wfp2, ";ID_ARRAY/ID_ARRAYW line=%d\n", __LINE__ );
								if( funcnum == fDataReq && cnt > 0 ) {
									fprintf( Wfp2, "\tMOV.W\t#_%s,%s\n", pn, Reg[cnt] );
								} else if( funcnum == ftime_set ||
											funcnum == ftime_get ||
											funcnum == ftime_cmp ||
											funcnum == ftime_update ||
											funcnum == ftime_rstcarry ||
											funcnum == fmemcpy ) {
									fprintf( Wfp2, "\tMOV.W\t#_%s,%s\n", pn, Reg[cnt] );
								} else {
									fprintf( Wfp2, "\tMOV.W\t@_%s,%s\n", pn, Reg[cnt] );
								}
							}
							break;
						default:
sprintf( ErrMsg1, "T|[gĂȂϐgĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
							return(-1);
						}
						break;
					default:
sprintf( ErrMsg1, "T|[gĂȂϐgĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					p++;	/* ̃p[^ɐi߂ */

					/* 2001/06 ȗ\ȃp[^w肳ꂽ̓[o */
					if( (*p == 'b' || *p == 'w') && p2 == NULL ) {
						/* ee_read(),ee_write(),time_set()p */
						cnt++;
						if( output_sub( M_CHAR, 0 ) == -1 ) {
							return(-1);
						}
						/* compile */
						if( Pass == 2 && Wfp1 != NULL ) {
							fprintf( Wfp2, ";M_CHAR/M_INT line=%d\n", __LINE__ );
							fprintf( Wfp2, "\tMOV.W\t#H'%X,%s\n", 0, Reg[cnt] );
						}
						p++;
					}

					if( (*p && p2 == NULL) || (*p == 0 && p2 != NULL) ) {
sprintf( ErrMsg1, "p[^ԈĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					cnt++;
				}

				/* compile */
				if( Pass == 2 && Wfp1 != NULL ) {
					output_function( funcnum );
					fprintf( Wfp2, ";function return line=%d\n", __LINE__ );
					fprintf( Wfp2, "\tPUSH.W\tR0\n" );
				}

				continue;
			case	ID_ARRAY:
			case	ID_ARRAYW:
				p = strstr( (char *)&Pp[i][2], "," );
				if( p == NULL ) {
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				*p = 0;
				if( SearchHashData( (char *)&Pp[i][2], (unsigned char *)Temp ) == -1 ) {
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				sscanf( Temp, "%u", &adr );
				*p = ',';	/* ꉞɖ߂ */
				p++;
				if( Pp[i][1] == ID_ARRAY ) {
					image[image_ptr++] = ARRAY;
				} else {
					image[image_ptr++] = ARRAYW;
				}
				/* z̃x[XAhX */
				image[image_ptr++] = (unsigned char)((adr>>8)&0xff);
				image[image_ptr++] = (unsigned char)(adr&0xff);
				if( isdigit(*(p+1)) ) {
					rc = M_INT;
					strcpy( Temp, p+1 );
				} else {
					rc = SearchHashData( p+1, (unsigned char *)Temp );
				}
				break;
			case	S_BOOLD:
				rc = S_BOOLD;
				strcpy( Temp, (char *)&Pp[i][2] );
				break;
			default:
				rc = SearchHashData( (char *)&Pp[i][2], (unsigned char *)Temp );
				break;
			}
			sscanf( Temp, "%u", &adr );
			switch( rc ) {
			case	M_INT:
				if( calc_output_sub( rc, (char *)&Pp[i][2], adr ) != 0 ) {
					return(-1);
				}
				break;
			case	S_BOOL:
				if( calc_output_sub( rc, (char *)&Pp[i][2], adr ) != 0 ) {
					return(-1);
				}
				break;
			case	S_BOOLD:	/* |[gf[^̒ڎw */
				if( calc_output_sub( rc, "", adr ) != 0 ) {
					return(-1);
				}
				break;
			case	S_BYTE:
				if( calc_output_sub( rc, (char *)&Pp[i][2], adr ) != 0 ) {
					return(-1);
				}
				break;
			case	S_WORD:
				if( calc_output_sub( rc, (char *)&Pp[i][2], adr ) != 0 ) {
					return(-1);
				}
				break;
			case	ID_INFUNC:
				break;
			default:
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
		} else {
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
	}
	return(0);
}

int	do_if(void)
{
	int		skip_adr, else_adr;
	int		if_top_adr;

	if( GetSym( (unsigned char *)Sym, &Code ) != S_LPAR ) {
sprintf( ErrMsg1, "ʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( do_statement3( S_RPAR ) != 0 ) {
		return(-1);
	}
	/* ͌ʂ̔s */
	if_top_adr = image_ptr;	/* compile */
	image[image_ptr++] = JUDGE;	/* 莮̎ʎq */
	skip_adr = image_ptr;		/* JUDGEdi[AhXL */
	image_ptr++;
	image_ptr++;
	image[image_ptr++] = (unsigned char)Pc;	/* i[ */
	/* vZ̏o */
	if( calc_output() == -1 ) {
		return(-1);
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\tPOP.W\tR0\n\tAND.W\tR0,R0\n" );
		fprintf( Wfp2, "\tBEQ\tLBL%X_ELSE:16\t;(if goto-else)\n", if_top_adr );
	}

	SymRc = GetSym( (unsigned char *)Sym, &Code );
	if( SymRc == S_LBRACE ) {
		SymRc = GetSym( (unsigned char *)Sym, &Code );
		while( SymRc != S_RBRACE ) {
			if( do_statement() != 0 ) {
				return(-1);
			}
		}
		SymRc = GetSym((unsigned char *) Sym, &Code );
	} else {
		if( do_statement() != 0 ) {
			return(-1);
		}
	}
	get_real_adrs(image_ptr);
	image[skip_adr+0] = (unsigned char)real_high;
	image[skip_adr+1] = (unsigned char)real_low;

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\tBRA\tLBL%X_E:16\t;(if end)\n", if_top_adr );
		fprintf( Wfp2, "LBL%X_ELSE\t;(else)\n", if_top_adr );
	}

	if( SymRc == S_STR ) {
		if( SearchHash( Sym ) == S_ELSE ) {
			image[image_ptr++] = GOTO;
			else_adr = image_ptr;
			image_ptr++;
			image_ptr++;
			get_real_adrs(image_ptr);
			image[skip_adr+0] = (unsigned char)real_high;
			image[skip_adr+1] = (unsigned char)real_low;
			SymRc = GetSym( (unsigned char *)Sym, &Code );
			if( SymRc == S_LBRACE ) {
				SymRc = GetSym( (unsigned char *)Sym, &Code );
				while( SymRc != S_RBRACE ) {
					if( do_statement() != 0 ) {
						return(-1);
					}
				}
				SymRc = GetSym( (unsigned char *)Sym, &Code );
			} else {
				if( do_statement() != 0 ) {
					return(-1);
				}
			}
			get_real_adrs(image_ptr);
			image[else_adr+0] = (unsigned char)real_high;
			image[else_adr+1] = (unsigned char)real_low;
		}
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "LBL%X_E:\t;(if end)\n", if_top_adr );
	}

	return(0);
}

int	do_while(void)
{
	int		rc, skip_adr, while_top_adr;

	LoopNest++;
	if( LoopNest == LOOP_NEST_MAX ) {
sprintf( ErrMsg1, "JԂ̃lXg[܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	LoopNestCounter[LoopNest] = LoopCounter;
	LoopCounter++;

	if( GetSym( (unsigned char *)Sym, &Code ) != S_LPAR ) {
sprintf( ErrMsg1, "ʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( do_statement3( S_RPAR ) != 0 ) {
		return(-1);
	}
	/* ͌ʂ̔s */
	while_top_adr = image_ptr;

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "LBL%X_T:\t;(while top)\n", LoopNestCounter[LoopNest] );
	}

	image[image_ptr++] = JUDGE;	/* 莮̎ʎq */
	skip_adr = image_ptr;		/* JUDGEdi[AhXL */
	image_ptr++;
	image_ptr++;
	image[image_ptr++] = (unsigned char)Pc;	/* i[ */
	/* vZ̏o */
	if( calc_output() == -1 ) {
		return(-1);
	}
	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\tPOP.W\tR0\n\tAND.W\tR0,R0\n" );
		fprintf( Wfp2, "\tBEQ\tLBL%X_E:16\n", LoopNestCounter[LoopNest] );
	}
	SymRc = GetSym( (unsigned char *)Sym, &Code );
	if( SymRc == S_LBRACE ) {
		SymRc = GetSym( (unsigned char *)Sym, &Code );
		while( SymRc != S_RBRACE ) {
			if( do_statement() != 0 ) {
				return(-1);
			}
		}
		SymRc = GetSym( (unsigned char *)Sym, &Code );
	} else {
		if( do_statement() != 0 ) {
			return(-1);
		}
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\tBRA\tLBL%X_T:16\t;(while goto-top)\n", LoopNestCounter[LoopNest] );
	}

	image[image_ptr++] = GOTO;
	get_real_adrs(while_top_adr);
	image[image_ptr++] = (unsigned char)real_high;
	image[image_ptr++] = (unsigned char)real_low;
	get_real_adrs(image_ptr);
	image[skip_adr+0] = (unsigned char)real_high;
	image[skip_adr+1] = (unsigned char)real_low;

	/* continuepx̒` */
	sprintf( Sym2, "ContinueLabel%d", LoopNestCounter[LoopNest] );
	if( Pass == 1 ) {
		rc = SearchHash( Sym2 );
		if( rc != -1 && rc != ID_PROTO ) {
sprintf( ErrMsg1, "Qd`ł [ %s ]", Sym2 );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
	}
	sprintf( Temp, "%d", while_top_adr );
	AddHash( Sym2, (unsigned char *)Temp, ID_LABEL );
	/* breakpx̒` */
	sprintf( Sym2, "BreakLabel%d", LoopNestCounter[LoopNest] );
	if( Pass == 1 ) {
		rc = SearchHash( Sym2 );
		if( rc != -1 && rc != ID_PROTO ) {
sprintf( ErrMsg1, "Qd`ł [ %s ]", Sym2 );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "LBL%X_E:\t;(while end)\n", LoopNestCounter[LoopNest] );
	}

	sprintf( Temp, "%d", image_ptr );
	AddHash( Sym2, (unsigned char *)Temp, ID_LABEL );
	LoopNest--;
	return(0);
}

int	do_do(void)
{
	int		rc, skip_adr, do_top_adr;

	LoopNest++;
	if( LoopNest == LOOP_NEST_MAX ) {
sprintf( ErrMsg1, "JԂ̃lXg[܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	LoopNestCounter[LoopNest] = LoopCounter;
	LoopCounter++;

	do_top_adr = image_ptr;

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "LBL%X_T:\t;(do top)\n", LoopNestCounter[LoopNest] );
	}

	SymRc = GetSym( (unsigned char *)Sym, &Code );
	if( SymRc == S_LBRACE ) {
		SymRc = GetSym( (unsigned char *)Sym, &Code );
		while( SymRc != S_RBRACE ) {
			if( do_statement() != 0 ) {
				return(-1);
			}
		}
		SymRc = GetSym( (unsigned char *)Sym, &Code );
	} else {
		if( do_statement() != 0 ) {
			return(-1);
		}
	}
	if( SymRc != S_STR ) {
sprintf( ErrMsg1, "while ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( GetSym( (unsigned char *)Sym, &Code ) != S_LPAR ) {
sprintf( ErrMsg1, "ʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( do_statement3( S_RPAR ) != 0 ) {
		return(-1);
	}
	/* ͌ʂ̔s */
	image[image_ptr++] = JUDGE;	/* 莮̎ʎq */
	skip_adr = image_ptr;		/* JUDGEdi[AhXL */
	image_ptr++;
	image_ptr++;
	image[image_ptr++] = (unsigned char)Pc;	/* i[ */
	/* vZ̏o */
	if( calc_output() == -1 ) {
		return(-1);
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\tPOP.W\tR0\n\tAND.W\tR0,R0\n" );
		fprintf( Wfp2, "\tBNE\tLBL%X_T:16\t;(do goto-top)\n", LoopNestCounter[LoopNest] );
	}

	image[image_ptr++] = GOTO;
	get_real_adrs(do_top_adr);
	image[image_ptr++] = (unsigned char)real_high;
	image[image_ptr++] = (unsigned char)real_low;
	get_real_adrs(image_ptr);
	image[skip_adr+0] = (unsigned char)real_high;
	image[skip_adr+1] = (unsigned char)real_low;

	/* continuepx̒` */
	sprintf( Sym2, "ContinueLabel%d", LoopNestCounter[LoopNest] );
	if( Pass == 1 ) {
		rc = SearchHash( Sym2 );
		if( rc != -1 && rc != ID_PROTO ) {
sprintf( ErrMsg1, "Qd`ł [ %s ]", Sym2 );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
	}
	sprintf( Temp, "%d", do_top_adr );
	AddHash( Sym2, (unsigned char *)Temp, ID_LABEL );
	/* breakpx̒` */
	sprintf( Sym2, "BreakLabel%d", LoopNestCounter[LoopNest] );
	if( Pass == 1 ) {
		rc = SearchHash( Sym2 );
		if( rc != -1 && rc != ID_PROTO ) {
sprintf( ErrMsg1, "Qd`ł [ %s ]", Sym2 );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "LBL%X_E:\t;(do end)\n", LoopNestCounter[LoopNest] );
	}

	sprintf( Temp, "%d", image_ptr );
	AddHash( Sym2, (unsigned char *)Temp, ID_LABEL );
	LoopNest--;

	if( GetSym( (unsigned char *)Sym, &Code ) != S_SEMICOL ) {
sprintf( ErrMsg1, "do ̏IɃZ~R܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	SymRc = GetSym( (unsigned char *)Sym, &Code );
	return(0);
}

int	do_goto(void)
{
	unsigned	int	adr;

	if( GetSym( (unsigned char *)Sym, &Code ) != S_STR ) {
sprintf( ErrMsg1, "goto ̔ѐ悪xł͂܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( GetSym( (unsigned char *)Sym2, &Code ) != S_SEMICOL ) {
sprintf( ErrMsg1, "goto ̏IɃZ~R܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	adr = 0;
	if( Pass == 2 ) {
		if( SearchHashData( Sym, (unsigned char *)Temp ) == -1 ) {
sprintf( ErrMsg1, "goto ̔ѐ悪܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		sscanf( Temp, "%u", &adr );
//printf( "goto ( %d ) [%s]\n", adr, Sym );
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\tBRA\t_%s:16\n", Sym );
	}

	image[image_ptr++] = GOTO;
	get_real_adrs(adr);
	image[image_ptr++] = (unsigned char)real_high;
	image[image_ptr++] = (unsigned char)real_low;
	SymRc = GetSym( (unsigned char *)Sym, &Code );
	return(0);
}

int	do_break(void)
{
	unsigned	int	adr;

	if( GetSym( (unsigned char *)Sym, &Code ) != S_SEMICOL ) {
sprintf( ErrMsg1, "break ̏IɃZ~R܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( LoopNest == 0 ) {
sprintf( ErrMsg1, "break ͌JԂ̒łg܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	sprintf( Sym, "BreakLabel%d", LoopNestCounter[LoopNest] );
	adr = 0;
	if( Pass == 2 ) {
		if( SearchHashData( Sym, (unsigned char *)Temp ) == -1 ) {
sprintf( ErrMsg1, "break ̔ѐ悪܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		sscanf( Temp, "%u", &adr );
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\tBRA\tLBL%X_E:16\t;(break)\n", LoopNestCounter[LoopNest] );
	}

	image[image_ptr++] = GOTO;
	get_real_adrs(adr);
	image[image_ptr++] = (unsigned char)real_high;
	image[image_ptr++] = (unsigned char)real_low;
	SymRc = GetSym( (unsigned char *)Sym, &Code );
	return(0);
}

int	do_continue(void)
{
	unsigned	int	adr;

	if( GetSym( (unsigned char *)Sym, &Code ) != S_SEMICOL ) {
sprintf( ErrMsg1, "continue ̏IɃZ~R܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( LoopNest == 0 ) {
sprintf( ErrMsg1, "continue ͌JԂ̒łg܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	sprintf( Sym, "ContinueLabel%d", LoopNestCounter[LoopNest] );
	adr = 0;
	if( Pass == 2 ) {
		if( SearchHashData( Sym, (unsigned char *)Temp ) == -1 ) {
sprintf( ErrMsg1, "continue ̔ѐ悪܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		sscanf( Temp, "%u", &adr );
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\tBRA\tLBL%X_T:16\t;(continue)\n", LoopNestCounter[LoopNest] );
	}

	image[image_ptr++] = GOTO;
	get_real_adrs(adr);
	image[image_ptr++] = (unsigned char)real_high;
	image[image_ptr++] = (unsigned char)real_low;
	SymRc = GetSym( (unsigned char *)Sym, &Code );
	return(0);
}

int	insidevalue( char *name )
{
	int		offset, pinno, adr;
//printf( "name in[ %s]\n", name );
	/* ϐȂ̂ŕϊsĂ */
	if( toupper(*name) == 'P' ) {
		/* |[g̒ڎw */
		adr = getbit2( name+1 );
		if( adr == -1 ) {
sprintf( ErrMsg1, "|[gԍԈĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
	} else {
		/* sԍw */
		offset = 0;
		if( strnicmp( name, "Vpp", 3 ) == 0 ) {
			offset = 40;
		} else if( strnicmp( name, "Vcc", 3 ) == 0 ) {
			offset = 80;
		} else if( strnicmp( name, "GND", 3 ) == 0 ) {
			offset = 120;
		}
		pinno = getbit( name );
		if( pinno == -1 ) {
sprintf( ErrMsg1, "sԍԈĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		pinno += offset;
		adr = pinno2port( (unsigned int)pinno );
		if( adr == 0xff ) {
sprintf( ErrMsg1, "sԍ|[gԍɕϊł܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
	}
	if( strstr( name, ".dir" ) != NULL ) {
		adr += 80;
	}
//printf( "name out( %d ) ( %d )\n", adr, pinno );
	return( adr );
}

/* ʂZ~Rif̃lXg߂ */
int	do_statement3( int endSym )
{
	int		i, rc, loop, nest, adr, checker;
	char	*p;

	*Sym = 0;
	Pc = 0;
	for( i=0; i<PC_MAX; i++ ) {
		Pp[i] = Pd[i];
	}
	nest = 1;
	loop = 1;
	checker = -1;	/* ϐ/l ϐ/l AG[̃`FbNptO */
	while( loop ) {
		SymRc = GetSym( (unsigned char *)Sym, &Code );
//printf( "< %d >\n", SymRc );
		switch( SymRc ) {
		case	S_EOF:
sprintf( ErrMsg1, "vOrŏIĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
#if 0
		case	S_RBRCKT:	/*  ]   */
			if( endSym == S_RBRCKT ) {
				loop = 0;
			} else {
sprintf( ErrMsg1, "vOԈĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			break;
#endif
		case	S_SEMICOL:
			if( endSym == S_SEMICOL ) {
				loop = 0;
			} else {
sprintf( ErrMsg1, "vOԈĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			break;
		case	S_STR:
			rc = SearchHash( Sym );
			switch( rc ) {
			case	ID_ARRAY:
			case	ID_ARRAYW:
				/* pzlɏ */
				/* ̃f[^ǂݍSymƂď */
				if( GetSym( (unsigned char *)Sym2, &Code ) != S_LBRCKT ) {
sprintf( ErrMsg1, "z̍ʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				Pd[Pc][0] = S_STR;
				Pd[Pc][1] = (unsigned char)rc;
				rc = GetSym( (unsigned char *)Sym2, &Code );
				if( GetSym( (unsigned char *)Temp, &Code ) != S_RBRCKT ) {
sprintf( ErrMsg1, "z̉Eʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				/* Sym , SymRc XXX 0x00 */
				p = (char *)&Pd[Pc++][2];
				strcpy( p, Sym );
				strcat( p, "," );
				Temp[0] = (unsigned char)rc;
				strcpy( &Temp[1], Sym2 );
				strcat( p, Temp );
				break;
			case	S_BOOL:
			case	S_BOOLD:
			case	S_BYTE:
			case	S_WORD:
				Pd[Pc][0] = S_STR;
				Pd[Pc][1] = (unsigned char)rc;
				strcpy( (char *)&Pd[Pc++][2], (char *)Sym );
				break;
			case	ID_INFUNC:	/* ֐ */
				Pd[Pc][0] = S_STR;
				Pd[Pc][1] = (unsigned char)rc;
				strcpy( (char *)&Pd[Pc][2], Sym );
				if( GetSym( (unsigned char *)Sym2, &Code ) != S_LPAR ) {
sprintf( ErrMsg1, "֐̍ʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				rc = GetSym( (unsigned char *)Sym2, &Code );
				while( rc != S_RPAR ) {
					/* ڎʗp̃J} */
					strcat( (char *)&Pd[Pc][2], "," );
					switch( rc ) {
					case	M_CHAR:
					case	M_INT:
					case	S_STR:
						break;
					default:
//printf( "rc = %d\n", rc );
sprintf( ErrMsg1, "eĂȂp[^w肳Ă܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					*Temp = (unsigned char)rc;
					Temp[1] = 0;
					strcat( (char *)&Pd[Pc][2], Temp );
					strcat( (char *)&Pd[Pc][2], Sym2 );
					rc = GetSym( (unsigned char *)Sym2, &Code );
					if( rc == S_COMMA ) {
						rc = GetSym( (unsigned char *)Sym2, &Code );
					}
				}
				Pc++;
				break;
			default:
				if( *Sym == '#' ) {
					/* ϐ */
					if( (adr=insidevalue( Sym+1 )) == -1 ) {
						return(-1);
					}
//printf( "*** adr = %d ***\n", adr );
					Pd[Pc][0] = S_STR;
					Pd[Pc][1] = S_BOOLD;
					sprintf( (char *)&Pd[Pc++][2], "%u", adr );
				} else {
sprintf( ErrMsg1, "錾̕ϐgĂ邩ُł [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				break;
			}
			*Sym = 0;
if( checker == 1 ) {
/* ϐ/l̒ɕϐ */
sprintf( ErrMsg1, "ɊԈႢ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
return(-1);
}
checker = 1;	/* ϐ/l ϐ/l AG[̃`FbNptO */
			break;
		case	S_LPAR:
			if( SymRc == S_LPAR ) {
				nest++;
			}
			Pd[Pc][0] = (unsigned char)SymRc;
			strcpy( (char *)&Pd[Pc++][1], "(" );
checker = -1;	/* ϐ/l ϐ/l AG[̃`FbNptO */
			break;
		case	S_RPAR:
			if( endSym == S_RPAR ) {
				nest--;
				if( nest == 0 ) {
					loop = 0;
				}
			}
			if( loop != 0 ) {
				Pd[Pc][0] = (unsigned char)SymRc;
				strcpy( (char *)&Pd[Pc++][1], ")" );
			}
checker = -1;	/* ϐ/l ϐ/l AG[̃`FbNptO */
			break;
		default:
			if( SymRc > M_START && SymRc < M_END ) {
				switch( SymRc ) {
				case	M_MODEQL:	/*  %=  */
				case	M_TIMESEQL:	/*  *=  */
				case	M_SLASHEQL:	/*  /=  */
				case	M_PLUSEQL:	/*  +=  */
				case	M_MINUSEQL:	/*  -=  */
				case	M_ANDEQL:	/*  &=  */
				case	M_OREQL:	/*  |=  */
				case	M_XOREQL:	/*  ^=  */
				case	M_ASSLEQL:	/*  <<= */
				case	M_ASSREQL:	/*  >>= */
				case	M_EQL:		/*  =   */
				case	M_BITXOR:	/*  ^   */
sprintf( ErrMsg1, "R[hTCY팸̂߃T|[gĂ܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				default:
					break;
				}
				Pd[Pc][0] = (unsigned char)SymRc;
				strcpy( (char *)&Pd[Pc++][1], Sym );
				*Sym = 0;
checker = 0;	/* ϐ/l ϐ/l AG[̃`FbNptO */
			} else if( SymRc > M_NUM_START && SymRc < M_NUM_END ) {
				Pd[Pc][0] = (unsigned char)SymRc;
				strcpy( (char *)&Pd[Pc++][1], Sym );
				*Sym = 0;
if( checker == 1 ) {
/* ϐ/l̒ɐl */
sprintf( ErrMsg1, "ɊԈႢ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
return(-1);
}
checker = 1;	/* ϐ/l ϐ/l AG[̃`FbNptO */
			} else {
//printf( "SymRc = %d  Sym [ %s ]\n", SymRc, Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			break;
		}
	}
	/* t|[h */
/*
if( Pass == 2 ) {
	for( rc=0; rc<Pc; rc++ ) {
		printf( " %s\n", &Pd[rc][1] );
	}
}
printf( "---------\n" );
*/
	Pc = pol( (char **)Pp, Pc );
	if( Pc >= STACK_MAX ) {
sprintf( ErrMsg1, "vZG߂̂ŕĉ" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
/*
if( Pass == 2 ) {
	for( rc=0; rc<Pc; rc++ ) {
		printf( " %s\n", &Pp[rc][1] );
	}
}
*/
	return(0);
}

int	array_output( int type, unsigned int adr, char *comp_save )
{
	int		rc;

	if( type == ID_ARRAY ) {
		image[image_ptr++] = ARRAY;		/* BYTE */
	} else {
		image[image_ptr++] = ARRAYW;	/* WORD */
	}
	/* z̃x[XAhX */
	image[image_ptr++] = (unsigned char)((adr>>8)&0xff);
	image[image_ptr++] = (unsigned char)(adr&0xff);
	rc = GetSym( (unsigned char *)Sym2, &Code );
	switch( rc ) {
	case	M_CHAR:
	case	M_INT:
		if( output_sub( rc, (unsigned int)Code ) == -1 ) {
			return(-1);
		}
		/* compile */
		if( type == ID_ARRAY ) {
			sprintf( comp_save, "\tMOV.W\t#H'%X,R0\n\tPUSH.W\tR0\n", Code );
		} else {
			sprintf( comp_save, "\tMOV.W\t#H'%X,R0\n\tPUSH.W\tR0\n", Code*2 );
		}
		break;
	case	S_STR:
		rc = SearchHashData( Sym2, (unsigned char *)Temp );
		sscanf( Temp, "%u", &adr );
		switch( rc ) {
		case	S_BYTE:
		case	S_WORD:
			if( output_sub( rc, adr ) == -1 ) {
				return(-1);
			}
			/* compile */
			/* ϐ̏ꍇ */
			if( rc == S_BYTE ) {
				/* 2001/06 bug fix S_WORDƋp̂𕪗 */
				if( type == ID_ARRAY ) {
					sprintf( comp_save, "\tMOV.B\t@_%s,R0L\n\tXOR.B\tR0H,R0H\n\tPUSH.W\tR0\n", Sym2 );
				} else {
					sprintf( comp_save, "\tMOV.B\t@_%s,R0L\n\tXOR.B\tR0H,R0H\n\tSHLL.W\tR0\n\tPUSH.W\tR0\n", Sym2 );
				}
			} else {
				if( type == ID_ARRAY ) {
					sprintf( comp_save, "\tMOV.W\t@_%s,R0\n\tPUSH.W\tR0\n", Sym2 );
				} else {
					sprintf( comp_save, "\tMOV.W\t@_%s,R0\n\tSHLL.W\tR0\n\tPUSH.W\tR0\n", Sym2 );
				}
			}
			break;
		default:
sprintf( ErrMsg1, "BYTE/WORD`ꂽϐ̂ݎgp\ł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		break;
	default:
sprintf( ErrMsg1, "BYTE/WORD`ꂽϐ̂ݎgp\ł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( GetSym( (unsigned char *)Temp, NULL ) != S_RBRCKT ) {
sprintf( ErrMsg1, "z̉Eʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	return(0);
}

int	output_function( int funcnum )
{
	switch( funcnum ) {
	case	fPulse:
		fprintf( Wfp2, "\tJSR\t@fPulse:24\n" );
		break;
	case	fInc:
		fprintf( Wfp2, "\tJSR\t@fInc:24\n" );
		break;
	case	fClear:
		fprintf( Wfp2, "\tJSR\t@fClear:24\n" );
		break;
	case	fDec:
		fprintf( Wfp2, "\tJSR\t@fDec:24\n" );
		break;
	case	fDataDump:
		fprintf( Wfp2, "\tJSR\t@fDataDump:24\n" );
		break;
	case	fGetTimer:
		fprintf( Wfp2, "\tJSR\t@fGetTimer:24\n" );
		break;
	case	fSetTimer:
		fprintf( Wfp2, "\tJSR\t@fSetTimer:24\n" );
		break;
	case	fStartDump:
		fprintf( Wfp2, "\tJSR\t@fStartDump:24\n" );
		break;
	case	fEndDump:
		fprintf( Wfp2, "\tJSR\t@fEndDump:24\n" );
		break;
	case	freturn:
		fprintf( Wfp2, "\tRTS\n" );
		break;
	case	fexit:
		fprintf( Wfp2, "\tJMP\t@USERRET:24\n" );
		break;
	case	fSendByte:
		fprintf( Wfp2, "\tJSR\t@fSendByte:24\n" );
		break;
	case	fSendWord:
		fprintf( Wfp2, "\tJSR\t@fSendWord:24\n" );
		break;
	case	fSendHex:
		fprintf( Wfp2, "\tJSR\t@fSendHex:24\n" );
		break;
	case	fSendCode:
		fprintf( Wfp2, "\tJSR\t@fSendCode:24\n" );
		break;
	case	fStartMsg:
		fprintf( Wfp2, "\tJSR\t@fStartMsg:24\n" );
		break;
	case	fSendMsg:
		fprintf( Wfp2, "\tJSR\t@fSendMsg:24\n" );
		break;
	case	fEndMsg:
		fprintf( Wfp2, "\tJSR\t@fEndMsg:24\n" );
		break;
	case	fSendNum2Str:
		fprintf( Wfp2, "\tJSR\t@fSendNum2Str:24\n" );
		break;
	case	fInitIo:
		fprintf( Wfp2, "\tJSR\t@fInitIo:24\n" );
		break;
	case	fVppVolt:
		fprintf( Wfp2, "\tJSR\t@fVppVolt:24\n" );
		break;
	case	fVccVolt:
		fprintf( Wfp2, "\tJSR\t@fVccVolt:24\n" );
		break;
	case	fRecByte:
		fprintf( Wfp2, "\tJSR\t@fRecByte:24\n" );
		break;
	case	fNwRecByte:
		fprintf( Wfp2, "\tJSR\t@fNwRecByte:24\n" );
		break;
	case	fDataReq:
		fprintf( Wfp2, "\tJSR\t@fDataReq:24\n" );
		break;
	case	fWait:
		fprintf( Wfp2, "\tJSR\t@fWait:24\n" );
		break;
	case	fmset:
		fprintf( Wfp2, "\tJSR\t@fmset:24\n" );
		break;
	case	fmget:
		fprintf( Wfp2, "\tJSR\t@fmget:24\n" );
		break;
	case	fmgetw:
		fprintf( Wfp2, "\tJSR\t@fmgetw:24\n" );
		break;
	case	fGetClock:
		fprintf( Wfp2, "\tJSR\t@fGetClock:24\n" );
		break;
	case	fSetClock:
		fprintf( Wfp2, "\tJSR\t@fSetClock:24\n" );
		break;
	case	fWaitExecEvent:
		fprintf( Wfp2, "\tJSR\t@fWaitExecEvent:24\n" );
		break;
	case	fMessage:
		fprintf( Wfp2, "\tJSR\t@fMessage:24\n" );
		break;
	case	fee_write:
		fprintf( Wfp2, "\tJSR\t@fee_write:24\n" );
		break;
	case	fee_read:
		fprintf( Wfp2, "\tJSR\t@fee_read:24\n" );
		break;
	case	fee_prog:
		fprintf( Wfp2, "\tJSR\t@fee_prog:24\n" );
		break;
	case	fClockStart:
		fprintf( Wfp2, "\tJSR\t@fClockStart:24\n" );
		break;
	case	fClockStop:
		fprintf( Wfp2, "\tJSR\t@fClockStop:24\n" );
		break;
	case	fInitVolt:
		fprintf( Wfp2, "\tJSR\t@fInitVolt:24\n" );
		break;
	case	ftime_set:
		fprintf( Wfp2, "\tJSR\t@ftime_set:24\n" );
		break;
	case	ftime_get:
		fprintf( Wfp2, "\tJSR\t@ftime_get:24\n" );
		break;
	case	ftime_cmp:
		fprintf( Wfp2, "\tJSR\t@ftime_cmp:24\n" );
		break;
	case	ftime_update:
		fprintf( Wfp2, "\tJSR\t@ftime_update:24\n" );
		break;
	case	ftime_rstcarry:
		fprintf( Wfp2, "\tJSR\t@ftime_rstcarry:24\n" );
		break;
	case	fmemcpy:
		fprintf( Wfp2, "\tJSR\t@fmemcpy:24\n" );
		break;
	default:
		break;
	}
	return(0);
}

unsigned	char	adr2port( unsigned int adr )
{
	switch( adr ) {
	case	Port1Adr:	return( A_DT );
	case	Port2Adr:	return( B_DT );
	case	Port3Adr:	return( C_DT );
	case	Port1Adr+2:	return( A_DIR );
	case	Port2Adr+2:	return( B_DIR );
	case	Port3Adr+2:	return( C_DIR );
	default:	return( 0 );
	}
}

/* s̉ */
int	do_statement2(void)
{
	int	rc, type, i, cnt;
	unsigned	int	adr;
	unsigned	char	funcnum, *p;
	char	save[128], save2[128];
	unsigned	char	port_id;
	int		m, n;
	int		adr_m;

	rc = GetSym( (unsigned char *)Sym2, (unsigned long *)&Code );
	switch( rc ) {
	case	S_COL:	/* x錾 */
		/* ̂܂܏o */
		if( Pass == 1 ) {
			rc = SearchHash( Sym );
			if( rc != -1 && rc != ID_PROTO ) {
sprintf( ErrMsg1, "Qd`ł [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
		}

		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			fprintf( Wfp2, "_%s:\n", Sym );
		}

		sprintf( Temp, "%d", image_ptr );
		AddHash( Sym, (unsigned char *)Temp, ID_LABEL );
		break;
	case	S_LPAR:	/* ֐Ăяo */
		*Temp = 0;
		rc = SearchHashData( Sym, (unsigned char *)Temp );
		if( rc == ID_INFUNC ) {
//printf( "gݍ݊֐ [ %s ]\n", Sym );
			/* gݍ݊֐ */
			/* Temp ̓eɂp[^ǂݍ */
			/* 99XY.. */
			/* 99 = 01-99 ֐ʔԍ */
			/* X  = (SP):^[lAB/W:BYTE/WORD̃^[l */
			/* Y... = Xg */
			p = (unsigned char *)Temp;
			funcnum = 0;
			while( isdigit( *p ) ) {
				funcnum = (unsigned char)(funcnum*10 + (*p-'0'));
				p++;
			}
			if( funcnum < 1 ) {
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			/* ^[l̎wLmF */
			/* ڌďoȂ̂Ń^[l͖gp */
			switch( toupper(*p) ) {
			case	'B':	/* oCgw */
			case	'W':	/* [hw */
				break;
			default:
				break;
			}
			p++;
			/* ̌ p ̓p[^̐擪wĂ */
			image[image_ptr++] = CALLIN;	/* gݍ݊֐ */
			image[image_ptr++] = funcnum;	/* gݍ݊֐ԍ */
			if( *p == 0 ) {
				SymRc = GetSym( (unsigned char *)Sym2, &Code );
			}
			cnt = 0;	/* compile Ԃ߂̃p[^Ă邩 */
			while( *p != 0 ) {
				/* p[^L */
				switch( toupper(*p) ) {
				case	'C':	/* B,W,|[g */
					SymRc = GetSym( (unsigned char *)Sym2, &Code );
					switch( SymRc ) {
					case	S_STR:
						rc = SearchHashData( Sym2, (unsigned char *)Temp );
						sscanf( Temp, "%u", &adr );
						switch( rc ) {
						case	S_BOOL:
							/* rbgw̕ϐƃAhX|[gwf[^ɕϊďo */
							if( (adr_m=get_bit_data( Sym2+1, adr )) == -1 ) {
								return(-1);
							}
							adr = (unsigned int)adr_m;
							if( output_sub( rc, adr ) == -1 ) {
								return(-1);
							}

							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								fprintf( Wfp2, ";S_BOOL line=%d\n", __LINE__ );
								fprintf( Wfp2, "\tMOV.B\t#H'%X,R0L\n", adr );
								fprintf( Wfp2, "\tJSR\t@fGetData:24\n\tMOV.W\tR0,%s\n", Reg[cnt] );
							}

							break;
						case	S_BYTE:
							if( output_sub( rc, adr ) == -1 ) {
								return(-1);
							}

							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								fprintf( Wfp2, ";S_BYTE line=%d\n", __LINE__ );
								if( funcnum == fPulse ) {
									funcnum = 0;
									fprintf( Wfp2, ";ϐւPulse()͖ӖȂ̂ŃR[ho͂Ȃ\n" );
								} else if( funcnum == fInc ) {
									funcnum = 0;
									fprintf( Wfp2, "\tMOV.B\t@_%s,%sL\n", Sym2, Reg[cnt] );
									fprintf( Wfp2, "\tINC.B\t%sL\n", Reg[cnt] );
									fprintf( Wfp2, "\tMOV.B\t%sL,@_%s\n", Reg[cnt], Sym2 );
								} else if( funcnum == fDec ) {
									funcnum = 0;
									fprintf( Wfp2, "\tMOV.B\t@_%s,%sL\n", Sym2, Reg[cnt] );
									fprintf( Wfp2, "\tDEC.B\t%sL\n", Reg[cnt] );
									fprintf( Wfp2, "\tMOV.B\t%sL,@_%s\n", Reg[cnt], Sym2 );
								} else if( funcnum == fClear ) {
									funcnum = 0;
									fprintf( Wfp2, "\tXOR.B\tR0L,R0L\n", Reg[cnt] );
									fprintf( Wfp2, "\tMOV.B\tR0L,@_%s\n", Sym2 );
								} else {
									fprintf( Wfp2, "\tMOV.B\t@_%s,%sL\n", Sym2, Reg[cnt] );
									fprintf( Wfp2, "\tXOR.B\t%sH,%sH\n", Reg[cnt], Reg[cnt] );
								}
							}

							break;
						case	S_WORD:
							if( output_sub( rc, adr ) == -1 ) {
								return(-1);
							}
							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								port_id = adr2port( adr );
								fprintf( Wfp2, ";S_WORD line=%d\n", __LINE__ );
								if( port_id == 0 && funcnum == fPulse ) {
									funcnum = 0;
									fprintf( Wfp2, ";ϐւPulse()͖ӖȂ̂ŃR[ho͂Ȃ\n" );
								} else if( port_id == 0 && funcnum == fInc ) {
									funcnum = 0;
									fprintf( Wfp2, "\tMOV.W\t@_%s,%s\n", Sym2, Reg[cnt] );
									fprintf( Wfp2, "\tINC.W\t#1,%s\n", Reg[cnt] );
									fprintf( Wfp2, "\tMOV.W\t%s,@_%s\n", Reg[cnt], Sym2 );
								} else if( port_id == 0 && funcnum == fDec ) {
									funcnum = 0;
									fprintf( Wfp2, "\tMOV.W\t@_%s,%s\n", Sym2, Reg[cnt] );
									fprintf( Wfp2, "\tDEC.W\t#1,%s\n", Reg[cnt] );
									fprintf( Wfp2, "\tMOV.W\t%s,@_%s\n", Reg[cnt], Sym2 );
								} else if( port_id == 0 && funcnum == fClear ) {
									funcnum = 0;
									fprintf( Wfp2, "\tXOR.W\tR0,R0\n", Reg[cnt] );
									fprintf( Wfp2, "\tMOV.W\tR0,@_%s\n", Sym2 );
								} else {
									if( port_id != 0 ) {
										fprintf( Wfp2, "\tMOV.B\t#H'%X,%sL\n", port_id, Reg[cnt] );
									} else {
										fprintf( Wfp2, "\tMOV.W\t@_%s,%s\n", Sym2, Reg[cnt] );
									}
								}
							}
							break;
						default:
							if( *Sym2 == '#' ) {
								/* ϐȂ̂ŕϊsĂ */
								if( (adr_m=insidevalue( Sym2+1 )) == -1 ) {
									return(-1);
								}
								adr = (unsigned int)adr_m;
								if( output_sub( S_BOOLD, adr ) == -1 ) {
									return(-1);
								}

								/* compile */
								if( Pass == 2 && Wfp1 != NULL ) {
									if( funcnum == fPulse || funcnum == fInc ||
										funcnum == fDec || funcnum == fClear ) {
										fprintf( Wfp2, "\tMOV.B\t#H'%X,%sL\n", adr, Reg[cnt] );
									} else {
										fprintf( Wfp2, ";#value line=%d\n", __LINE__ );
										fprintf( Wfp2, "\tMOV.B\t#H'%X,R0L\n", adr );
										fprintf( Wfp2, "\tJSR\t@fGetData:24\n\tMOV.W\tR0,%s\n", Reg[cnt] );
									}
								}

							} else {
sprintf( ErrMsg1, "BYTE/WORD/|[g`ꂽϐ̂ݎgp\ł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
								return(-1);
							}
						}
						break;
					}
					break;
				case	'B':	/* oCgw */
				case	'W':	/* [hw */
				case	'P':	/* [hw */
				case	'A':	/* zϐw */
				case	'F':	/* t[gw(D/Ao͌) */
					SymRc = GetSym( (unsigned char *)Sym2, &Code );
					if( toupper(*p) == 'P' && SymRc != S_STR ) {
sprintf( ErrMsg1, "p[^ԈĂ܂([hϐK{)" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					if( toupper(*p) == 'A' && SymRc != S_STR ) {
sprintf( ErrMsg1, "p[^ԈĂ܂(zϐK{)" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					/* 12.0  12 Ǝw肵ꍇAM_FLOAT ɂĂ */
					if( toupper(*p) == 'F' && (SymRc == M_CHAR || SymRc == M_INT) ) {
						SymRc = M_FLOAT;
					}
					switch( SymRc ) {
					case	M_CHAR:
					case	M_INT:
						if( output_sub( SymRc, (unsigned int)Code ) == -1 ) {
							return(-1);
						}

						/* compile */
						if( Pass == 2 && Wfp1 != NULL ) {
							fprintf( Wfp2, ";M_CHAR/M_INT line=%d\n", __LINE__ );
							fprintf( Wfp2, "\tMOV.W\t#H'%X,%s\n", (unsigned int)Code, Reg[cnt] );
						}

						break;
					case	M_FLOAT:
						// D/A̒lɒ
						if( strstr( Sym, "Vcc" ) == NULL ) {
							adr_m = DAC( BoardNum, 0, Sym2 );	/* VPPQ */
						} else {
							adr_m = DAC( BoardNum, 1, Sym2 );	/* VCCQ */
						}
						if( adr_m == -1 ) {
sprintf( ErrMsg1, "D/Ao͂ 0V ܂ 5.0V`21.0V ͈̔͂ɂĉ" );
sprintf( ErrMsg2, "line %d", __LINE__ );
							return(-1);
						}
						adr = (unsigned int)adr_m;
						image[image_ptr++] = CONST1;
						image[image_ptr++] = (unsigned char)adr;

						/* compile */
						if( Pass == 2 && Wfp1 != NULL ) {
							fprintf( Wfp2, ";M_CHAR/M_INT line=%d\n", __LINE__ );
							fprintf( Wfp2, "\tMOV.W\t#H'%X,%s\n", (unsigned int)adr, Reg[cnt] );
						}

						break;
					case	S_STR:
						rc = SearchHashData( Sym2, (unsigned char *)Temp );

						sscanf( Temp, "%u", &adr );
						if( toupper(*p) == 'P' && rc != S_WORD ) {
sprintf( ErrMsg1, "p[^ԈĂ܂([hϐK{)" );
sprintf( ErrMsg2, "line %d", __LINE__ );
							return(-1);
						}
						if( toupper(*p) == 'A' && rc != ID_ARRAY ) {
sprintf( ErrMsg1, "p[^ԈĂ܂(zϐK{)" );
sprintf( ErrMsg2, "line %d", __LINE__ );
							return(-1);
						}
						switch( rc ) {
						case	S_BYTE:

							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								fprintf( Wfp2, ";S_BYTE line=%d\n", __LINE__ );
								fprintf( Wfp2, "\tMOV.B\t@_%s,%sL\n", Sym2, Reg[cnt] );
								fprintf( Wfp2, "\tXOR.B\t%sH,%sH\n", Reg[cnt], Reg[cnt] );
							}

							if( output_sub( rc, adr ) == -1 ) {
								return(-1);
							}
							break;
						case	S_WORD:
							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								port_id = adr2port( adr );
								fprintf( Wfp2, ";S_WORD line=%d\n", __LINE__ );
								if( funcnum == fDataReq && cnt > 0 ) {
									if( port_id != 0 ) {
										return(-1);
									} else {
										/* |C^̉16bitn */
										fprintf( Wfp2, "\tMOV.W\t#_%s,%s\n", Sym2, Reg[cnt] );
									}
								} else {
									/* ln */
									if( port_id != 0 ) {
										fprintf( Wfp2, "\tMOV.B\t#H'%X,R0L\n", port_id );
										fprintf( Wfp2, "\tJSR\t@fGetData:24\n" );
										fprintf( Wfp2, "\tMOV.W\tR0,%s\n", Reg[cnt] );
									} else {
										fprintf( Wfp2, "\tMOV.W\t@_%s,%s\n", Sym2, Reg[cnt] );
									}
								}
							}

							if( output_sub( rc, adr ) == -1 ) {
								return(-1);
							}
							break;
						case	ID_ARRAY:
						case	ID_ARRAYW:
							sscanf( Temp, "%u", &adr );
							/* ł͔z̃AhXɂ̂M_INTɂ */

							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								fprintf( Wfp2, ";ID_ARRAY/ID_ARRAYW line=%d\n", __LINE__ );

								/* 2001/06 ԈႢC */
								fprintf( Wfp2, "\tMOV.W\t#_%s,%s\n", Sym2, Reg[cnt] );
								/*fprintf( Wfp2, "\tMOV.W\t#H'%X,%s\n", (unsigned int)Code, Reg[cnt] );*/

							}
							if( output_sub( M_INT, adr ) == -1 ) {
								return(-1);
							}
//							if( GetSym( Sym2, &Code ) != S_LBRCKT ) {
//sprintf( ErrMsg1, "z̍ʂ܂" );
//sprintf( ErrMsg2, "line %d", __LINE__ );
//								return(-1);
//							}
//							if( array_output( rc, adr, save2 ) == -1 ) {
//								return(-1);
//							}
							break;
						default:
sprintf( ErrMsg1, "BYTE/WORD`ꂽϐ̂ݎgp\ł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
							return(-1);
						}
						break;
					}
					break;
				case	'S':	/* w */
					SymRc = GetSym( (unsigned char *)Sym2, &Code );
					if( SymRc != S_MSG ) {
sprintf( ErrMsg1, "p[^ԈĂ܂(K{)" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					i = 1;

					/* 2001/07 */
					/*while( Sym2[i] != '"' && Sym2[i] != 0 ) {*/
					while( i < (int)(strlen(Sym2)-1) ) {
						image[image_ptr++] = Sym2[i];
						i++;
					}
					image[image_ptr++] = 0;

					/* compile */
					MsgCount++;
					if( Pass == 2 && Wfp1 != NULL ) {
						/* f[^GAɏo */
						fprintf( Wfp1, ";STRING line=%d\n", __LINE__ );
						fprintf( Wfp1, "MSG_%d:\n", MsgCount );
						fprintf( Wfp1, "\t.SDATA\t%s\n", Sym2 );
						fprintf( Wfp1, "\t.DATA.B\t0\n" );
						/* R[hGAɃAhXo */
						fprintf( Wfp2, ";STRING line=%d\n", __LINE__ );
						fprintf( Wfp2, "\tMOV.L\t#MSG_%d:32,ER2\n", MsgCount );
					}

					break;
				default:
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				SymRc = GetSym( (unsigned char *)Sym2, &Code );
				if( SymRc != S_COMMA && SymRc != S_RPAR ) {
/* point 2001/06 */
printf( "SymRc = %d   [%s]\n", SymRc, Sym2 );
sprintf( ErrMsg1, "֐̃p[^ɊԈႢ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				p++;

				/* 2001/06 ȗ\ȃp[^w肳ꂽ̓[o */
				if( (*p == 'b' || *p == 'w') && SymRc == S_RPAR ) {
					/* ee_read(),ee_write(),time_set()p */
					cnt++;
					if( output_sub( M_CHAR, 0 ) == -1 ) {
						return(-1);
					}
					/* compile */
					if( Pass == 2 && Wfp1 != NULL ) {
						fprintf( Wfp2, ";M_CHAR/M_INT line=%d\n", __LINE__ );
						fprintf( Wfp2, "\tMOV.W\t#H'%X,%s\n", 0, Reg[cnt] );
					}
					p++;
				}

				cnt++;
			}
			if( SymRc != S_RPAR ) {
sprintf( ErrMsg1, "֐̉Eʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			if( GetSym( (unsigned char *)Sym2, &Code ) != S_SEMICOL ) {
sprintf( ErrMsg1, "֐ĨZ~R܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}

			/* compile */
			if( Pass == 2 && Wfp1 != NULL ) {
				output_function( funcnum );
			}

			SymRc = GetSym( (unsigned char *)Sym, &Code );
			return(0);
		}
		/* [U֐Ăяo */
		if( GetSym( (unsigned char *)Sym2, &Code ) != S_RPAR ) {
sprintf( ErrMsg1, "֐̉Eʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		if( GetSym( (unsigned char *)Sym2, &Code ) != S_SEMICOL ) {
sprintf( ErrMsg1, "֐ĨZ~R܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		/* ֐Ăяo */
		rc = SearchHashData( Sym, (unsigned char *)Temp );
		if( rc == -1 ) {
			adr = 0;
			/* Ɋ֐錾Ă */
			AddHash( Sym, (unsigned char *)"", ID_PROTO );
		} else {

			/* 2001/06 */
			if( Pass == 2 && rc == ID_PROTO ) {
				/* Pass 2 ł ID_PROTO Ȃ݂̂ĂȂ */
sprintf( ErrMsg1, "֐̒`܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}

			sscanf( Temp, "%u", &adr );
		}
		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			/*if( overlay_frame_count != 0 ) {*/
			if( overlay_frame ) {
				/* I[oC̎͐؂ւ֐R[ */
				/* ŃAhX邽߂̈ʒu}[NĂ */
				fprintf( Wfp2, "update_%d_%d:\n", overlay_frame_count, image_ptr );
				/* R[AhXER2ɓĐ؂ւ֐R[ */
				fprintf( Wfp2, "\tMOV.L\t#_%s:32,ER2\n", Sym );
				fprintf( Wfp2, "\tJSR\t@fOverlay\n" );
			} else {
				/* ̂܂܎w֐R[ */
				fprintf( Wfp2, "\tJSR\t@_%s\n", Sym );
			}
		}

		image[image_ptr++] = CALL;
		get_real_adrs(adr);
		image[image_ptr++] = (unsigned char)real_high;
		image[image_ptr++] = (unsigned char)real_low;
		break;
	case	M_MODEQL:	/*  %=  */
	case	M_TIMESEQL:	/*  *=  */
	case	M_SLASHEQL:	/*  /=  */
	case	M_PLUSEQL:	/*  +=  */
	case	M_MINUSEQL:	/*  -=  */
	case	M_ANDEQL:	/*  &=  */
	case	M_OREQL:	/*  |=  */
	case	M_XOREQL:	/*  ^=  */
	case	M_ASSLEQL:	/*  <<= */
	case	M_ASSREQL:	/*  >>= */
sprintf( ErrMsg1, "R[hTCY팸̂߃T|[gĂ܂ [ %s ]", Sym2 );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	case	S_LBRCKT:	/*  [ zϐւ̑  */
		image[image_ptr++] = LET;	/* ̎ʎq */
		rc = SearchHashData( Sym, (unsigned char *)Temp );
		if( rc != ID_ARRAY && rc != ID_ARRAYW ) {
sprintf( ErrMsg1, "zϐł͂܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );

		}

		/* compile */
		strcpy( save, Sym );	/* zϐۑ */

		sscanf( Temp, "%u", &adr );
		if( array_output( rc, adr, save2 ) == -1 ) {
			return(-1);
		}
		if( GetSym( (unsigned char *)Sym2, &Code ) != M_EQL ) {
sprintf( ErrMsg1, "CR[܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		/* ̉ */
		if( do_statement3( S_SEMICOL ) != 0 ) {
			return(-1);
		}
		image[image_ptr++] = (unsigned char)Pc;	/* i[ */
		/* vZ */
		if( calc_output() == -1 ) {
			return(-1);
		}
		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			/* i[AhXvZ */
			fprintf( Wfp2, ";ARRAY line=%d\n", __LINE__ );
			fprintf( Wfp2, "%s", save2 );
			/* i[f[^o */
			fprintf( Wfp2, "\tPOP.W\tR0\n" );

			/* 2001/06 Rǉ */
			fprintf( Wfp2, "\tXOR.W\tE0,E0\n" );

			fprintf( Wfp2, "\tMOV.L\t#_%s:32,ER1\n", save );
			fprintf( Wfp2, "\tADD.L\tER0,ER1\n" );
			fprintf( Wfp2, "\tPOP.W\tR0\n" );
			fprintf( Wfp2, "\tMOV.B\tR0L,@ER1\n" );
		}
		break;
	case	M_EQL:	/*  */
		image[image_ptr++] = LET;	/* ̎ʎq */
		*save = 0;
		switch( SymRc ) {
		case	S_STR:
			*Temp = 0;
			type = SearchHashData( Sym, (unsigned char *)Temp );
			switch( type ) {
			case	S_BOOL:
				sscanf( Temp, "%u", &adr );
				/* rbgw̕ϐƃAhX|[gwf[^ɕϊďo */
				if( (adr_m=get_bit_data( Sym+1, adr )) == -1 ) {
					return(-1);
				}
				adr = (unsigned int)adr_m;
				if( output_sub( type, adr ) == -1 ) {
					return(-1);
				}

				for( m=0; m<3; m++ ) {
					for( n=0; n<16; n++ ) {
						if( image[m*20+n+4] == 0xff ) {
							break;
						}
						if( image[m*20+n+4] == (unsigned char)adr ) {
sprintf( ErrMsg1, "#portŎgpĂrbgϐ֑邱Ƃ͂ł܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
							return(-1);
						}
					}
				}

				/* compile */
				if( Pass == 2 && Wfp1 != NULL ) {
					sprintf( save, ";S_BOOL line=%d\n\tPOP.W\tR0\n\tMOV.B\t#H'%X,R1L\n\tJSR\t@fSetData:24\n", __LINE__, adr );
				}
				break;
			case	S_BYTE:
				sscanf( Temp, "%u", &adr );
				if( output_sub( type, adr ) == -1 ) {
					return(-1);
				}
				/* compile */
				if( Pass == 2 && Wfp1 != NULL ) {
					sprintf( save, ";S_BYTE line=%d\n\tPOP.W\tR0\n\tMOV.B\tR0L,@_%s\n", __LINE__, Sym );
				}
				break;
			case	S_WORD:
				sscanf( Temp, "%u", &adr );
				if( output_sub( type, adr ) == -1 ) {
					return(-1);
				}
				/* compile */
				if( Pass == 2 && Wfp1 != NULL ) {
					port_id = adr2port( adr );
					if( port_id != 0 ) {
						sprintf( save, ";S_WORD line=%d\n\tPOP.W\tR0\n\tMOV.B\t#H'%X,R1L\n\tJSR\t@fSetData:24\n", __LINE__, port_id );
					} else {
						sprintf( save, ";S_WORD line=%d\n\tPOP.W\tR0\n\tMOV.W\tR0,@_%s\n", __LINE__, Sym );
					}
				}
				break;
			default:
				if( *Sym == '#' ) {
					/* ϐȂ̂ŕϊsĂ */
					if( (adr_m=insidevalue( Sym+1 )) == -1 ) {
						return(-1);
					}
					adr = (unsigned int)adr_m;

					for( m=0; m<3; m++ ) {
						for( n=0; n<16; n++ ) {
							if( image[m*20+n+4] == 0xff ) {
								break;
							}
							if( image[m*20+n+4] == (unsigned char)adr ) {
sprintf( ErrMsg1, "#portŎgpĂrbgϐ֑邱Ƃ͂ł܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
								return(-1);
							}
						}
					}

					/* compile */
					if( Pass == 2 && Wfp1 != NULL ) {
						sprintf( save, ";#value line=%d\n\tPOP.W\tR0\n\tMOV.B\t#H'%X,R1L\n\tJSR\t@fSetData:24\n", __LINE__, adr );
					}
					if( output_sub( S_BOOLD, adr ) == -1 ) {
						return(-1);
					}
				} else {
sprintf( ErrMsg1, "悪ϐɂȂĂ܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
			}
			break;
		default:
sprintf( ErrMsg1, "悪ϐɂȂĂ܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		/* ̉ */
		if( do_statement3( S_SEMICOL ) != 0 ) {
			return(-1);
		}
		image[image_ptr++] = (unsigned char)Pc;	/* i[ */
		/* vZ */
		if( calc_output() == -1 ) {
			return(-1);
		}
		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			fprintf( Wfp2, save );
		}
		break;
	default:		/* a++; ̎s */
sprintf( ErrMsg1, "T|[gĂȂł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	SymRc = GetSym( (unsigned char *)Sym, &Code );
	return(0);
}

/* s̉ */
int	do_statement(void)
{
	/* P̎s߂ */
	switch( SearchHash( Sym ) ) {
	case	S_IF:
		if( do_if() != 0 ) {
			return(-1);
		}
		break;
	case	S_WHILE:
		if( do_while() != 0 ) {
			return(-1);
		}
		break;
	case	S_DO:
		if( do_do() != 0 ) {
			return(-1);
		}
		break;
	case	S_GOTO:
		if( do_goto() != 0 ) {
			return(-1);
		}
		break;
	case	S_BREAK:
		if( do_break() != 0 ) {
			return(-1);
		}
		break;
	case	S_CONTINUE:
		if( do_continue() != 0 ) {
			return(-1);
		}
		break;
	default:
		if( strcmp( Sym, ";" ) == 0 ) {
			SymRc = GetSym( (unsigned char *)Sym, &Code );
			break;
		}
		if( strcmp( Sym, "#asm" ) == 0 ) {
			if( do_asm() != 0 ) {
				return(-1);
			}
			break;
		}
		if( do_statement2() != 0 ) {
			return(-1);
		}
		break;
	}
	return(0);
}

/* #define xxxx */
int	do_define(void)
{
	ReplaceFlg = 0;	/* #define̒utO */
	if( GetSym( (unsigned char *)Sym, &Code ) != S_STR ) {
sprintf( ErrMsg1, "͕ɂKv܂ [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
		ReplaceFlg = 1;	/* #define̒utO */
		return(-1);
	}
	ReplaceFlg = 1;	/* #define̒utO */
	SymRc = GetSym( (unsigned char *)Sym2, &Code );
	if( SymRc != S_STR && !(SymRc > M_NUM_START && SymRc < M_NUM_END) ) {
sprintf( ErrMsg1, "͕񂩐lɂKv܂ [ %s ]", Sym2 );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( Pass == 1 ) {
		if( SearchHash( Sym ) != -1 ) {
sprintf( ErrMsg1, "Qd`ł [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		/* e[uɊi[ */
		Temp[0] = (unsigned char)SymRc;
		strcpy( &Temp[1], Sym2 );
		AddHash( Sym, (unsigned char *)Temp, ID_DEFINE );
//printf( "define o^ [%s] [%s]\n", Sym, Sym2 );
	}
	/* s܂Ői߂ */
	SetSymFp( Rfp );
	return(0);
}

int	pin_convert( char *msg, unsigned char *data )
{
	int		cnt, pin;

	cnt = 0;
	msg++;
	memset( data, 0xff, 16 );
	while( *msg != '"' ) {
		if( toupper( *msg ) == 'P' ) {
			/* |[g̒ڎw*/
			msg++;
			pin = getbit2( msg );
			if( pin == -1 ) {
sprintf( ErrMsg1, "|[gArbg̒ڎwɊԈႢ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			msg += 2;
			if( cnt >= 16 ) {
sprintf( ErrMsg1, "ݒł̂͂PUrbgł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			data[cnt] = (unsigned char)pin;
			cnt++;
		} else if( isdigit(*msg) ) {
			if( sscanf( msg, "%d", &pin ) != 1 ) {
sprintf( ErrMsg1, "sԍw肳Ă܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			if( cnt >= 16 ) {
sprintf( ErrMsg1, "ݒł̂͂PUrbgł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			if( pin < 1 || pin > 40 ) {
sprintf( ErrMsg1, "sԍ͂P`SO܂łł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			if( (data[cnt] = (unsigned char)pinno2port( (unsigned char)pin )) == 0xff ) {
sprintf( ErrMsg1, "sԍ|[gԍɕϊł܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			cnt++;
			while( isdigit(*msg) ) {
				msg++;
			}
		} else {
sprintf( ErrMsg1, "sԍ̎w@ԈĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		if( *msg == ',' ) {
			msg++;
		}
	}
	return(0);
}

int	do_port(void)
{
	int		n;

	if( GetSym( (unsigned char *)Sym, &Code ) != S_STR ) {
sprintf( ErrMsg1, "|[gw肳Ă܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( GetSym( (unsigned char *)Sym2, &Code ) != S_MSG ) {
sprintf( ErrMsg1, "|[gwtH[}bgԈĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	/* s܂Ői߂ */
	SetSymFp( Rfp );
	if( PortCounter >= 3 ) {
sprintf( ErrMsg1, "|[gwł̂͂PUrbg~R܂łł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( pin_convert( Sym2, &image[PortCounter*20+4] ) != 0 ) {
		return(-1);
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		OutputPort[PortCounter] = 1;	/* |[g`o͂ǂ̃`FbNp */
		fprintf( Wfp1, "\t.ORG\tMEMORYTOP+%d\n", PortCounter*20 );
		fprintf( Wfp1, "\t.DATA.B\t0,0,255,255\n" );
		fprintf( Wfp1, "\t.DATA.B\t" );
		for( n=0; n<16; n++ ) {
			fprintf( Wfp1, "%d", image[PortCounter*20+4+n] );
			if( n == 15 ) {
				fprintf( Wfp1, "\n" );
			} else {
				fprintf( Wfp1, "," );
			}
		}
	}

	/* O[oϐƂēo^Ă */
	sprintf( Temp, "%d", PortCounter*20 );
	AddHash( Sym, (unsigned char *)Temp, S_WORD );
	sprintf( Temp2, "%s.dir", Sym );
	sprintf( Temp, "%d", PortCounter*20+2 );
	AddHash( Temp2, (unsigned char *)Temp, S_WORD );
	for( n=0; n<16; n++ ) {
		if( image[PortCounter*20 + 4 + 15-n ] != 0xff ) {
			sprintf( Temp2, "%s%d", Sym, n );
			/* temp ɂ̓|[gϊf[^i[ */
			sprintf( Temp, "%d", PortCounter*20 + 4 + 15-n );
			AddHash( Temp2, (unsigned char *)Temp, S_BOOL );
			sprintf( Temp2, "%s%d.dir", Sym, n );
			sprintf( Temp, "%d", PortCounter*20 + 4 + 15-n );
			AddHash( Temp2, (unsigned char *)Temp, S_BOOL );
		}
	}
	PortCounter++;
	return(0);
}

int	check_value( char *sym )
{
	if( stricmp( sym, "BYTE" ) == 0 ) {
		return( S_BYTE );
	}
	if( stricmp( sym, "WORD" ) == 0 ) {
		return( S_WORD );
	}
	return(0);
}

void	jmp_main(void)	/* main()ւ̃Wvo */
{
	int		i;

	if( Pass == 2 && Wfp1 != NULL ) {

		for( i=0; i<3; i++ ) {
			if( OutputPort[i] == 0 ) {	/* |[g`o͂ǂ̃`FbNp */
				fprintf( Wfp1, "\t.ORG\tMEMORYTOP+%d\n", i*20 );
				fprintf( Wfp1, "\t.DATA.B\t0,0,255,255\n" );
				fprintf( Wfp1, "\t.DATA.B\t255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255\n" );
			}
		}

		fprintf( Wfp1, "\t.ORG\tMEMORYTOP+%d\n", 60 );
		fprintf( Wfp1, "\t.DATA.B\tH'01\t;compile mode\n" );
		fprintf( Wfp1, "\t.DATA.B\tH'%02X\t;Board Number(0-2)\n", BoardNum );
		fprintf( Wfp1, "\tJMP\t@_main:24\n" );
		fprintf( Wfp1, "\t.ORG\tMEMORYTOP+%d\n", 66 );
	}
}

int	do_global(void)	/* O[oϐ֐錾 */
{
	int		type, rc, i, blen;
	long	dlen, bsize;

	if( strcmp( Sym, "#port" ) == 0 ) {
		if( GlobalStatus != 0 ) {	/* 0:port錾A1:O[oϐdefine`A2:R[h */
sprintf( ErrMsg1, "#port `͕ϐ^R[h錾̑Oɍsĉ" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		return( do_port() );
	}
	if( strcmp( Sym, "#define" ) == 0 ) {
		if( GlobalStatus == 2 ) {	/* 0:port錾A1:O[oϐdefine`A2:R[h */
sprintf( ErrMsg1, "#define `̓R[h錾̑Oɍsĉ" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}

		/* compile */
		if( GlobalStatus == 0 ) {
			jmp_main();	/* main()ւ̃Wvo */
		}

		GlobalStatus = 1;	/* 0:port錾A1:O[oϐdefine`A2:R[h */
		return( do_define() );
	}
	type = check_value( Sym );
	if( type > 0 ) {
		if( GlobalStatus == 2 ) {	/* 0:port錾A1:O[oϐdefine`A2:R[h */
sprintf( ErrMsg1, "ϐ`̓R[h錾̑Oɍsĉ" );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}

		/* compile */
		if( GlobalStatus == 0 ) {
			jmp_main();	/* main()ւ̃Wvo */
		}

		GlobalStatus = 1;	/* 0:port錾A1:O[oϐdefine`A2:R[h */
		do {
			rc = GetSym( (unsigned char *)Sym, &Code );
			if( rc != S_STR ) {
sprintf( ErrMsg1, "ϐw肳Ă܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			/* ϐ̎̃f[^o */
			SymRc = GetSym( (unsigned char *)Sym2, &Code );
			Code = 0;
			if( Pass == 1 ) {
				if( SearchHash( Sym ) != -1 ) {
sprintf( ErrMsg1, "Qd`ł [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				/* ϐ̃AhX̓pXPŊm */
				sprintf( Temp, "%d", image_ptr );
//printf( "%s = %d\n", Sym, image_ptr );
				if( SymRc == S_LBRCKT ) {	/* z̒` */
					if( type == S_BYTE ) {
						AddHash( Sym, (unsigned char *)Temp, ID_ARRAY );
					} else {
						AddHash( Sym, (unsigned char *)Temp, ID_ARRAYW );
					}
				} else {
					AddHash( Sym, (unsigned char *)Temp, (unsigned char)type );
				}
			}

			/* compile */
			if( Pass == 2 && Wfp1 != NULL ) {
				fprintf( Wfp1, "_%s:\n", Sym );
			}

			if( SymRc == S_LBRCKT ) {	/* z̒` */
				SymRc = GetSym( (unsigned char *)Sym2, &Code );
				bsize = (int)Code;

				if( SymRc == S_RBRCKT ) {
					/* TCYw͏lōsĂ */
					bsize = 0;	/* BYTE AAA[] = "ABCD"; `ɑΉ */
				} else if( SymRc == M_CHAR || SymRc == M_INT ) {
					if( type == S_WORD ) {
						/* compile */
						if( Pass == 2 && Wfp1 != NULL ) {
							if( image_ptr&1 ) {
sprintf( ErrMsg1, "WORDϐ͋Ԓnn܂悤ɒĉ" );
sprintf( ErrMsg2, "line %d", __LINE__ );
								return(-1);
							}
						}
						bsize *= 2;
					}
					SymRc = GetSym( (unsigned char *)Sym2, &Code );
				} else {
sprintf( ErrMsg1, "zTCY͒萔ɂKv܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				if( SymRc != S_RBRCKT ) {
sprintf( ErrMsg1, "z̕ʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				SymRc = GetSym( (unsigned char *)Sym2, &Code );
				if( SymRc == M_EQL ) {
					SymRc = GetSym( (unsigned char *)Sym2, &Code );
					if( SymRc == S_MSG ) {
						blen = strlen(Sym2)-1;
						Sym2[blen] = 0;	/* " -> 0x00 */
						if( type == S_WORD && (blen%2) != 0 ) {
							blen++;	/* WORDEɂ */
						}
						for( i=1; i<=blen; i++ ) {
							/* S_BYTE, S_WORD ɓ@Ŋi[ */
							image[image_ptr++] = (unsigned char)(Sym2[i]);

							/* compile */
							if( Pass == 2 && Wfp1 != NULL ) {
								fprintf( Wfp1, "\t.DATA.B\t%d\n", Sym2[i] );
							}
						}
					} else if( SymRc == S_LBRACE ) {
						blen = 0;
						while( 1 ) {
							SymRc = GetSym( (unsigned char *)Sym2, &Code );
							if( type == S_BYTE && SymRc != M_CHAR ) {
sprintf( ErrMsg1, "lBYTE͈̔͂𒴂Ă܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
								return(-1);
							}
							if( type == S_WORD && SymRc != M_CHAR && SymRc != M_INT ) {
sprintf( ErrMsg1, "lWORD͈̔͂𒴂Ă܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
								return(-1);
							}
							switch( type ) {
							case	S_BYTE:
								image[image_ptr] = (unsigned char)(Code&0xff);

								/* compile */
								if( Pass == 2 && Wfp1 != NULL ) {
									fprintf( Wfp1, "\t.DATA.B\t%d\n", Code&0xff );
								}

								image_ptr++;
								break;
							case	S_WORD:
								image[image_ptr  ] = (unsigned char)((Code>>8)&0xff);
								image[image_ptr+1] = (unsigned char)(Code&0xff);

								/* compile */
								if( Pass == 2 && Wfp1 != NULL ) {
									fprintf( Wfp1, "\t.DATA.W\t%d\n", Code&0xffff );
								}

								image_ptr+=2;
								break;
							}
							SymRc = GetSym( (unsigned char *)Sym2, &Code );
							blen++;
							if( SymRc == S_RBRACE ) {
								break;
							} else if( SymRc != S_COMMA ) {
sprintf( ErrMsg1, "l̏ɊԈႢ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
								return(-1);
							}
						}
					} else {
sprintf( ErrMsg1, "l̏ɊԈႢ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					if( bsize > blen ) {
						image_ptr += (bsize-blen);

						/* compile */
						if( Pass == 2 && Wfp1 != NULL ) {
							fprintf( Wfp1, "\t.RES.B\t%d\n", bsize-blen );
						}

					} else if( bsize != 0 && bsize < blen ) {
sprintf( ErrMsg1, "zTCYsĂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					bsize = 0;

					SymRc = GetSym( (unsigned char *)Sym2, &Code );
				}

				if( bsize ) {
					/* compile */
					if( Pass == 2 && Wfp1 != NULL ) {
						fprintf( Wfp1, "\t.RES.B\t%d\n", bsize );
					}

					image_ptr += bsize;
				}

				if( SymRc != S_COMMA && SymRc != S_SEMICOL ) {
sprintf( ErrMsg1, "J}Z~R܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				if( image_ptr >= PROG_MAX ) {
sprintf( ErrMsg1, "ővOTCY𒴂܂ [ %d ]", image_ptr );
					return(-1);
				}
				if( image_ptr >= OVERLAY_MAX ) {
sprintf( ErrMsg1, "ővOTCY𒴂܂(overlay) [ %d ]", image_ptr );
					return(-1);
				}

			} else {
				if( SymRc == M_EQL ) {
					SymRc = GetSym( (unsigned char *)Sym2, &Code );
					if( type == S_BYTE && SymRc != M_CHAR ) {
sprintf( ErrMsg1, "lBYTE͈̔͂𒴂Ă܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					if( type == S_WORD && SymRc != M_CHAR && SymRc != M_INT ) {
sprintf( ErrMsg1, "lWORD͈̔͂𒴂Ă܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
						return(-1);
					}
					SymRc = GetSym( (unsigned char *)Sym2, &Code );
				}
				if( SymRc != S_COMMA && SymRc != S_SEMICOL ) {
sprintf( ErrMsg1, "J}Z~R܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
				/* imageւ̏ */
				switch( type ) {
				case	S_BYTE:
					image[image_ptr] = (unsigned char)(Code&0xff);

					/* compile */
					if( Pass == 2 && Wfp1 != NULL ) {
						fprintf( Wfp1, "\t.DATA.B\t%d\n", Code&0xff );
					}

					image_ptr++;
					break;
				case	S_WORD:
					image[image_ptr  ] = (unsigned char)((Code>>8)&0xff);
					image[image_ptr+1] = (unsigned char)(Code&0xff);

					/* compile */
					if( Pass == 2 && Wfp1 != NULL ) {
						if( image_ptr&1 ) {
sprintf( ErrMsg1, "WORDϐ͋Ԓnn܂悤ɒĉ" );
sprintf( ErrMsg2, "line %d", __LINE__ );
							return(-1);
						}
						fprintf( Wfp1, "\t.DATA.W\t%d\n", Code&0xffff );
					}

					image_ptr+=2;
					break;
				}
			}
		} while( SymRc != S_SEMICOL );
		return(0);
	}
	/* ֐錾 */
	if( GlobalStatus != 2 ) {

		/* compile */
		if( GlobalStatus == 0 ) {
			jmp_main();	/* main()ւ̃Wvo */
		}

		/* _vpɃR[hJnAhXLĂ */
		code_start = image_ptr;

		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			fprintf( Wfp2, "\n" );
			fprintf( Wfp2, "\t.ALIGN\t2\n" );
		}

	}
	GlobalStatus = 2;	/* 0:port錾A1:O[oϐdefine`A2:R[h */

	/* t[mF */
	if( strcmp( Sym, "#frame" ) == 0 ) {
		if( Pass == 1 ) {
			if( overlay_frame > 15 ) {
sprintf( ErrMsg1, "I[oC 15 ܂łł" );
sprintf( ErrMsg2, "line %d", __LINE__ );
				return(-1);
			}
			/* t[AhX̕ۑ */
			frame_length[overlay_frame] = image_ptr-frame_start[overlay_frame];

			if( overlay_frame == 0 ) {
				if( image_ptr > PROG_MAX ) {
sprintf( ErrMsg1, "%d t[̃TCY %d 𒴂܂ [ %d ]",
					overlay_frame, PROG_MAX, image_ptr );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
			} else {
				/* ݂̃t[TCYvZ */
				dlen = frame_length[0] + frame_length[overlay_frame];
				if( dlen > PROG_MAX ) {
sprintf( ErrMsg1, "%d t[̃TCY %d 𒴂܂ [ %d(base) + %d = %d ]",
					overlay_frame, PROG_MAX, frame_length[0],
					frame_length[overlay_frame], dlen );
sprintf( ErrMsg2, "line %d", __LINE__ );
					return(-1);
				}
			}
		}

		/* compile */
		if( Pass == 2 && Wfp1 != NULL ) {
			/* t[ʒupxo͂ */
			fprintf( Wfp2, "\n" );
			fprintf( Wfp2, "frame_%d:\n", overlay_frame_count );
			overlay_frame_count++;
		}

		if( Pass == 1 ) {
			overlay_frame++;
			frame_start[overlay_frame] = image_ptr;
		}
		return(0);
	}

	if( GetSym( (unsigned char *)Sym2, &Code ) != S_LPAR ) {
sprintf( ErrMsg1, "֐̍ʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( GetSym( (unsigned char *)Sym2, &Code ) != S_RPAR ) {
sprintf( ErrMsg1, "֐̉Eʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	if( GetSym( (unsigned char *)Sym2, &Code ) != S_LBRACE ) {
sprintf( ErrMsg1, "֐̍ʂ܂" );
sprintf( ErrMsg2, "line %d", __LINE__ );
		return(-1);
	}
	/* ֐ƃAhXi[ */
	if( Pass == 1 ) {
		rc = SearchHash( Sym );
		if( rc != -1 && rc != ID_PROTO ) {
			/* QƂłȂ̂ňُ */
sprintf( ErrMsg1, "Qd`ł [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
	} else {
		/* main̂ݎsJnAhX̏Ɋi[Ă */
		if( strcmp( Sym, "main" ) == 0 ) {
			image[IMAGE_MAIN+0] = GOTO;
			get_real_adrs(image_ptr);
			image[IMAGE_MAIN+1] = (unsigned char)real_high;
			image[IMAGE_MAIN+2] = (unsigned char)real_low;
		}
		if( func_ptr >= FUNC_MAX ) {
sprintf( ErrMsg1, "֐̍őo^\ [ %d ] ܂łł", FUNC_MAX );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		if( strlen( Sym ) >= 50 ) {
sprintf( ErrMsg1, "֐͂TO܂łł [ %s ]", Sym );
sprintf( ErrMsg2, "line %d", __LINE__ );
			return(-1);
		}
		strcpy( func_name[func_ptr], Sym );
		func_adr[func_ptr] = (unsigned long)get_real_adrs(image_ptr);
		func_ptr++;
	}

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\n_%s:\n", Sym );
	}

	sprintf( Temp, "%d", image_ptr );
	AddHash( Sym, (unsigned char *)Temp, ID_FUNC );
	SymRc = GetSym( (unsigned char *)Sym, &Code );

	while( SymRc != S_RBRACE ) {
		if( do_statement() != 0 ) {
			return(-1);
		}
	}
	image[image_ptr++] = FUNC_END;	/* ֐̏I */

	/* compile */
	if( Pass == 2 && Wfp1 != NULL ) {
		fprintf( Wfp2, "\tRTS\n" );
	}

	return(0);
}

void	SetFunc( char *name, int id, char *param )	/* ֐` */
{
	char	buff[100];

	sprintf( buff, "%02d%s", id, param );
	AddHash( name, (unsigned char *)buff, ID_INFUNC );
}

int	cc_main( char *name, char *asm_name, FILE *fp, char *msg1, char *msg2, char *msg3, int linenum )
{
	int		i, rc, dt;
	long	fp_adr;
	long	dlen;

	/* G[bZ[W\p */
	*ErrMsg1 = 0;
	*ErrMsg2 = 0;
    *msg1 = 0;
    *msg2 = 0;
    *msg3 = 0;

	InitHash();			/* nbVe[ȕ */

	/* n[hEFA`t@Cǂݍ */
	Pass = 1;	/* do_define()gp邽Pass=1ɂ */
	if( deffileload( name ) == -1 ) {
sprintf( msg1, "n[hEFA`t@Cǂݍُ݈ł[%s]", name );
		return(-2);
	}

	/* compile */
	Wfp1 = NULL;			/* RpCʏop */
	Wfp2 = NULL;
	if( asm_name != NULL && *asm_name ) {
		if( (Wfp1=fopen( asm_name, "w" )) == NULL ) {
sprintf( msg1, "o̓t@CI[vł܂[%s]", asm_name );
			return(-2);
		}
		if( (Wfp2=tmpfile()) == NULL ) {
sprintf( msg1, "e|t@CI[vł܂" );
			fclose( Wfp1 );
			return(-2);
		}
	}

	/* t|[h͗p̏ */
	pol_init();
	for( i=0; i<PC_MAX; i++ ) {
		Pp[i] = Pd[i];
	}
/* \ݒ */
AddHash( "if",       NULL, S_IF );
AddHash( "goto",     NULL, S_GOTO );
AddHash( "else",     NULL, S_ELSE );
AddHash( "while",    NULL, S_WHILE );
AddHash( "do",       NULL, S_DO );
AddHash( "break",    NULL, S_BREAK );
AddHash( "continue", NULL, S_CONTINUE );
/* ֐ݒ */
/* B:BYTE^Cv̕ϐ */
/* W:WORD^Cv̕ϐ */
/* P:W^Cv̕ϐK{ƂӖŎgp */
/* S:̎w */
/* A:zϐ̎w */
/* C:B,W,|[gϐ̎w肪\ */
/*  1   -> No1,^[,Byte^̈Kv */
/* 12BL -> No12,Bytelă^[,Long^̈Kv */
/* ɎŝԂɂ */
/* ͏ȗ\ŁAȗ̓[ɂȂp[^ */
SetFunc( "Pulse",        fPulse,    " C"   );/* ϐInc() & Dec() */
SetFunc( "Inc",          fInc,      " C"   );/* ϐ̃CNg */
SetFunc( "Clear",        fClear,    " C"   );/* ϐ̃[NA */
SetFunc( "Dec",          fDec,      " C"   );/* ϐ̃fNg */
SetFunc( "DataDump",     fDataDump, " B"   );/* f[^̃_v */
SetFunc( "GetTimer",     fGetTimer, "W"    );/* ^C}[lǂݏo */
SetFunc( "SetTimer",     fSetTimer, "WWW"  );/* ^C}[lݒ */
SetFunc( "StartDump",    fStartDump," WWW" );/* f[^̃_vJn */
SetFunc( "EndDump",      fEndDump,  " "    );/* f[^̃_vI */
SetFunc( "return",       freturn,   " "    );/* ֐̏I */
SetFunc( "exit",         fexit,     " B"   );/* ȈՌI */
SetFunc( "SendByte",     fSendByte, " B"   );/* PoCgo */
SetFunc( "SendWord",     fSendWord, " W"   );/* QoCgo */
SetFunc( "SendHex",      fSendHex,  " B"   );/* PoCgóiPUiQj */
SetFunc( "SendCode",     fSendCode, " W"   );/* Xg{bNX\p̃bZ[Wԍ𑗐M */
SetFunc( "StartMsg",     fStartMsg, " "    );/* 񑗐M̊Jnʒm */
SetFunc( "SendMsg",      fSendMsg,  " S"   );/* w肳ꂽo */
SetFunc( "EndMsg",       fEndMsg,   " "    );/* 񑗐M̏Iʒm */
/* B:0-9:wA10-19:[߂ƌ(0-9)w */
SetFunc( "SendNum2Str",  fSendNum2Str," BW"  );/* lɂďo */
SetFunc( "InitIo",       fInitIo,   " "    );/* I/Ȍ */
SetFunc( "VppVolt",      fVppVolt,  " F"   );/* VPP̐ݒ */
SetFunc( "VccVolt",      fVccVolt,  " F"   );/* VCC̐ݒ */
SetFunc( "RecByte",      fRecByte,  "W"    );/* PoCg */
SetFunc( "NwRecByte",    fNwRecByte,"W"    );/* PoCg(no wait) */
/* P:W^Cv̕ϐK{ƂӖŎgp */
/* A:zϐ̎w */
SetFunc( "DataReq",      fDataReq,  "WWPPAP" );/* f[^͗v */
SetFunc( "Wait",         fWait,     "WWW" );/* w莞Ԃ̑҂ */
/* mset,mget WW = 16bit,16bit̃AhX */
SetFunc( "mset",         fmset,     " WWB" );/* ւ̏ */
SetFunc( "mget",         fmget,     "BWW" );/* ǂݏo(byte) */
SetFunc( "mgetw",        fmgetw,    "WWW" );/* ǂݏo(word) */
SetFunc( "GetClock",     fGetClock, "W"   );/* NbNǂݏo */
SetFunc( "SetClock",     fSetClock, "WW"  );/* NbNݒ */
SetFunc( "WaitExecEvent",fWaitExecEvent,"W"   );/* O̎swCxg̎MmF */
SetFunc( "Message",      fMessage,  " S"  );/* w肳ꂽo(header܂) */
SetFunc( "ee_write",     fee_write, "BWBb" );/* 24LC64 */
SetFunc( "ee_read",      fee_read,  "BWb"  );/* 24LC64ǂݏo */
SetFunc( "ee_prog",      fee_prog,  "B"    );/* 24LC64vO~O */
SetFunc( "ClockStart",   fClockStart," "   );/* NbN荞ݍĊJ */
SetFunc( "ClockStop",    fClockStop," "    );/* NbN荞ݒ~ */
SetFunc( "InitVolt",     fInitVolt, " "    );/* VPP/VCC̓d */
SetFunc( "time_set",     ftime_set, "WABw" );/* ̐ݒ */
SetFunc( "time_get",     ftime_get, "WAB"  );/* ̎擾 */
SetFunc( "time_cmp",     ftime_cmp, "WAA"  );/* ̔r */
SetFunc( "time_update",  ftime_update,"WAb");/* ̍XV */
SetFunc( "time_rstcarry",ftime_rstcarry," A");/* ̃L[tONA */
SetFunc( "memcpy",fmemcpy," AAW");			/* memcpy( dst, src, length ) */
	image_ptr = 0;

	Rfp = fp;
	fp_adr = ftell(Rfp)-1;
	memset( &image[0], 0xff, 60 );	/* portϐGA */
	memset( &image[0], 0, 2 );		/* portl̓̕[ŏ */
	memset( &image[20], 0, 2 );		/* portl̓̕[ŏ */
	memset( &image[40], 0, 2 );		/* portl̓̕[ŏ */
	image[IMAGE_MAIN+0] = PROG_END;
	image[IMAGE_MAIN+1] = 0;
	image[IMAGE_MAIN+2] = 0;
	image[CODE_TYPE] = 0;	/* C^v^ */

	func_ptr = 0;

	/* compile */
	if( Wfp1 != NULL ) {
		fprintf( Wfp1, ";assembler source for AASM Version 3.51\n" );
		fprintf( Wfp1, "\n" );
		fprintf( Wfp1, "\t.CPU\t300HA\n" );
		fprintf( Wfp1, "MEMORYTOP\t.EQU\tH'FEF10\n" );
		fprintf( Wfp1, "\n" );
		fprintf( Wfp1, "\t.INCLUDE %cH8FUNC.H%c\n", 34, 34 );
		fprintf( Wfp1, "\n" );
	}

	/* I[oC֘A */
	frame_start[0] = 0;		/* t[f[^̊i[JnAhX */
	frame_length[0] = 0;	/* t[f[^ */
	overlay_frame = 0;
	for( Pass=1; Pass<=2; Pass++ ) {
		GlobalStatus = 0;	/* 0:port錾A1:O[oϐdefine`A2:R[h */
		PortCounter = 0;
		memset( OutputPort, 0, sizeof( OutputPort ) );	/* |[g`o͂ǂ̃`FbNp */
		LoopCounter = 0;
		LoopNest = 0;
		image_ptr = IMAGE_START;
		code_start = 0;
		MsgCount = 0;	/* compile */

		/* I[oC֘A */
		overlay_frame_count = 0;

		SetLineNumber( linenum );	/* ǂݍ݃t@C̍sԍݒ肷 */
		fseek( Rfp, fp_adr, 0 );
		SetSymFp( Rfp );
		rc = 0;
		while( 1 ) {
			SymRc = GetSym( (unsigned char *)Sym, &Code );
			if( SymRc == S_EOF ) {
				break;
			}
			if( SymRc == S_ERR ) {
				break;
			}

			/* compile point  */
			if( Pass == 2 && Wfp1 != NULL ) {
				if( GlobalStatus != 2 ) {	/* 0:port錾A1:O[oϐdefine`A2:R[h */
					fprintf( Wfp1, ";%s\n", GetLineBuff() );
				} else {
					fprintf( Wfp2, ";%s\n", GetLineBuff() );
				}
			}

			if( SymRc == S_STR ) {
				if( do_global() != 0 ) {	/* O[oϐ֐錾 */
					rc = -1;
					break;
				}
				if( Pass == 1 ) {
					if( overlay_frame == 0 ) {
						if( Wfp1 != NULL ) {
							/* RpC͉̎ OVERLAY_MAX ̃TCYɂĂ */
							if( image_ptr > OVERLAY_MAX ) {
sprintf( ErrMsg1, "ővOTCY𒴂܂ [ %d ]", image_ptr );
								rc = -1;
								break;
							}
						} else {
							if( image_ptr > PROG_MAX ) {
sprintf( ErrMsg1, "ővOTCY𒴂܂ [ %d ]", image_ptr );
								rc = -1;
								break;
							}
						}
					} else {
						/* ݂̃t[TCYvZ */
						dlen = frame_length[0] + frame_length[overlay_frame];
						if( dlen > PROG_MAX ) {
sprintf( ErrMsg1, "%d t[̃TCY %d 𒴂܂ [ %d(base) + %d = %d ]",
							overlay_frame, PROG_MAX, frame_length[0],
							frame_length[overlay_frame], dlen );
sprintf( ErrMsg2, "line %d", __LINE__ );
							rc = -1;
							break;
						}
					}
					if( image_ptr >= OVERLAY_MAX ) {
sprintf( ErrMsg1, "ővOTCY𒴂܂(overlay) [ %d ]", image_ptr );
						rc = -1;
						break;
					}
				}
			} else {
sprintf( ErrMsg1, "ŊJnĂ܂BُłB" );
				rc = -1;
				break;
			}
		}
		if( rc == -1 ) {
			break;
		} else {
			image[image_ptr++] = PROG_END;	/* vȌI */

			if( Pass == 1 ) {
				/* ŏIt[ʒuۑ */
				frame_length[overlay_frame] = image_ptr - frame_start[overlay_frame];
				if( overlay_frame ) {
					overlay_frame++;
				}
			}
		}
	}
	SetSymFp( NULL );
	DestroyHash();		/* nbVe[ůJ */

	/* compile */
	if( Wfp1 != NULL ) {	/* RpCʏop */
		if( rc == 0 ) {
			if( image[IMAGE_MAIN+0] != GOTO ) {
				/* main()֐̂Ń_~[main()֐쐬Ă */
				fprintf( Wfp2, "\n_main:\n\tRTS\n" );
			}
		}
		rewind( Wfp2 );
		while( (dt=fgetc(Wfp2)) >= 0 ) {
			fputc( dt, Wfp1 );
		}
		fclose( Wfp2 );
		fprintf( Wfp1, "\t.END\n" );
		fclose( Wfp1 );
	}

	if( rc == 0 ) {
		/*sprintf( msg1, "vOTCY %d oCgł", image_ptr );*/
		sprintf( msg1, "Compiling normal completion !" );
	} else {
		if( *ErrMsg1 == 0 ) {
			strcpy( msg1, "G[" );
		} else {
			strcpy( msg1, ErrMsg1 );
		}
		strcpy( msg2, ErrMsg2 );
		sprintf( msg3, "%ld : %s", GetLineNumber(), GetLineBuff() );
	}
	return( rc );
}

int		MakeRom(char *outfile)
{
	int	i;
	FILE	*fp;

	if( (fp=fopen( outfile,"w" )) == NULL ) {
		printf( "file open error [%s]\n", outfile );
		return(-1);
	}
	for( i=0; i<16; i++ ) {
		ihex( 0, (long)(i*4+0), (unsigned char)((frame_start[i]+64)>>8), fp );
		ihex( 0, (long)(i*4+1), (unsigned char)((frame_start[i]+64)&0xff), fp );
		ihex( 0, (long)(i*4+2), (unsigned char)(frame_length[i]>>8), fp );
		ihex( 0, (long)(i*4+3), (unsigned char)(frame_length[i]&0xff), fp );
	}
	for( i=0; i<image_ptr; i++ ) {
		ihex( 0, (long)(i+64), (unsigned char)image[i], fp );
	}
	ihex_out( 0, fp );
	ihex_end( fp );
	fclose( fp );
	return( 0 );
}

int		InfSave( char *inffile, int asm_mode )	/* xxx.inf t@C̏o */
{
	int		i;
	long	adr;
	FILE	*fp;
	char	buff[256];

	/* ֐t@C̐ */
	if( (fp=fopen( inffile, "w" )) == NULL ) {
		printf( "file open error [%s]\n", inffile );
		return(-1);
	}

	fprintf( fp, "[Common]\n" );
	fprintf( fp, "size = %ld (%lXH)\n", (unsigned long)image_ptr, (unsigned long)image_ptr );
	fprintf( fp, "compile = %d\n", asm_mode );
	fprintf( fp, "\n" );

	fprintf( fp, "[Function]\n" );
	for( i=0; i<func_ptr; i++ ) {
		adr = func_adr[i];
		if( overlay_frame && asm_mode ) {
			if( adr < 0x100000 ) {
				/* frame ΉAhXɕϊ */
				adr = get_real_adrs_asm( adr );
			}
		}
		fprintf( fp, "%s = %ld (%lXH)\n", func_name[i], adr, adr );
	}
	fprintf( fp, "\n" );

	fprintf( fp, "[Overlay]\n" );
	fprintf( fp, "count = %d\n", overlay_frame );
	for( i=0; i<overlay_frame; i++ ) {
		if( asm_mode ) {
			/* RpCĂ鎞 */
			adr = frame_start[i] - 0xfef10;
		} else {
			/* C^v^̎ */
			adr = frame_start[i];
		}
		fprintf( fp, "frame%02d = %ld (%lXH)\n", i, adr, adr );
		fprintf( fp, "frame%02dlength = %ld (%lXH)\n", i, frame_length[i], frame_length[i] );
	}
	fprintf( fp, "\n" );
	fclose( fp );
	return(0);
}

int		InfLoad( char *inffile )	/* xxx.inf t@C̏ǂݏo */
{
	int		status, i;
	unsigned	long	udt;
	FILE	*fp;
	char	buff[256], pr[256], dmy[256];


	if( (fp=fopen( inffile, "r" )) == NULL ) {
		printf( "file open error [%s]\n", inffile );
		return(-1);
	}

	image_ptr = 0;
	func_ptr = 0;
	overlay_frame = 0;

	status = 0;
	while( fgets( buff, 256, fp ) != NULL ) {
		if( strnicmp( buff, "[Common]", 8 ) == 0 ) {
			status = 1;
			continue;
		} else if( strnicmp( buff, "[Function]", 10 ) == 0 ) {
			status = 2;
			continue;
		} else if( strnicmp( buff, "[Overlay]", 9 ) == 0 ) {
			status = 3;
			continue;
		}

		if( sscanf( buff, "%s %s %ld", pr, dmy, &udt ) != 3 ) {
			continue;
		}
		switch( status ) {
		case	1:
			if( stricmp( pr, "size" ) == 0 ) {
				image_ptr = udt;
				continue;
			}
			break;
		case	2:
			strcpy( func_name[func_ptr],  pr );
			/* AhX xxx.sym XV̂Ń[ɏĂ */
			func_adr[func_ptr] = 0;
			func_ptr++;
			break;
		case	3:
			if( strnicmp( pr, "frame", 5 ) == 0 ) {
				if( !isdigit(pr[5]) || !isdigit(pr[6]) ) {
					fclose( fp );
					printf( "file format error [%s]\n", inffile );
					return(-1);
				}
				i = (pr[5]-'0')*10+pr[6]-'0';
				if( stricmp( &pr[7], "length" ) == 0 ) {
					frame_length[i] = udt;
				} else {
					frame_start[i] = udt;
				}
				if( (i+1) > overlay_frame ) {
					overlay_frame = i+1;
				}
			}
			break;
		default:
			break;
		}
	}
	fclose( fp );

	if( overlay_frame == 0 ) {
		frame_length[0] = image_ptr;
	}

	return(0);
}

/* xxx.sym t@C̏ǂݏoăAhXXV */
int		SymLoad( char *symfile )
{
	FILE	*fp;
	int		i, counter;
	char	*ps, *p, buff[256];
	unsigned	long	adr;

	/* frame Ή */
	update_counter = 0;
	counter = 0;
	frame_start[counter] = 0xfef10;	/* t[f[^̊i[JnAhX */

	if( (fp=fopen( symfile, "r" )) == NULL ) {
		printf( "File open error [ %s ]\n", symfile );
		return(-1);
	}
	while( fgets( buff, 256, fp ) != NULL ) {
		ps = p = buff;
		while( isxdigit( *ps ) ) {
			while( isxdigit( *p ) ) {
				p++;
			}
			*p = 0;
			sscanf( ps, "%lx", &adr );
			ps = p+1;
			p++;
			while( *p && !isspace( *p ) ) {
				p++;
			}
			*p = 0;
			if( *ps == '_' ) {
				/* ֐͑S_t`ɂȂĂ̂_Ĕr */
				ps++;
				for( i=0; i<func_ptr; i++ ) {
					if( stricmp( func_name[i], ps ) == 0 ) {
						func_adr[i] = adr;
						break;
					}
				}
			} else {
				/* frame ̎擾(update_x_xframe_x`̏𒊏o) */
				if( strncmp( ps, "update_", 7 ) == 0 ) {
					/* XVΏۃAhXۑ */
					if( update_counter >= MAX_UPDATE_COUNT ) {
						fclose( fp );
						printf( "update_counter overflow!!! [ %d ]\n", update_counter );
						return(-1);
					}
					update_adrs[update_counter++] = adr;
				} else if( strncmp( ps, "frame_", 6 ) == 0 ) {
					/* frame ̋؂AhXۑ */
					frame_length[counter] = adr - frame_start[counter];
					counter++;
					frame_start[counter] = adr;
				}
			}
			ps = p+1;
			while( *ps && isspace( *ps ) ) {
				ps++;
			}
			p = ps;
		}
	}
	fclose( fp );

	frame_length[counter] = adr - frame_start[counter];

	for( i=0; i<func_ptr; i++ ) {
		if( func_adr[i] == 0 ) {
			printf( "[ %s ] not found\n", func_name[i] );
			return(-1);
		}
	}

	return(0);
}

int		Hex2Rom( char *infile )	/* xxx.hex -> xxx.rom ɏo */
{
	int i, flg;
	FILE	*fp;
	char	*ptr;
	unsigned	int	length;
	long	adr, offset;
	unsigned	char	data[1024];

	/* [ɓǂݍ */
	if( (fp=fopen( infile, "r" )) == NULL ) {
		printf( "File open error [ %s ]\n", infile );
		return(-1);
	}
	flg = 0;	/* f[^v */
	image_ptr = 0;
	for( ;; ) {
		length = 1000;	/* xɓǂݍލőf[^ */
		if( ReadData( flg, fp, &adr, data, (int *)&length ) != 0 ) {
			fclose( fp );
			printf( "t@Cǂݍ݂ňُ킪܂[ %s ]\n", infile );
			return(-1);
		}
		if( length == 0 ) {
			break;
		}
		flg = 1;	/* pf[^vɕύX */
		/* ǂݍ񂾃f[^imageɊi[ */
		offset = adr-0xfef10;
		if( (offset+length) >= PROG_MAX ) {
			fclose( fp );
			printf( "ővOTCY𒴂܂ [ %d ] ( max = %d )\n", offset+length, PROG_MAX );
			return(-1);
		}
		for( i=0; i<(int)length; i++ ) {
			image[offset+i] = data[i];
		}
		if( (int)(offset+length) > image_ptr ) {
			image_ptr = offset+length;
		}
	}
	fclose( fp );
	if( overlay_frame ) {
		/* frame ΉAhXɃRo[g */
		for( i=0; i<update_counter; i++ ) {
			/* AhX̒o */
			/* +3 = xۂ̃AhXĂ镔܂ł̃ItZbg */
			ptr = &image[ update_adrs[i] - 0xfef10 + 3 ];
			adr = ((unsigned char)ptr[0] << 16) + ((unsigned char)ptr[1] << 8) + (unsigned char)ptr[2];
			adr = get_real_adrs_asm( adr );
			ptr[0] = (adr>>16)&0xff;
			ptr[1] = (adr>>8)&0xff;
			ptr[2] = adr&0xff;
		}
	}
	printf( "RpCvOTCY %d oCgł\n", image_ptr );
	return(0);
}

int	Analysis( int adr )
{
	int		cnt;

	switch( image[adr] ) {
	case	CONST1:	printf( "CONST1(%d) ",	image[adr+1] );	return(2);
	case	CONST2:	printf( "CONST2(%d) ",	(image[adr+1]<<8)+image[adr+2] );	return(3);
	case	VAL1:	printf( "VAL1(%d) ",	(image[adr+1]<<8)+image[adr+2] );	return(3);
	case	VAL2:	printf( "VAL2(%d) ",	(image[adr+1]<<8)+image[adr+2] );	return(3);
	case	ARRAY:	printf( "ARRAY(%d)[ ",	(image[adr+1]<<8)+image[adr+2] );
			cnt = Analysis( adr+3 );		/* ItZbg */
			printf( "] " );
			return( 3+cnt );
	case	ARRAYW:	printf( "ARRAYW(%d)[ ",	(image[adr+1]<<8)+image[adr+2] );
			cnt = Analysis( adr+3 );		/* ItZbg */
			printf( "] " );
			return( 3+cnt );
	case	A_DT:	printf( "A_DT "  );	break;
	case	A_DIR:	printf( "A_DIR " );	break;
	case	B_DT:	printf( "B_DT "  );	break;
	case	B_DIR:	printf( "B_DIR " );	break;
	case	C_DT:	printf( "C_DT "  );	break;
	case	C_DIR:	printf( "C_DIR " );	break;
	case	LET:
			printf( "\n<%04d> ", adr );
			printf( "LET " );
			cnt = Analysis( adr+1 );			/*  */
			printf( "= Para(%d) ", image[adr+cnt+1] );/* p[^ */
			return( 1+cnt+1 );
	case	JUDGE:
			printf( "\n<%04d> ", adr );
			printf( "JUDGE(skip:%d) ", (image[adr+1]<<8)+image[adr+2] );
			printf( "Para(%d) ", image[adr+3] );	/* p[^ */
			return( 4 );
	case	GOTO:
			printf( "\n<%04d> ", adr );
			printf( "GOTO(%d) ",	(image[adr+1]<<8)+image[adr+2] );	return(3);
	case	CALL:
			printf( "\n<%04d> ", adr );
			printf( "CALL(%d) ",	(image[adr+1]<<8)+image[adr+2] );	return(3);
	case	CALLIN:
			printf( "\n<%04d> ", adr );
			printf( "CALLIN(" );
			switch( image[adr+1] ) {
			case	fPulse:			printf( "Pulse" );			break;
			case	fInc:			printf( "Inc" );			break;
			case	fClear:			printf( "Clear" );			break;
			case	fDec:			printf( "Dec" );			break;
			case	fDataDump:		printf( "DataDump" );		break;
			case	fGetTimer:		printf( "GetTimer" );		break;
			case	fSetTimer:		printf( "SetTimer" );		break;
			case	fStartDump:		printf( "StartDump" );		break;
			case	fEndDump:		printf( "EndDump" );		break;
			case	freturn:		printf( "return" );			break;
			case	fexit:			printf( "exit" );			break;
			case	fSendByte:		printf( "SendByte" );		break;
			case	fSendWord:		printf( "SendWord" );		break;
			case	fSendHex:		printf( "SendHex" );		break;
			case	fSendCode:		printf( "SendCode" );		break;
			case	fStartMsg:		printf( "StartMsg" );		break;
			case	fSendMsg:		printf( "SendMsg" );		break;
			case	fEndMsg:		printf( "EndMsg" );			break;
			case	fSendNum2Str:	printf( "SendNum2Str" );	break;
			case	fInitIo:		printf( "InitIo" );			break;
			case	fVppVolt:		printf( "VppVolt" );		break;
			case	fVccVolt:		printf( "VccVolt" );		break;
			case	fRecByte:		printf( "RecByte" );		break;
			case	fNwRecByte:		printf( "NwRecByte" );		break;
			case	fDataReq:		printf( "DataReq" );		break;
			case	fWait:			printf( "Wait" );			break;
			case	fmset:			printf( "mset" );			break;
			case	fmget:			printf( "mget" );			break;
			case	fmgetw:			printf( "mgetw" );			break;
			case	fGetClock:		printf( "GetClock" );		break;
			case	fSetClock:		printf( "SetClock" );		break;
			case	fWaitExecEvent:	printf( "WaitExecEvent" );	break;
			case	fMessage:		printf( "Message" );		break;
			case	fee_write:		printf( "ee_write" );		break;
			case	fee_read:		printf( "ee_read" );		break;
			case	fee_prog:		printf( "ee_prog" );		break;
			case	fClockStart:	printf( "ClockStart" );		break;
			case	fClockStop:		printf( "ClockStop" );		break;
			case	fInitVolt:		printf( "InitVolt" );		break;
			case	ftime_set:		printf( "time_set" );		break;
			case	ftime_get:		printf( "time_get" );		break;
			case	ftime_cmp:		printf( "time_cmp" );		break;
			case	ftime_update:	printf( "time_update" );	break;
			case	ftime_rstcarry:	printf( "time_rstcarry" );	break;
			case	fmemcpy:		printf( "memcpy" );	break;
			default:	printf( "%d", image[adr+1] );	break;
			}
			printf( ") " );
			return(2);
	case	M_INC+MATH_OFFSET:		printf( "++ " );	break;
	case	M_DEC+MATH_OFFSET:		printf( "-- " );	break;
	case	M_MODEQL+MATH_OFFSET:	printf( "%= " );	break;
	case	M_TIMESEQL+MATH_OFFSET:	printf( "*= " );	break;
	case	M_SLASHEQL+MATH_OFFSET:	printf( "/= " );	break;
	case	M_PLUSEQL+MATH_OFFSET:	printf( "+= " );	break;
	case	M_MINUSEQL+MATH_OFFSET:	printf( "-= " );	break;
	case	M_BITREV+MATH_OFFSET:	printf( "~ "  );	break;
	case	M_BITXOR+MATH_OFFSET:	printf( "^ "  );	break;
	case	M_NOT+MATH_OFFSET:		printf( "! "  );	break;
	case	M_ANDEQL+MATH_OFFSET:	printf( "&= " );	break;
	case	M_OREQL+MATH_OFFSET:	printf( "|= " );	break;
	case	M_XOREQL+MATH_OFFSET:	printf( "^= " );	break;
	case	M_ASSLEQL+MATH_OFFSET:	printf( "<<= ");	break;
	case	M_ASSREQL+MATH_OFFSET:	printf( ">>= ");	break;
	case	M_EQL+MATH_OFFSET:		printf( "= "  );	break;
	case	M_PLUS+MATH_OFFSET:		printf( "+ "  );	break;
	case	M_MINUS+MATH_OFFSET:	printf( "- "  );	break;
	case	M_SLASH+MATH_OFFSET:	printf( "/ "  );	break;
	case	M_TIMES+MATH_OFFSET:	printf( "* "  );	break;
	case	M_MOD+MATH_OFFSET:		printf( "% "  );	break;
	case	M_NEQ+MATH_OFFSET:		printf( "!= " );	break;
	case	M_GEQ+MATH_OFFSET:		printf( ">= " );	break;
	case	M_GTR+MATH_OFFSET:		printf( "> "  );	break;
	case	M_LEQ+MATH_OFFSET:		printf( "<= " );	break;
	case	M_LSS+MATH_OFFSET:		printf( "< "  );	break;
	case	M_CMP+MATH_OFFSET:		printf( "== " );	break;
	case	M_SHIFTL+MATH_OFFSET:	printf( "<< " );	break;
	case	M_SHIFTR+MATH_OFFSET:	printf( ">> " );	break;
	case	M_AND+MATH_OFFSET:		printf( "&& " );	break;
	case	M_BITAND+MATH_OFFSET:	printf( "& "  );	break;
	case	M_OR+MATH_OFFSET:		printf( "|| " );	break;
	case	M_BITOR+MATH_OFFSET:	printf( "| "  );	break;
	case	FUNC_END:
			printf( "\n<%04d> ", adr );
			printf( "FUNC_END\n" );	break;
	case	PROG_END:	printf( "PROG_END\n" );	return(0);
	default:
		if( image[adr] < 80 ) {
			printf( "BOOL(%d) ", image[adr] );
		} else if( image[adr] < 160 ) {
			printf( "BOOLD(%d) ", image[adr] );
		} else {
			printf( "?(%d) ", image[adr] );
		}
		break;
	}
	return(1);
}

void	ImageDump()
{
	int	i, j, cnt, adr;
	unsigned	char	*p;
	FILE	*fp;

	for( j=0; j<3; j++ ) {
		printf( "          data   dir  data(bit0 -> bit15)\n" );
		printf( "[port]  : %02X%02X : ", image[20*j], image[20*j+1] );
		printf( "%02X%02X ", image[20*j+2], image[20*j+3] );
		for( i=0; i<16; i++ ) {
			printf( "%02X ", image[20*j+4+i] );
		}
		printf( "\n" );
	}
	if( IMAGE_START != code_start ) {
		printf( "\n[value]\n" );
	}
	for( i=IMAGE_START; i<code_start; i++ ) {
		printf( "%02X ", image[i] );
		if( (i%16) == 15 ) {
			printf( "\n" );
		}
	}
	printf( "\n" );
	printf( "[code]  (start = %d )\n", code_start );
	for( i=0; i<func_ptr; i++ ) {
		printf( "%s = %ld\n", func_name[i], func_adr[i] );
	}

	adr = code_start;
	do {
		cnt = Analysis( adr );
		adr += cnt;
	} while( cnt != 0 );

	printf( "\n" );
	printf( "gp %d bytes\n", image_ptr );
	for( i=0; i<overlay_frame; i++ ) {
		printf( "frame %d   adr = %d   length = %d\n", i, frame_start[i], frame_length[i] );
	}
}

void	help()
{
	printf( "<<< example 1 >>>   xxx.c -> xxx.rom xxx.inf\n" );
	printf( ">devicec xxx.c [-Configfile]\n" );

	printf( "<<< example 2 >>>   xxx.c -> xxx.asm xxx.inf\n" );
	printf( ">devicec xxx.c [-Configfile] -a\n" );

	printf( "<<< example 3 >>>   xxx.hex xxx.sym xxx.inf -> xxx.rom xxx.inf\n" );
	printf( ">devicec xxx.hex\n" );

}

int	main( int argc, char *argv[] )
{
	FILE	*fp;
	int		i, rc, linenum;
	int		asm_mode;
	int		debug;
	char	*infile, *conffile, *p;
	char	outfile[512];
	char	asmfile[512];
	char	inffile[512];
	char	symfile[512];
	char	msg1[128], msg2[128], msg3[128];

	printf( "%s", TITLE );
	if( argc < 2 ) {
		help();
		return(1);
	}

	infile = NULL;
	conffile = NULL;
	BoardNum = 0;
	asm_mode = 0;
	debug = 0;
	for( i=1; i<argc; i++ ) {
		if( strcmp( argv[i], "-a" ) == 0 || strcmp( argv[i], "-A" ) == 0 ) {
			asm_mode = 1;
		} else if( strcmp( argv[i], "-g" ) == 0 || strcmp( argv[i], "-G" ) == 0 ) {
			debug = 1;
		} else if( *argv[i] == '-' ) {
			if( conffile != NULL ) {
				help();
				return(1);
			}
			conffile = &argv[i][1];
		} else {
			if( infile != NULL ) {
				help();
				return(1);
			}
			infile = argv[i];
		}
	}

	if( infile == NULL ) {
		help();
		return(1);
	}

#ifdef	MALLOC
	if( (image=(unsigned char *)malloc(OVERLAY_MAX+256)) == NULL ) {
		printf( "There is not a sufficient memory.\n" );
		return(1);
	}
#endif

	if( conffile == NULL ) {
		conffile = "control.dat";
	}

	/* o̓t@C̓t@C琶 */
	strcpy( inffile, infile );
	if( (p=strrchr(inffile,'.')) != NULL ) {
		strcpy( p, ".inf" );
	} else {
		printf( "gq̖t@C͎gpł܂\n" );
		return(1);
	}

	strcpy( outfile, infile );
	p = strrchr(outfile,'.');
	if( asm_mode == 0 ) {
		strcpy( p, ".rom" );
	} else {
		strcpy( p, ".asm" );
	}

	if( strcmp( infile, outfile ) == 0 ) {
		printf( "t@C̊gqύXĉ\n" );
		return(1);
	}

	p = strrchr(infile,'.');
	if( stricmp( p, ".hex" ) == 0 ) {
		/* xxx.hex + xxx.sym + xxx.inf -> xxx.rom + xxx.inf */
		strcpy( symfile, infile );
		p = strrchr(symfile,'.');
		strcpy( p, ".sym" );

		/* xxx.inf t@C̏ǂݏo */
		if( InfLoad( inffile ) != 0 ) {
			return(1);
		}

		/* xxx.sym t@C̏ǂݏoăAhXXV */
		if( SymLoad( symfile ) != 0 ) {
			return(1);
		}

		/* XVAhX xxx.inf t@C̏o */
		if( InfSave( inffile, 1 ) != 0 ) {
			return(1);
		}

		/* xxx.hex -> xxx.rom ɏo */
		if( Hex2Rom( infile ) != 0 ) {
			return(1);
		}

		/* f[^t@C̐ */
		if( MakeRom( outfile ) != 0 ) {
			return(1);
		}

		return( 0 );
	}

	if( (fp=fopen( infile, "r" )) == NULL ) {
		printf( "file open error [%s]\n", infile );
		return(1);
	}
	rc = -1;
	linenum = 0;
	while( fgets( Temp, 512, fp ) != NULL ) {
		if( strnicmp( Temp, "[CODE]", 6 ) == 0 ) {
			rc = 0;
			break;
		}
		linenum++;
	}
	if( rc != 0 ) {
		printf( "[CODE] ̃Gg[܂\n" );
		fclose( fp );
		return(1);
	}

	if( asm_mode == 0 ) {
		/* xxx.c -> xxx.rom + xxx.inf */
		rc = cc_main( conffile, NULL, fp, msg1, msg2, msg3, linenum );
	} else {
		/* xxx.c -> xxx.asm + xxx.inf */
		rc = cc_main( conffile, outfile, fp, msg1, msg2, msg3, linenum );
	}
	fclose( fp );

	if( rc == 0 ) {
		/* I */
		if( InfSave( inffile, asm_mode ) != 0 ) {	/* xxx.inf t@C̏o */
			return(1);
		}

		if( asm_mode == 0 ) {
			/* fobOpɃ_v */
			if( debug ) {
				ImageDump();
			}
			/* f[^t@C̐ */
			if( MakeRom(outfile) != 0 ) {
				return(1);
			}
		}
	} else {
		rc = 1;
	}

	/* sʂ̕\ */
	if( *msg1 ) {
		printf( "%s\n", msg1 );
	}
	if( *msg2 ) {
		printf( "%s\n", msg2 );
	}
	if( *msg3 ) {
		printf( "%s\n", msg3 );
	}
	return(rc);
}
