#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	"control.h"

#include	"sym.h"
#include	"sym2.h"


/* control.c */
extern	unsigned	int	Wait(unsigned int w1, unsigned int w2);
extern	unsigned	int	GetTimer(void);
extern	unsigned	int	SetTimer(unsigned int w1, unsigned int w2);
extern	unsigned	char	ee_read(unsigned int adr, unsigned char dev);
extern	unsigned	char	ee_write(unsigned int adr, unsigned char data, unsigned char dev);
extern	unsigned	int	GetClock(void);
extern	unsigned	int	SetClock(unsigned int w);
extern	unsigned	int	time_cmp(unsigned char *data1, unsigned char *data2);
extern	unsigned	int	time_update(unsigned char *data, unsigned char updown);
extern	void	time_rstcarry(unsigned char *data);
extern	unsigned	int	time_set(unsigned char *data, unsigned char flg, unsigned int dt);
extern	unsigned	int	time_get(unsigned char *data, unsigned char flg);
extern	void	SendByte(int ch);
extern	void	initvolt(void);
extern	void	VccVolt(int d);
extern	void	VppVolt(int d);
extern	int	RecByte(void);
extern	int	NwRecByte(void);
extern	void	SendEvent(int id);
extern	void	SendCode(unsigned int num);
extern	unsigned	char	ee_prog(void);
extern	void	StartDump(unsigned int adH,unsigned int adL,unsigned int size);
extern	void	DataDump(unsigned char data);
extern	void	EndDump(void);
extern	int	DataReq(unsigned int flg, unsigned char *adrH, unsigned char *adrL, unsigned char *data, unsigned char *len);
extern	unsigned	int	WaitExecEvent(void);
extern	void	SendHex(unsigned char d);
extern	void	SendNum2Str(unsigned int fmt, unsigned int dt);
extern	unsigned	int	PageLoad(unsigned int page);
extern	unsigned	int	time_cmp(unsigned char *data1,unsigned char *data2);
extern	unsigned	int	time_update(unsigned char *data,unsigned char updown);
extern	void	time_rstcarry(unsigned char *data);
extern	unsigned	int	time_set(unsigned char *data,unsigned char flg,unsigned int dt);
extern	unsigned	int	time_get(unsigned char *data,unsigned char flg);


/* execute.c */
extern	void	inc_port_data(unsigned int adr);
extern	void	inc_port_tris(unsigned int adr);
extern	void	dec_port_data(unsigned int adr);
extern	void	dec_port_tris(unsigned int adr);
extern	void	set_port(unsigned char type, unsigned int data);
extern	unsigned	int	get_port_data(unsigned char type);

/* execute2.c */
unsigned	int	fGetExitCode(void);
void	fGetData(void);
void	fSetData(void);
void	fPulse(void);
void	fInc(void);
void	fDec(void);
void	fClear(void);
void	fDataDump(void);
void	fGetTimer(void);
void	fSetTimer(void);
void	fStartDump(void);
void	fEndDump(void);
void	fSendByte(void);
void	fSendWord(void);
void	fSendHex(void);
void	fSendCode(void);
void	fStartMsg(void);
void	fSendMsg(void);
void	fEndMsg(void);
void	fMessage(void);
void	fSendNum2Str(void);
void	fInitIo(void);
void	fInitVolt(void);
void	fVppVolt(void);
void	fVccVolt(void);
void	fRecByte(void);
void	fNwRecByte(void);
void	fDataReq(void);
void	fWait(void);
void	fmset(void);
void	fmget(void);
void	fmgetw(void);
void	fGetClock(void);
void	fSetClock(void);
void	fWaitExecEvent(void);
void	fee_write(void);
void	fee_read(void);
void	fee_prog(void);
void	fOverlayStart(void);
void	fOverlayEnd(void);
void	ftime_set(void);
void	ftime_get(void);
void	ftime_cmp(void);
void	ftime_update(void);
void	ftime_rstcarry(void);
void	fmemcpy(void);


extern	volatile	unsigned	int		Nest_adr[NEST_MAX];
extern	volatile	unsigned	char	Nest;

extern	volatile	unsigned	int	p0w, p1w, p2w, p3w, p4w;
extern	volatile	unsigned	int	ProgPage;	/* ǂݍłvÕy[W */

/* control.c R[ */
unsigned	int	fGetExitCode(void)
{
	return( p0w );
}

void	fGetData(void)	/* w|[gϐ̃f[^擾 */
{
	p0w = get_port_data( (unsigned char)p0w );
}
void	fSetData(void)	/* w|[gϐɃf[^ݒ肷 */
{
	set_port( (unsigned char)p1w, p0w );
}
void	fPulse(void)	/* Pulse, W, ϐInc() & Dec() */
{
	/* ɂ̂̓|[gϐɂĂ̂ */
	switch( (unsigned char)p0w ) {
	case	A_DT:	inc_port_data(  0 );	dec_port_data(  0 );	return;
	case	A_DIR:	inc_port_tris(  2 );	dec_port_tris(  2 );	return;
	case	B_DT:	inc_port_data( 20 );	dec_port_data( 20 );	return;
	case	B_DIR:	inc_port_tris( 22 );	dec_port_tris( 22 );	return;
	case	C_DT:	inc_port_data( 40 );	dec_port_data( 40 );	return;
	case	C_DIR:	inc_port_tris( 42 );	dec_port_tris( 42 );	return;
	default:	return;
	}
}
void	fInc(void)	/* Inc, W, ϐ̃CNg */
{
	/* ɂ̂̓|[gϐɂĂ̂ */
	switch( (unsigned char)p0w ) {
	case	A_DT:	inc_port_data(  0 );	return;
	case	A_DIR:	inc_port_tris(  2 );	return;
	case	B_DT:	inc_port_data( 20 );	return;
	case	B_DIR:	inc_port_tris( 22 );	return;
	case	C_DT:	inc_port_data( 40 );	return;
	case	C_DIR:	inc_port_tris( 42 );	return;
	default:	return;
	}
}
void	fDec(void)	/* Dec, W, ϐ̃fNg */
{
	/* ɂ̂̓|[gϐɂĂ̂ */
	switch( (unsigned char)p0w ) {
	case	A_DT:	dec_port_data(  0 );	return;
	case	A_DIR:	dec_port_tris(  2 );	return;
	case	B_DT:	dec_port_data( 20 );	return;
	case	B_DIR:	dec_port_tris( 22 );	return;
	case	C_DT:	dec_port_data( 40 );	return;
	case	C_DIR:	dec_port_tris( 42 );	return;
	default:	return;
	}
}
void	fClear(void)	/* Clear, W, ϐ̃[NA */
{
	/* ɂ̂̓|[gϐɂĂ̂ */
	set_port( (unsigned char)p0w, 0 );
}
void	fDataDump(void)	/* DataDump, B, f[^̃_v */
{
	DataDump( (unsigned char)p0w );
}
void	fGetTimer(void)	/* GetTimer, W ^C}[lǂݏo */
{
	p0w = GetTimer();
}
void	fSetTimer(void)	/* SetTimer, WWW ^C}[lݒ */
{
	p0w = SetTimer( p0w, p1w );
}
void	fStartDump(void)	/* StartDump, WWW f[^̃_vJn */
{
	StartDump( p0w, p1w, p2w );
}
void	fEndDump(void)	/* EndDump, f[^̃_vI */
{
	EndDump();
}
void	fSendByte(void)	/* SendByte, B PoCgo */
{
	SendByte( (unsigned char)p0w );
}
void	fSendWord(void)	/* SendWord, W QoCgo */
{
	SendByte( (p0w>>8)&0xff );
	SendByte( p0w&0xff );
}
void	fSendHex(void)	/* SendHex, B PoCgóiPUiQj */
{
	SendHex( (unsigned char)p0w );
}
void	fSendCode(void)	/* SendCode, W Xg{bNX\p̃bZ[Wԍ𑗐M */
{
	SendCode( p0w );
}
void	fStartMsg(void)	/* StartMsg,  񑗐M̊Jnʒm */
{
	SendEvent( EV_STR );
}
void	fSendMsg(void)	/* SendMsg, S 񑗐M */
{
	unsigned	char	*ptr;

	ptr = (unsigned char *)(((unsigned long)p0w<<16L) + (unsigned long)p1w);
	while( *ptr ) {
		SendByte( *ptr );
		ptr++;
	}
}
void	fEndMsg(void)	/* EndMsg, 񑗐M̏Iʒm */
{
	SendByte(0);
}
void	fMessage(void)	/* Message, S 񑗐M(header܂) */
{
	unsigned	char	*ptr;

	ptr = (unsigned char *)(((unsigned long)p0w<<16L) + (unsigned long)p1w);
	SendEvent( EV_STR );
	while( *ptr ) {
		SendByte( *ptr );
		ptr++;
	}
	SendByte( 0 );
}
void	fSendNum2Str(void)	/* SendNum2Str, BW lɂďo */
{
	/* B:0-9:wA10-19:[߂ƌ(0-9)w */
	SendNum2Str( p0w, p1w );
}
void	fInitIo(void)	/* InitIo I/Ȍ */
{
	initio();
}
void	fInitVolt(void)	/* InitVolt VppVolt()/VccVolt()̏ */
{
	initvolt();
}
void	fVppVolt(void)	/* VppVolt, F VPP̐ݒ */
{
	VppVolt( (unsigned char)p0w );
}
void	fVccVolt(void)	/* VccVolt, F VCC̐ݒ */
{
	VccVolt( (unsigned char)p0w );
}
void	fRecByte(void)	/* RecByte PoCg */
{
	p0w = RecByte();
}
void	fNwRecByte(void)	/* NwRecByte PoCg(no wait) */
{
	p0w = NwRecByte();
}
void	fDataReq(void)	/* DataReq,WWWWWW f[^v */
{
	volatile	unsigned	int		*p1, *p2, *p3;
	volatile	unsigned	char	*io;

	p1 = (volatile unsigned int *)((unsigned long)0xf0000 + (unsigned long)p1w);
	p2 = (volatile unsigned int *)((unsigned long)0xf0000 + (unsigned long)p2w);
	io = (volatile unsigned char *)((unsigned long)0xf0000 + (unsigned long)p3w);
	p3 = (volatile unsigned int *)((unsigned long)0xf0000 + (unsigned long)p4w);
	p0w = DataReq( p0w, (unsigned char *)p1, (unsigned char *)p2, io, (unsigned char *)p3 );
}
void	fWait(void)	/* Wait,  WWW w莞Ԃ̑҂ */
{
	p0w = Wait( p0w, p1w );
}
void	fmset(void)	/* mset, WWB ւ̏ */
{
	volatile	unsigned	char	*io;

	io = (volatile unsigned char *)(((unsigned long)p0w<<16L) + (unsigned long)p1w);
	*io = (unsigned char)p2w;
}
void	fmget(void)	/* mget", WW, ID_INFUNC ǂݏo */
{
	volatile	unsigned	char	*io;

	io = (volatile unsigned char *)(((unsigned long)p0w<<16L) + (unsigned long)p1w);
	p0w = (unsigned char)(*io);
}
void	fmgetw(void)	/* mgetw, WW, ID_INFUNC ǂݏo(word) */
{
	volatile	unsigned	int	*iow;

	iow = (volatile unsigned int *)(((unsigned long)p0w<<16L) + (unsigned long)p1w);
	p0w = (unsigned int)(*iow);
}
void	fGetClock(void)	/* GetClock, W NbNǂݏo */
{
	p0w = GetClock();
}
void	fSetClock(void)	/* SetClock, WW NbNݒ */
{
	p0w = SetClock( p0w );
}
void	fWaitExecEvent(void)	/* WaitExecEvent, W O̎swCxg̎MmF */
{
	p0w = WaitExecEvent();
}
void	fee_write(void)	/* ee_write, WB, 24LC64ւ̏ */
{
	p0w = ee_write( p0w, p1w, (unsigned char)p2w );
}
void	fee_read(void)	/* ee_read, W, 24LC64ǂݏo */
{
	p0w = ee_read( p0w, (unsigned char)p1w );
}
void	fee_prog(void)	/* ee_prog, , 24LC64vO~O */
{
	p0w = ee_prog();
}
void	fOverlayStart(void)	/* R[̃I[oCĂy[W̊mFƐ؂ւ */
{
	unsigned	int	page;

	page = (p0w>>4)&0xf;

	/* y[Wۑ */
	Nest_adr[Nest] = page;
	Nest++;
	if( page ) {
		/* page 1-15̏ꍇ(page 0 ͏Ƀ[hĂ) */
		if( ProgPage != page ) {
			/* XbvAʂ̃y[Wǂݍ */
			ProgPage = page;
			PageLoad(ProgPage);
		}
	}
}
void	fOverlayEnd(void)	/* ^[̃I[oCĂy[W̊mFƐ؂ւ */
{
	unsigned	int	page;

	/* y[W𕜋A */
	Nest--;
	page = Nest_adr[Nest];
	if( page ) {
		/* page 1-15̏ꍇ(page 0 ͏Ƀ[hĂ) */
		if( ProgPage != page ) {
			/* XbvAʂ̃y[Wǂݍ */
			ProgPage = page;
			PageLoad(ProgPage);
		}
	}
}

void	ftime_cmp(void)
{
	volatile	unsigned	char	*p1, *p2;

	p1 = (volatile unsigned char *)((unsigned long)0xf0000 + (unsigned long)p0w);
	p2 = (volatile unsigned char *)((unsigned long)0xf0000 + (unsigned long)p1w);
	p0w = time_cmp( (unsigned char *)p1, (unsigned char *)p2 );
}

void	ftime_update(void)
{
	volatile	unsigned	char	*p1;

	p1 = (volatile unsigned char *)((unsigned long)0xf0000 + (unsigned long)p0w);

	p0w = time_update( (unsigned char *)p1, p1w );
}

void	ftime_rstcarry(void)
{
	volatile	unsigned	char	*p1;

	p1 = (volatile unsigned char *)((unsigned long)0xf0000 + (unsigned long)p0w);

	time_rstcarry( (unsigned char *)p1 );
}

void	ftime_set(void)
{
	volatile	unsigned	char	*p1;

	p1 = (volatile unsigned char *)((unsigned long)0xf0000 + (unsigned long)p0w);

	p0w = time_set( (unsigned char *)p1, p1w, p2w );
}

void	ftime_get(void)
{
	volatile	unsigned	char	*p1;

	p1 = (volatile unsigned char *)((unsigned long)0xf0000 + (unsigned long)p0w);

	p0w = time_get( (unsigned char *)p1, p1w );
}

void	fmemcpy(void)
{
	volatile	unsigned	char	*p1, *p2;

	p1 = (volatile unsigned char *)((unsigned long)0xf0000 + (unsigned long)p0w);
	p2 = (volatile unsigned char *)((unsigned long)0xf0000 + (unsigned long)p1w);
	memcpy( p1, p2, p2w );
}
