#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<alloc.h>

typedef	unsigned	char	uchar;
#include	"opt_pro.h"

#define	STR_TBLMAX	10000				/*	obt@GA				*/
#define	STR_LBLMAX	500					/*	őL[ڐ				*/

typedef	struct	{
	char	*name;						/*	L[ږ					*/
	short	id;							/*	f[^i[GA			*/
	uchar	atr;						/*	gf[^i[GA		*/
}	LBL_TBL;

static	LBL_TBL	str_key[STR_LBLMAX];	/*	L[ڊi[GA			*/
static	char	str_tbl_dat[STR_TBLMAX];/*	f[^i[GA			*/
static	int		str_key_cnt = 0;		/*	L[񍀖ڐ				*/
static	int		str_tbl_ptr = 0;		/*	f[^i[|C^		*/
static	char	str_init_flg = 1;		/*						*/
extern	int		debug;					/*	fobOo			*/

/************************************************************************/
/*	i[GȀ													*/
/************************************************************************/
void	str_init()
{
	int		n;

	for( n=0; n<str_key_cnt; n++ ) {
		if( str_key[n].name != NULL ) {
			free( str_key[n].name );
		}
	}
	str_key_cnt = 0;
	str_tbl_ptr = 0;
	str_init_flg = 0;					/*						*/
}

/************************************************************************/
/*	f[^̌														*/
/*	f[^(-1)Af[^L(gGAf[^Auchar)Abf:	*/
/************************************************************************/
int		str_srh( char *dt, char *bf, int sw )
{
	int		i, j, k, cmp;

	j = 0;
	k = str_key_cnt+1;
	while( 1 ) {
		if( k == (j+1) ) {
			if( sw == 2 ) {
				return( j );
			}
			return -1;
		}
		i = (j+k)/2;
		cmp = strcmp( str_key[i-1].name, dt );
		if( cmp == 0 ) {
			if( sw == 1 ) {				/*	ʃf[^̗L		*/
				strcpy( bf, &str_tbl_dat[str_key[i-1].id] );
			}
			return( (int)str_key[i-1].atr );
		}
		if( cmp < 0 ) {
			j = i;
		} else if( cmp > 0 ) {
			k = i;
		}
	}
}

/************************************************************************/
/*	f[^̊i[														*/
/*	key:L[ږ  dat:L[ڑΉf[^  atr:uchar̊gf[^		*/
/************************************************************************/
void	str_set(char *key, char *dat, uchar atr )
{
	int		len;
	int		set_adr, n;

	if( str_init_flg ) {
		str_init();
	}
	len = strlen( dat );
	if( (str_tbl_ptr + len + 1) >= STR_TBLMAX ) {
		printf( "f[^e[uI[o[t[" );
		exit(-1);
	}
	if( str_key_cnt >= STR_LBLMAX ) {
		printf( "L[e[uI[o[t[" );
		exit(-1);
	}
	set_adr = str_srh( key, "", 2 );	/*	i[ʒu擾	*/
	str_key_cnt++;
	for( n=str_key_cnt; n>set_adr; n-- ) {
		str_key[n].name = str_key[n-1].name;
		str_key[n].id = str_key[n-1].id;
		str_key[n].atr = str_key[n-1].atr;
	}
	str_key[set_adr].name = malloc(strlen( key ) + 1);
	if( str_key[set_adr].name == NULL ) {
		printf( "mallocG[" );
		exit(-1);
	}
	strcpy( str_key[set_adr].name, key );
	str_key[set_adr].id = str_tbl_ptr;
	str_key[set_adr].atr = atr;
	memcpy( &str_tbl_dat[str_tbl_ptr], dat, len + 1 );
	str_tbl_ptr+=(len+1);
	if( debug ) {
		printf("\t\t\t\t\t\tcnt %d   adrs %d\n",str_key_cnt,str_tbl_ptr);
	}
}
