//---------------------------------------------------------------------------
#include <vcl.h>
#include <shellapi.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <winbase.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
#include "Comm.h"
#include "hex.h"
#include "profile.h"
#include "control.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CommX"
#pragma resource "*.dfm"
TForm1 *Form1;

#define	LIST_LOG_MAX	500
#define	DEVICE_MAX		100
#define	FUNCTION_MAX	30
#define	MESSAGE_MAX		100

char	controlfile[MAXPATH+15];
/* foCXi[ϐ */
struct _Device {
	AnsiString	FileName;
	AnsiString	DeviceName;
}	Device[DEVICE_MAX];
int		DeviceCount = 0;
int		UsingDevice;

/* ֐ƃAhXi[ϐ */
struct	{
	AnsiString	func;	/* ֐ */
	AnsiString	com;	/*  */
	char	flg;		/* smFL */
	char	fcheck;		/* t@CLmF */
	unsigned	long	adr;	/* sJnAhX */
}	Func[FUNCTION_MAX];
int		FunctionCount = 0;
int		FunctionPage = 0;
#define	PAGE_MAX	8

char    Msg1[128];

/* s֐ */
AnsiString	AutoRun[2];
unsigned	long	AutoAdr[2];
int		AutoRunCount = 0;

/* bZ[Wi[ϐ */
struct	{
	AnsiString	Msg;		// bZ[W
	unsigned	int	num;	// bZ[Wԍ
}	MsgData[MESSAGE_MAX];
int		MsgCount = 0;

int		Cid = -1;			// RS232CʐM|[gID
int		ComStatus = 0;		// ʐMԊǗp
int		UsingPort = -1;		// COM1-8̎ʗp
int		ComTimeout = 0;		// RS232C^CAEgĎp
int		ComTime = 0;		// RS232C^CAEgĎp

struct	{	// RS232CMf[^i[p
	int		status;			// ʐM   -> 0:wb_MA1:f[^M

	// Mf[^i[GA
	unsigned	int		event;		// Mf[^̃CxgR[h
	unsigned	long	length;		// Mς݂̃f[^
	unsigned	long	address;	// DUMPpA擪AhX
	unsigned	long	datalength;	// DUMPpAMf[^
	unsigned	long	alllength;	// DUMPpAMKvȑf[^
	unsigned	char	ComBuff[65536+256];
} coms;
TRs232c	*RsRec;				// RS232C̃f[^MXbh

#define	S_IDLE		0		// 
#define	S_UPLOAD	1		// uploadI
#define	S_STARTUP	2		// s
#define	S_EXEWAIT	3		// ewt\
#define	S_EXECUTE	4		// ew
#define	S_VER		5		// Version`FbN
int		ExeStatus = S_IDLE;	// sԊǗp
int     WaitAnswer = 0;		// ̌ʂ҂Ă邩 */
unsigned	int	ProgSum = 0;
int		AutoExec = -1;		// sp
char	EditFile[512];
char	InfFile[512];		// xxx.inf t@C
char	RomFile[512];		// xxx.rom t@C
int		HexKey = 0;

unsigned	long	RecDataAdr = 0L;
FILE	*Rdfp = NULL;		// ǂݍݗpt@C|C^
FILE	*Wrfp = NULL;		// ݗpt@C|C^

unsigned	char	image[OVERLAY_MAX+256];	// ݃C[W
int		image_ptr;

/* I[oCt[ */
long	frame_start[16];	/* t[f[^̊i[JnAhX */
long	frame_length[16];	/* t[f[^ */
int	overlay_frame;

extern	int	ReadData(	// 0:A-1:ُ
	int		flg,			// 0:A1:p
	FILE	*fp,			// ǂݍ݃t@C|C^
	long	*radr,			// ǂݍ񂾃f[^̊JnAhX
	unsigned char	*data,	// ǂݍ񂾃f[^
	int 	*len );			// :őǂݍݒAo:ۂ̓ǂݍݒ


#define	COMMX	1	// CommX  VCLgp 2000/07/19


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
	if( Rdfp != NULL ) {
		fclose( Rdfp );
		Rdfp = NULL;
	}
	exit(0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TimeOutSet( int sec )
{
	ComTimeout = sec;	// RS232C^CAEgĎp
	ComTime = time(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
	char	ans[256];

	MenuUp->Visible = false;
	MenuDown->Visible = false;
	SearchSource( "*.c" );
	getcwd( controlfile, MAXPATH );
	strcat( controlfile, "\\" );
	strcat( controlfile, "control.dat" );

	*EditFile = 0;
	OpenDialog1->FileName = "*.hex";
	coms.status = 0;
	coms.length = 0;
	DragAcceptFiles( Handle, true );

	getprofilestring( CONTROL_DATA, "Setting", "COM", ans, "1" );
	if( strcmp( ans, "2" ) == 0 ) {
		COM21->Checked = true;
	} else if( strcmp( ans, "3" ) == 0 ) {
		COM31->Checked = true;
	} else if( strcmp( ans, "4" ) == 0 ) {
		COM41->Checked = true;
	} else if( strcmp( ans, "5" ) == 0 ) {
		COM51->Checked = true;
	} else if( strcmp( ans, "6" ) == 0 ) {
		COM61->Checked = true;
	} else if( strcmp( ans, "7" ) == 0 ) {
		COM71->Checked = true;
	} else if( strcmp( ans, "8" ) == 0 ) {
		COM81->Checked = true;
	} else {
		COM11->Checked = true;
	}
	getprofilestring( CONTROL_DATA, "Setting", "HEX", ans, "2" );
	if( strcmp( ans, "1" ) == 0 ) {
		HEXMODE1->Checked = true;
		ihex_mode( 1 );
	} else if( strcmp( ans, "3" ) == 0 ) {
		HEXMODE3->Checked = true;
		ihex_mode( 3 );
	} else if( strcmp( ans, "4" ) == 0 ) {
		HEXMODE4->Checked = true;
		ihex_mode( 4 );
	} else {
		HEXMODE2->Checked = true;
		ihex_mode( 2 );
	}
	/* compile */
	getprofilestring( CONTROL_DATA, "Setting", "Compiler", ans, "h8cc32.exe $0.c -$1" );
	OptionBox->CompilerCommand->Text = ans;
	getprofilestring( CONTROL_DATA, "Setting", "Makeasm", ans, "h8cc32.exe $0.c -$1 -a" );
	OptionBox->MakeasmCommand->Text = ans;
	getprofilestring( CONTROL_DATA, "Setting", "Assembler", ans, "aasm32.exe -s -m -mh8.mac $0.asm" );
	OptionBox->AssemblerCommand->Text = ans;
	getprofilestring( CONTROL_DATA, "Setting", "Optimize", ans, "optim32.exe h8.tbl $0.asm $0.as1" );
	OptionBox->OptimizeCommand->Text = ans;
	getprofilestring( CONTROL_DATA, "Setting", "OptimizeStatus", ans, "on" );
	if( toupper(ans[0]) == 'O' && toupper(ans[1]) == 'N' && ans[2] == 0 ) {
		OptionBox->Optimize->ItemIndex = 0;
	} else {
		OptionBox->Optimize->ItemIndex = 1;
	}
	getprofilestring( CONTROL_DATA, "Setting", "SymbolUpdate", ans, "h8cc32.exe $0.hex" );
	OptionBox->SymbolUpdateCommand->Text = ans;
	getprofilestring( CONTROL_DATA, "Setting", "AsmMode", ans, "0" );
	if( strcmp( ans, "1" ) == 0 ) {
		AsmMode1->Checked = true;
	} else if( strcmp( ans, "2" ) == 0 ) {
		AsmMode2->Checked = true;
	} else {
		AsmMode0->Checked = true;
	}

	*InfFile = *RomFile = 0;

#ifdef	COMMX
	Timer1->Interval = 500;	// CommXg̓^CAEgĎ̂
#else
	Timer1->Interval = 100;
#endif
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MessageList(AnsiString msg)
{
	int		i, j;

	j = ListBox1->Items->Count;
	for( i=LIST_LOG_MAX; i<j; i++ ) {
		ListBox1->Items->Delete( 0 );
	}
	ListBox1->Items->Add( msg );
	ListBox1->Items->Add( "" );
	if( ListBox1->Items->Count >= 5 ) {
		ListBox1->TopIndex = ListBox1->Items->Count - 5;
	}
}
//---------------------------------------------------------------------------
int __fastcall TForm1::InfLoad( char *inffile )	/* xxx.inf t@C̏ǂݏo */
{
	int		status, i;
	unsigned	long	udt;
	FILE	*fp;
	char	buff[256], pr[256], dmy[256];

	if( (fp=fopen( inffile, "r" )) == NULL ) {
		sprintf( buff, "file open error [%s]\n", inffile );
		MessageList( buff );
		return(-1);
	}

	overlay_frame = 0;

	status = 0;
	while( fgets( buff, 256, fp ) != NULL ) {
		if( strnicmp( buff, "[Common]", 8 ) == 0 ) {
			status = 1;
			continue;
		} else if( strnicmp( buff, "[Function]", 10 ) == 0 ) {
			status = 2;
			continue;
		} else if( strnicmp( buff, "[Overlay]", 9 ) == 0 ) {
			status = 3;
			continue;
		}

		if( sscanf( buff, "%s %s %ld", pr, dmy, &udt ) != 3 ) {
			continue;
		}
		switch( status ) {
		case	1:	// TCY(gp)
			break;
		case	2:	// ֐AhX
			for( i=0; i<FunctionCount; i++ ) {
				if( strcmp( Func[i].func.c_str(), pr ) == 0 ) {
					Func[i].adr = udt;
					break;
				}
			}
			for( i=0; i<AutoRunCount; i++ ) {
				if( strcmp( AutoRun[i].c_str(), pr ) == 0 ) {
					AutoAdr[i] = udt;
					break;
				}
			}
			break;
		case	3:	// t[
			if( strnicmp( pr, "frame", 5 ) == 0 ) {
				if( !isdigit(pr[5]) || !isdigit(pr[6]) ) {
					fclose( fp );
					sprintf( buff, "file format error [%s]\n", inffile );
					MessageList( buff );
					return(-1);
				}
				i = (pr[5]-'0')*10+pr[6]-'0';
				if( stricmp( &pr[7], "length" ) == 0 ) {
					frame_length[i] = udt;
				} else {
					frame_start[i] = udt;
				}
				if( (i+1) > overlay_frame ) {
					overlay_frame = i+1;
				}
			}
			break;
		default:
			break;
		}
	}
	fclose( fp );
	return(0);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::ProgLoad()
{
	int	i, mode, compile, flg;
	FILE	*fp;
	char	*p, buff[512], bf1[512], bf2[256], bf3[256];
	char	FileName[512];

	unsigned	int	length;
	long	adr, offset;
	unsigned	char	data[512];

	*InfFile = *RomFile = 0;
	if( (fp=fopen(EditFile,"r")) == NULL ) {
		sprintf( buff, "File open error [ %s ]", EditFile );
		MessageList( buff );
		return(-1);
	}

	/* et@C𐶐 */
	strcpy( FileName, EditFile );
	if( (p=strrchr(FileName,'.')) != NULL ) {
		strcpy( p, "" );
	} else {
		sprintf( buff, "File name error [ %s ]", EditFile );
		MessageList( buff );
		fclose(fp);
		return(-1);
	}
	sprintf( InfFile, "%s.inf", FileName );
	sprintf( RomFile, "%s.rom", FileName );

	if( AsmMode0->Checked == true ) {
		compile = 0;	/* t@Cɏ] */
	} else if( AsmMode1->Checked == true ) {
		compile = 1;	/* RpC */
	} else {
		compile = 2;	/* RpCȂ */
	}

	FunctionCount = 0;
	AutoRunCount = 0;
	MsgCount = 0;

	mode = 0;
	while( fgets( buff, 256, fp ) != NULL ) {
		if( (p=strrchr(buff,'\n')) != NULL ) {
			*p = 0;
		}
		if( strnicmp( buff, "[AUTORUN]", 9 ) == 0 ) {
			mode = 1;
		} else if( strnicmp( buff, "[MENU]", 6 ) == 0 ) {
			mode = 2;
		} else if( strnicmp( buff, "[MESSAGE]", 9 ) == 0 ) {
			mode = 3;
		} else if( strnicmp( buff, "[TITLE]", 7 ) == 0 ) {
			mode = 4;
		} else if( strnicmp( buff, "[COMPILE]", 9 ) == 0 ) {
			mode = 5;
		} else if( strnicmp( buff, "[CODE]", 6 ) == 0 ) {
			break;
		}
		if( *buff == '[' || !isalnum( *buff ) ) {
			continue;
		}
		if( sscanf( buff, "%s", bf1 ) != 1 ) {
			continue;
		}
		switch( mode ) {
		case	1:	/* [AUTORUN] */
			if( AutoRunCount >2 ) {
				MessageList( "s֐̓o^͂Q܂łł" );
				break;
			}
			AutoAdr[AutoRunCount] = 0;
			AutoRun[AutoRunCount++] = bf1;
			break;
		case	2:	/* [MENU] */
			if( FunctionCount >= FUNCTION_MAX ) {
				MessageList( "j[̍őo^\𒴂Ă܂" );
				break;
			}
			if( (p=strchr(buff,',')) == NULL ) {
				break;
			}
			*p = ' ';
			if( (p=strchr(buff,',')) == NULL ) {
				break;
			}
			*p = ' ';
			if( (p=strchr(buff,',')) == NULL ) {
				break;
			}
			*p = 0;
			p++;	//main,1,,
			*bf3 = 0;	// bf3͎Ȃꍇ
			if( sscanf( buff, "%s %s %s", bf1, bf2, bf3 ) < 2 ) {
				break;
			}
			Func[FunctionCount].flg = 0;
			if( strcmp( bf2, "1" ) == 0 ) {
				Func[FunctionCount].flg = 1;
			}
			Func[FunctionCount].fcheck = 0;
			if( strchr( bf3, 'r' ) != NULL ) {
				Func[FunctionCount].fcheck |= 1;
			}
			if( strchr( bf3, 'w' ) != NULL ) {
				Func[FunctionCount].fcheck |= 2;
			}
			Func[FunctionCount].func = bf1;
			Func[FunctionCount].com = p;
			Func[FunctionCount].adr = 0;
			FunctionCount++;
			break;
		case	3:	/* [MESSAGE] */
			if( MsgCount >= MESSAGE_MAX ) {
				MessageList( "bZ[W̍őo^\𒴂Ă܂" );
				break;
			}
			p = buff;
			while( isspace(*p) ) p++;
			while( isdigit(*p) ) p++;
//			while( isspace(*p) ) p++;
			while( *p == ' ' || *p == '\t' ) p++;
			if( sscanf( buff, "%d", &MsgData[MsgCount].num ) != 1 ) {
				MessageList( "bZ[W̃tH[}bgɈُ킪܂" );
				break;
			}
			MsgData[MsgCount].Msg = p;
			MsgCount++;
			break;
		case	4:	/* [TITLE] */
			break;
		case	5:	/* [COMPILE] */
			if( compile == 0 ) {	/* t@Cɏ] */
				if( stricmp( bf1, "on" ) == 0 ) {
					compile = 1;	/* RpC */
				}
			}
			break;
		default:
			break;
		}
	}
	fclose(fp);

	getprofilestring( InfFile, "Common", "compile", buff, "" );
	if( compile == 1 && strcmp( buff, "0" ) == 0 ) {
		unlink( InfFile );	/* t@Cčč\z */
	}
	if( compile == 2 && strcmp( buff, "1" ) == 0 ) {
		unlink( InfFile );	/* t@Cčč\z */
	}

	/* t@C̃^CX^v`FbNēK؂ȏs */
	if( NewFile( EditFile, InfFile ) != 0 || NewFile( EditFile, RomFile ) != 0 ) {
		if( compile == 1 ) {
			strcpy( buff, OptionBox->MakeasmCommand->Text.c_str() );
		} else {
			strcpy( buff, OptionBox->CompilerCommand->Text.c_str() );
		}
		while( (p=strstr(buff,"$1")) != NULL ) {
			strcpy( bf1, p+2 );
			strcpy( p, controlfile );
			strcat( p, bf1 );
		}
		while( (p=strstr(buff,"$0")) != NULL ) {
			strcpy( bf1, p+2 );
			strcpy( p, FileName );
			strcat( p, bf1 );
		}
		if( *buff == 0 ) {
			sprintf( bf1, "RpC̎sR}hw肳Ă܂" );
			MessageList( bf1 );
			return(-1);
		}
		MessageList( "compile start !" );
		if( RunChild( buff ) != 0 ) {
			return(-1);
		}

		if( compile == 1 ) {
			/* RpCꍇ */
			/* KvȂœK */
			if( OptionBox->Optimize->ItemIndex == 0 ) {
				strcpy( buff, OptionBox->OptimizeCommand->Text.c_str() );
				while( (p=strstr(buff,"$0")) != NULL ) {
					strcpy( bf1, p+2 );
					strcpy( p, FileName );
					strcat( p, bf1 );
				}
				if( *buff == 0 ) {
					sprintf( bf1, "œK̎sR}hw肳Ă܂" );
					MessageList( bf1 );
					return(-1);
				}
				MessageList( "optimize start !" );
				if( RunChild( buff ) != 0 ) {
					return(-1);
				}
			}
			/* AZu */
			strcpy( buff, OptionBox->AssemblerCommand->Text.c_str() );
			while( (p=strstr(buff,"$0")) != NULL ) {
				strcpy( bf1, p+2 );
				strcpy( p, FileName );
				strcat( p, bf1 );
			}
			if( *buff == 0 ) {
				sprintf( buff, "AZu̎sR}hw肳Ă܂" );
				MessageList( buff );
				return(-1);
			}
			MessageList( "assemble start !" );
			if( RunChild( buff ) != 0 ) {
				return(-1);
			}
			/* InfFile ̃AhXXV */
			strcpy( buff, OptionBox->SymbolUpdateCommand->Text.c_str() );
			while( (p=strstr(buff,"$0")) != NULL ) {
				strcpy( bf1, p+2 );
				strcpy( p, FileName );
				strcat( p, bf1 );
			}
			if( *buff == 0 ) {
				sprintf( buff, "V{XVR}hw肳Ă܂" );
				MessageList( buff );
				return(-1);
			}
			MessageList( "symbol update start !" );
			if( RunChild( buff ) != 0 ) {
				return(-1);
			}
		}
	}

	/* InfFile AhXǍ */
	/* AhX̏ */
	for( i=0; i<FunctionCount; i++ ) {
		Func[i].adr = 0;
	}
	for( i=0; i<AutoRunCount; i++ ) {
		AutoAdr[i] = 0;
	}

	if( InfLoad( InfFile ) != 0 ) {	/* xxx.inf t@C̏ǂݏo */
		return(-1);
	}

	/* RomFile 烁[ɓǍ */
	if( (fp=fopen( RomFile, "r" )) == NULL ) {
		sprintf( buff, "t@CI[vł܂[ %s ]", RomFile );
		MessageList( buff );
		return(-1);
	}
	flg = 0;	/* f[^v */
	for( ;; ) {
		length = 500;	/* xɓǂݍލőf[^ */
		if( ReadData( flg, fp, &adr, data, (int *)&length ) != 0 ) {
			fclose( fp );
			sprintf( buff, "t@Cǂݍ݂ňُ킪܂[ %s ]", RomFile );
			MessageList( buff );
			return(-1);
		}
		if( length == 0 ) {
			break;
		}
		flg = 1;	/* pf[^vɕύX */
		/* ǂݍ񂾃f[^imageɊi[ */
		/* RpCt@CɃAhX̓VtgĂ */
		offset = adr;
		/* ɂłĂ64ROMC[WɊi[Ăt[Ȃ̂ */
		/* ǂݍݎɍ폜 */
		if( overlay_frame ) {
			if( (offset+length) >= (OVERLAY_MAX+64) ) {
				fclose( fp );
				sprintf( buff, "mۂĂ郁[TCY𒴂܂ [ %ld ] ( max = %d )", offset+length-64, OVERLAY_MAX );
				MessageList( buff );
				return(-1);
			}
		} else {
			if( (offset+length) >= (PROG_MAX+64) ) {
				fclose( fp );
				sprintf( buff, "mۂĂ郁[TCY𒴂܂ [ %ld ] ( max = %d )", offset+length-64, PROG_MAX );
				MessageList( buff );
				return(-1);
			}
		}
		for( i=0; i<(int)length; i++ ) {
			if( (offset+i) < 64 ) {
				continue;
			}
			image[offset+i-64] = data[i];
		}
		if( (int)(offset+length) > image_ptr ) {
			image_ptr = offset+length;
		}
	}
	image_ptr -= 64;
	fclose( fp );

	/* m̃AhX`FbN */
	for( i=0; i<FunctionCount; i++ ) {
		if( Func[i].adr == 0 ) {
			sprintf( buff, "[ %s ] not found", Func[i].func.c_str() );
			MessageList( buff );
			return(-1);
		}
	}
	for( i=0; i<AutoRunCount; i++ ) {
		if( AutoAdr[i] == 0 ) {
			sprintf( buff, "[ %s ] not found", AutoRun[i].c_str() );
			MessageList( buff );
			return(-1);
		}
	}

	if( overlay_frame ) {
		for( i=0; i<overlay_frame; i++ ) {
			sprintf( buff, "frame %d   adr = %d(%XH)   length = %d", i, frame_start[i], frame_start[i], frame_length[i] );
			MessageList( buff );
		}
		sprintf( buff, "Ŝ̃vOTCY %d oCgł", image_ptr );
		MessageList( buff );
	} else {
		sprintf( buff, "vOTCY %d oCgł", image_ptr );
		MessageList( buff );
	}

	return(0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FunctionDisp(void)
{
	int		ptr;

	ptr = FunctionPage*PAGE_MAX;
	if( FunctionCount > ptr ) {
		B1->Visible = true;
		B1->Caption = Func[ptr].com;
	} else {
		B1->Visible = false;
	}
	if( FunctionCount > (ptr+1) ) {
		B2->Visible = true;
		B2->Caption = Func[ptr+1].com;
	} else {
		B2->Visible = false;
	}
	if( FunctionCount > (ptr+2) ) {
		B3->Visible = true;
		B3->Caption = Func[ptr+2].com;
	} else {
		B3->Visible = false;
	}
	if( FunctionCount > (ptr+3) ) {
		B4->Visible = true;
		B4->Caption = Func[ptr+3].com;
	} else {
		B4->Visible = false;
	}
	if( FunctionCount > (ptr+4) ) {
		B5->Visible = true;
		B5->Caption = Func[ptr+4].com;
	} else {
		B5->Visible = false;
	}
	if( FunctionCount > (ptr+5) ) {
		B6->Visible = true;
		B6->Caption = Func[ptr+5].com;
	} else {
		B6->Visible = false;
	}
	if( FunctionCount > (ptr+6) ) {
		B7->Visible = true;
		B7->Caption = Func[ptr+6].com;
	} else {
		B7->Visible = false;
	}
	if( FunctionCount > (ptr+7) ) {
		B8->Visible = true;
		B8->Caption = Func[ptr+7].com;
	} else {
		B8->Visible = false;
	}
	if( FunctionCount > PAGE_MAX ) {
		MenuUp->Visible = true;
		MenuDown->Visible = true;
	} else {
		MenuUp->Visible = false;
		MenuDown->Visible = false;
	}
	ListBox1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
	int		i;

	if( *(ComboBox1->Text.c_str()) == 0 ) {
		return;
	}
	if( DeviceCount == 0 ) {
		MessageList( "foCXo^Ă܂" );
		return;
	}
	for( i=0; i<DeviceCount; i++ ) {
		if( Device[i].DeviceName == ComboBox1->Text ) {
			break;
		}
	}
	if( DeviceCount == 0 || i == DeviceCount ) {
		return;
	}

	ListBox1->Items->Clear();
	FileType->ItemIndex = 0;

	UsingDevice = i;
	if( On1->Checked == true ) {
		// RpCOɃ{[h`FbNKv
		if( PortOpen() == -1 ) {
			return;
		}
        BoardCheck();
	} else {
		ProgLoadStart();
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ProgLoadStart(void)
{
	strcpy( EditFile, Device[UsingDevice].FileName.c_str() );
	image_ptr = 0;
	memset( image, 0, OVERLAY_MAX+256 );

	if( ProgLoad() == 0 ) {
		FunctionPage = 0;
		FunctionDisp();
		ButtonDisable();
		StatusBar1->Panels->Items[1]->Text = "";
		if( AutoUpload->Checked == True ) {
			uploadClick(NULL);
		}
	} else {
		if( *InfFile && access( InfFile, 0 ) == 0 ) {
			//unlink( InfFile );
		}
		if( *RomFile && access( RomFile, 0 ) == 0 ) {
			unlink( RomFile );
		}
		*InfFile = *RomFile = 0;
		image_ptr = 0;
	}
	Target->Caption = "TARGET";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DataFileNameClick(TObject *Sender)
{
	if( OpenDialog1->Execute() == true ) {
		StatusBar1->Panels->Items[2]->Text = OpenDialog1->FileName;
		if( Rdfp != NULL ) {
			fclose( Rdfp );
			Rdfp = NULL;
		}
	}
	ListBox1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuUpClick(TObject *Sender)
{
	if( FunctionPage == 0 ) {
		return;
	}
	FunctionPage--;
	FunctionDisp();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuDownClick(TObject *Sender)
{
	if( (FunctionPage+1)*PAGE_MAX > (FunctionCount-1) ) {
		return;
	}
	FunctionPage++;
	FunctionDisp();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::COM11Click(TObject *Sender)
{
	COM11->Checked = true;
	if( UsingPort != 1 ) {
		if( Cid != -1 ) {
			coms.status = 0;
			coms.length = 0;
#ifdef	COMMX
			CommX1->ClearTransBuf();
			CommX1->ClearReceiveBuf();
			CommX1->PortClose();
#else
			FlushRs232c( Cid );
			CloseRs232c( Cid );	/* RS232C |[g̃N[Y */
#endif
			Cid = -1;
		}
	}
	setprofilestring( CONTROL_DATA, "Setting", "COM", "1" );
	UsingPort = 1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::COM21Click(TObject *Sender)
{
	COM21->Checked = true;
	if( UsingPort != 2 ) {
		if( Cid != -1 ) {
			coms.status = 0;
			coms.length = 0;
#ifdef	COMMX
			CommX1->ClearTransBuf();
			CommX1->ClearReceiveBuf();
			CommX1->PortClose();
#else
			FlushRs232c( Cid );
			CloseRs232c( Cid );	/* RS232C |[g̃N[Y */
#endif
			Cid = -1;
		}
	}
	setprofilestring( CONTROL_DATA, "Setting", "COM", "2" );
	UsingPort = 2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::COM31Click(TObject *Sender)
{
	COM31->Checked = true;
	if( UsingPort != 3 ) {
		if( Cid != -1 ) {
			coms.status = 0;
			coms.length = 0;
#ifdef	COMMX
			CommX1->ClearTransBuf();
			CommX1->ClearReceiveBuf();
			CommX1->PortClose();
#else
			FlushRs232c( Cid );
			CloseRs232c( Cid );	/* RS232C |[g̃N[Y */
#endif
			Cid = -1;
		}
	}
	setprofilestring( CONTROL_DATA, "Setting", "COM", "3" );
	UsingPort = 3;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::COM41Click(TObject *Sender)
{
	COM41->Checked = true;
	if( UsingPort != 4 ) {
		if( Cid != -1 ) {
			coms.status = 0;
			coms.length = 0;
#ifdef	COMMX
			CommX1->ClearTransBuf();
			CommX1->ClearReceiveBuf();
			CommX1->PortClose();
#else
			FlushRs232c( Cid );
			CloseRs232c( Cid );	/* RS232C |[g̃N[Y */
#endif
			Cid = -1;
		}
	}
	setprofilestring( CONTROL_DATA, "Setting", "COM", "4" );
	UsingPort = 4;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::COM51Click(TObject *Sender)
{
	COM51->Checked = true;
	if( UsingPort != 5 ) {
		if( Cid != -1 ) {
			coms.status = 0;
			coms.length = 0;
#ifdef	COMMX
			CommX1->ClearTransBuf();
			CommX1->ClearReceiveBuf();
			CommX1->PortClose();
#else
			FlushRs232c( Cid );
			CloseRs232c( Cid );	/* RS232C |[g̃N[Y */
#endif
			Cid = -1;
		}
	}
	setprofilestring( CONTROL_DATA, "Setting", "COM", "5" );
	UsingPort = 5;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::COM61Click(TObject *Sender)
{
	COM61->Checked = true;
	if( UsingPort != 6 ) {
		if( Cid != -1 ) {
			coms.status = 0;
			coms.length = 0;
#ifdef	COMMX
			CommX1->ClearTransBuf();
			CommX1->ClearReceiveBuf();
			CommX1->PortClose();
#else
			FlushRs232c( Cid );
			CloseRs232c( Cid );	/* RS232C |[g̃N[Y */
#endif
			Cid = -1;
		}
	}
	setprofilestring( CONTROL_DATA, "Setting", "COM", "6" );
	UsingPort = 6;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::COM71Click(TObject *Sender)
{
	COM71->Checked = true;
	if( UsingPort != 7 ) {
		if( Cid != -1 ) {
			coms.status = 0;
			coms.length = 0;
#ifdef	COMMX
			CommX1->ClearTransBuf();
			CommX1->ClearReceiveBuf();
			CommX1->PortClose();
#else
			FlushRs232c( Cid );
			CloseRs232c( Cid );	/* RS232C |[g̃N[Y */
#endif
			Cid = -1;
		}
	}
	setprofilestring( CONTROL_DATA, "Setting", "COM", "7" );
	UsingPort = 7;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::COM81Click(TObject *Sender)
{
	COM81->Checked = true;
	if( UsingPort != 8 ) {
		if( Cid != -1 ) {
			coms.status = 0;
			coms.length = 0;
#ifdef	COMMX
			CommX1->ClearTransBuf();
			CommX1->ClearReceiveBuf();
			CommX1->PortClose();
#else
			FlushRs232c( Cid );
			CloseRs232c( Cid );	/* RS232C |[g̃N[Y */
#endif
			Cid = -1;
		}
	}
	setprofilestring( CONTROL_DATA, "Setting", "COM", "8" );
	UsingPort = 8;
}
//---------------------------------------------------------------------------
int __fastcall TForm1::PortOpen(void)
{
	if( Cid == -1 ) {
#ifdef	COMMX
		if( COM11->Checked == true ) {
			Cid = 1;
		} else if( COM21->Checked == true ) {
			Cid = 2;
		} else if( COM31->Checked == true ) {
			Cid = 3;
		} else if( COM41->Checked == true ) {
			Cid = 4;
		} else if( COM51->Checked == true ) {
			Cid = 5;
		} else if( COM61->Checked == true ) {
			Cid = 6;
		} else if( COM71->Checked == true ) {
			Cid = 7;
		} else if( COM81->Checked == true ) {
			Cid = 8;
		}
		CommX1->PortNo = Cid;
		CommX1->PortOpen();
#else
		if( COM11->Checked == true ) {
			Cid = OpenRs232c("COM1");
		} else if( COM21->Checked == true ) {
			Cid = OpenRs232c("COM2");
		} else if( COM31->Checked == true ) {
			Cid = OpenRs232c("COM3");
		} else if( COM41->Checked == true ) {
			Cid = OpenRs232c("COM4");
		} else if( COM51->Checked == true ) {
			Cid = OpenRs232c("COM5");
		} else if( COM61->Checked == true ) {
			Cid = OpenRs232c("COM6");
		} else if( COM71->Checked == true ) {
			Cid = OpenRs232c("COM7");
		} else if( COM81->Checked == true ) {
			Cid = OpenRs232c("COM8");
		}
#endif
		coms.status = 0;
		coms.length = 0;
	}
	if( Cid == -1 ) {
		MessageList( "ʐM|[gI[vł܂" );
	}
	return(Cid);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::uploadClick(TObject *Sender)
{
	int		ptr;
	unsigned	int		i;
	unsigned	char	data[4096];

	if( WaitAnswer != 0 ) { /* ̌ʂ҂Ă邩 */
		MessageList( "wʑ҂Ă܂" );
		return;
	}
	if( image_ptr == 0 ) {
		MessageList( "ȈՌꂪǂݍ܂Ă܂" );
		return;
	}
	if( PortOpen() == -1 ) {
		return;
	}
	MessageList( "ȈՌ̓]Jn܂" );
	ProgSum = 0;
	if( overlay_frame != 0 ) {
		ptr = frame_length[0];
	} else {
		ptr = image_ptr;
	}
	sprintf( (char *)data, "+++%c%c%c", EV_PROG,
			(unsigned char)((ptr>>8)&0xff),
			(unsigned char)(ptr&0xff) );
	for( i=0; i<(unsigned int)ptr; i++ ) {
		data[i+6] = image[i];
		ProgSum += image[i];
	}
	data[ptr+6] = (unsigned char)((ProgSum>>8)&0xff);
	data[ptr+7] = (unsigned char)(ProgSum&0xff);
	WriteComm( (char *)data, 6 + ptr + 2 );
	// ̏ԂɑJ
	WaitAnswer = S_UPLOAD;
	ListBox1->Color = clInfoBk;
	ExeStatus = S_UPLOAD;
	AutoExec = 0;	// ŏ̍ڂ玩s
	TimeOutSet( 3 );
	Timer1->Enabled = true;
	ListBox1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
	if( Rdfp != NULL ) {
		fclose( Rdfp );
		Rdfp = NULL;
	}
	if( Cid != -1 ) {
		coms.status = 0;
		coms.length = 0;
#ifdef	COMMX
		CommX1->ClearTransBuf();
		CommX1->ClearReceiveBuf();
		CommX1->PortClose();
#else
		FlushRs232c( Cid );
		CloseRs232c( Cid );	/* RS232C |[g̃N[Y */
#endif
		Cid = -1;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BoardCheck(void)
{
	unsigned	char	buff[10];

	sprintf( (char *)buff, "+++%c", EV_VER );
	WriteComm( (char *)buff, 4 );
	WaitAnswer = 1;
	ListBox1->Color = clInfoBk;
	ExeStatus = S_VER;
	TimeOutSet( 3 );
	Timer1->Enabled = true;
	ListBox1->SetFocus();
	MessageList( "n[hEFA`FbN܂" );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AutoExecute(void)
{
	unsigned	char	buff[200];

	if( AutoExec != -1 && AutoExec < AutoRunCount ) {
		if( AutoAdr[AutoExec] != 0 ) {
			/* compile */
			sprintf( (char *)buff, "+++%c%c%c%c%c%c%c%c%c", EV_EXEC,
				(unsigned char)(AutoAdr[AutoExec]>>16),
				(unsigned char)((AutoAdr[AutoExec]>>8)&0xff),
				(unsigned char)(AutoAdr[AutoExec]&0xff),
				(unsigned char)(ProgSum>>8),
				(unsigned char)(ProgSum&0xff), 0, 0, 0 );
			WriteComm( (char *)buff, 12 );
			ExeStatus = S_EXECUTE;
			WaitAnswer = 1;
			ListBox1->Color = clInfoBk;
			TimeOutSet( 3 );
			Timer1->Enabled = true;
			sprintf( (char *)buff, "s܂[ %s ]", AutoRun[AutoExec].c_str() );
			MessageList( (char *)buff );
			AutoExec++;
		} else {
			MessageList( "s֐܂" );
			AutoExec = -1;
		}
	} else {
		AutoExec = -1;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TransmitData( int flg, unsigned int length )
{
	int		rc;
	long	adr;
	unsigned	int		ad, sum;
	unsigned	char	ad1, ad2, ad3, ad4, l1, l2;
	unsigned	char	buff[256], data[4096];

	// tO̊mF
	if( flg == 0 ) {
		/* ̃f[^v */
		if( Rdfp != NULL ) {
			fclose( Rdfp );
		}
		Rdfp = fopen( StatusBar1->Panels->Items[2]->Text.c_str(), "r" );
	}
	if( Rdfp == NULL ) {
		MessageList( "t@CI[vo܂" );
		// ɓǂݍ݃f[^TCY[ŕԂ */
		sprintf( (char *)data, "+++%c%c%c%c%c%c%c", EV_DATA, 0,0,0,0, 0, 0 );
		data[10] = 0;
		data[11] = 0;
		WriteComm( (char *)buff, 12 );
		return;
	}
	rc = ReadData( flg, Rdfp, &adr, &data[10], (int *)&length );
	if( rc != 0 ) {
		if( Rdfp != NULL ) {
			fclose( Rdfp );
		}
		Rdfp = NULL;
		MessageList( "t@Cǂݍ݂ňُ킪܂" );
		// ɓǂݍ݃f[^TCY[ŕԂ */
		sprintf( (char *)data, "+++%c%c%c%c%c%c%c", EV_DATA, 0,0,0,0, 0, 0 );
		data[10] = 0;
		data[11] = 0;
		WriteComm( (char *)buff, 12 );
		return;
	} else if( length == 0 ) {
		if( Rdfp != NULL ) {
			fclose( Rdfp );
		}
		Rdfp = NULL;
	}
	sum = 0;
	ad1 = (unsigned char)((adr>>24)&0xff);
	sum += ad1;
	ad2 = (unsigned char)((adr>>16)&0xff);
	sum += ad2;
	ad3 = (unsigned char)((adr>>8)&0xff);
	sum += ad3;
	ad4 = (unsigned char)(adr&0xff);
	sum += ad4;
	l1 = (unsigned char)((length>>8)&0xff);
	sum += l1;
	l2 = (unsigned char)(length&0xff);
	sum += l2;

	if( length == 0 ) {
		sprintf( (char *)buff, "f[^ǂݏoIʒm𑗐M܂" );
	} else {
		sprintf( (char *)buff, "%lX(H)  %d oCg̃f[^𑗐M܂", adr, length );
	}
	MessageList( AnsiString((char *)buff) );

	sprintf( (char *)buff, "+++%c%c%c%c%c%c%c", EV_DATA, ad1,ad2,ad3,ad4, l1, l2 );
	memcpy( data, buff, 10 );
	for( ad = 0; ad<length; ad++ ) {
		sum += data[ad+10];
	}
	data[length+10] = (unsigned char)((sum>>8)&0xff);
	data[length+11] = (unsigned char)(sum&0xff);
	WriteComm( (char *)data, length+12 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TransmitProg( int frame )
{
	unsigned	int		ad, sum;
	unsigned	char	data[4096], ad1, ad2, ead1, ead2, l1, l2;

	if( frame < 0 || frame > overlay_frame ) {
		StatusBar1->Panels->Items[0]->Text = "";
		/* frame͈͊Ô߃I[[ԑ */
		sprintf( (char *)data, "+++%c%c%c%c%c%c%c%c%c",
				EV_LOAD, 0,0, 0,0, 0,0, 0,0 );
		WriteComm( (char *)data, 12 );
		return;
	}
	sum = 0;
	/* [̃AhXݒ肷 */
	if( frame == 0 ) {
		ad1 = 0;
		ad2 = 0;
	} else {
		ad1 = (unsigned char)((frame_length[0]>>8)&0xff);
		sum += ad1;
		ad2 = (unsigned char)(frame_length[0]&0xff);
		sum += ad2;
	}
	/* EEPROM[̃AhXݒ肷 */
	ad = frame_start[frame]+64;	/* 64=(adr1(2)+adr2(2)) * 16 */
	ead1 = (unsigned char)((ad>>8)&0xff);
	sum += ead1;
	ead2 = (unsigned char)(ad&0xff);
	sum += ead2;
	/* f[^ݒ肷 */
	l1 = (unsigned char)((frame_length[frame]>>8)&0xff);
	sum += l1;
	l2 = (unsigned char)(frame_length[frame]&0xff);
	sum += l2;

	sprintf( (char *)data, "frame %d", frame );
	StatusBar1->Panels->Items[0]->Text = (char *)data;

	sprintf( (char *)data, "+++%c%c%c%c%c%c%c",
			EV_LOAD, ad1,ad2, ead1,ead2, l1,l2 );
	for( ad = 0; ad<(unsigned int)frame_length[frame]; ad++ ) {
		data[ad+10] = image[frame_start[frame]+ad];
		sum += data[ad+10];
	}
	data[frame_length[frame]+10] = (unsigned char)((sum>>8)&0xff);
	data[frame_length[frame]+11] = (unsigned char)(sum&0xff);
	WriteComm( (char *)data, frame_length[frame]+12 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	Timer1->Enabled = false;	// ^C}[~
	// ʐM|[g̏ԂÔߊmF
	if( Cid == -1 ) {			// ʐM|[gĂꍇ
		WaitAnswer = 0;
		ListBox1->Color = clWhite;
		return;
	}
	// Mf[^̗LmF
#ifndef	COMMX
	Rs232cRecData();
#endif
	// ʐM^CAEgmF
	if( ComTimeout ) {
		// ^CAEgݒ肳Ă
		if( ComTime != time(NULL) ) {
			ComTime = time(NULL);
			ComTimeout--;
			if( ComTimeout == 0 ) {
				Timer1->Enabled = false;	// ^C}[~߂
				switch( ExeStatus ) {
				case	S_IDLE:		/*  */
					break;
				case	S_UPLOAD:	/* uploadI */
					MessageList( "ȈՌ̓]^CAEg܂" );
					break;
				case	S_STARTUP:	/* s */
					MessageList( "sŃ^CAEg܂" );
					break;
				case	S_EXEWAIT:	/* ewt\ */
					break;
				case	S_EXECUTE:	/* ew */
					MessageList( "swŃ^CAEg܂" );
					break;
				case	S_VER:		/* Version`FbN */
					MessageList( "o[W`FbNŃ^CAEg܂" );
					break;
				}
				ExeStatus = S_IDLE;
				coms.status = 0;
				coms.length = 0;
#ifdef	COMMX
				CommX1->ClearTransBuf();
				CommX1->ClearReceiveBuf();
				CommX1->PortClose();
#else
				FlushRs232c( Cid );	// RS232C̃f[^j
				CloseRs232c( Cid );	// U|[g
#endif
				Cid = -1;
				WaitAnswer = 0;
				ListBox1->Color = clWhite;
				return;
			}
		}
	}
	Timer1->Enabled = true;	// ^C}[Jn
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComsAnalyze(void)
{
	int		i;
	unsigned	long	ad;
	unsigned	int	msgno, length;
	char	name[1024];

	switch( coms.event ) {
	case	EV_STR:
		MessageList( AnsiString((char *)coms.ComBuff) );
		break;
	case	EV_CODE:
		msgno  = (unsigned int)coms.ComBuff[0]<<8;
		msgno += (unsigned int)coms.ComBuff[1];
		switch( msgno ) {
		case	0:	// Xg{bNX
			ListBox1->Items->Clear();
			break;
		case	1:	// L[{[h͗L
			KeyOnOff->ItemIndex = 0;
			ListBox1->SetFocus();
			break;
		case	2:	// L[{[h͖
			KeyOnOff->ItemIndex = 1;
			break;
		case	3:	// 
			KeyMode->ItemIndex = 0;
			break;
		case	4:	// 16i
			KeyMode->ItemIndex = 1;
			HexKey = 0;
			break;
		case	5:	// {^L
			ButtonEnable();
			break;
		case	6:	// {^
			ButtonDisable();
			break;
		default:
			for( i=0; i<MsgCount; i++ ) {
				if( MsgData[i].num == msgno ) {
					MessageList( MsgData[i].Msg );
					break;
				}
			}
			break;
		}
		break;
	case	EV_DUMP:
//     XXXXXXXX XXXX XX`XX XXXX  AhX + f[^ + f[^ + SUM
		if( Wrfp == NULL ) {	// ݗpt@C|C^
			strcpy( name, StatusBar1->Panels->Items[2]->Text.c_str() );
			if( *name == 0 ) {
				MessageList( "݃t@C͂Ă܂" );
			} else {
				if( (Wrfp=fopen(name,"w")) == NULL ) {
					MessageList( "݃t@CI[vł܂" );
				}
			}
		}
		//sprintf( (char *)Msg1, "%lX(H)  %lX(H) ܂ł̃f[^M܂",
		//		coms.address, coms.address+coms.datalength );
		if( Wrfp != NULL ) {
			// t@CɊi[
			for( ad = 0; ad<coms.datalength; ad++ ) {
				ihex( 0, (long)(coms.address+ad), (unsigned char)coms.ComBuff[ad+6], Wrfp );
			}
		}
		break;
	case	EV_DUMPEND:
		if( Wrfp != NULL ) {
			ihex_out( 0, Wrfp );
			ihex_end( Wrfp );
			fclose( Wrfp );	// ݗpt@C|C^
			Wrfp = NULL;
		}
		MessageList( "_vIʒmM܂" );
		break;
	case	EV_VER:
		sprintf( Msg1, "t@[EFAo[W %d.%02d",
				coms.ComBuff[0]/100, coms.ComBuff[0]%100 );
		MessageList( Msg1 );
		sprintf( Msg1, "{[hʔԍ %d", coms.ComBuff[1] );
		MessageList( Msg1 );
		//BoardNum = coms.ComBuff[1]-1;	/* n[hEFA{[hԍ */
		//if( BoardNum < 0 || BoardNum > 2 ) {
		//	sprintf( Msg1, "{[hʔԍԈĂ܂BPԂɏ܂B" );
		//	MessageList( Msg1 );
		//	BoardNum = 0;
		//}
		sprintf( Msg1, "ȈՌi[JnAhX %X%02X%02X",
				coms.ComBuff[2], coms.ComBuff[3], coms.ComBuff[4] );
		MessageList( Msg1 );
		On1->Checked = false;
		Off1->Checked = true;
		TimeOutSet( 0 );
		WaitAnswer = 0;
		ListBox1->Color = clWhite;
		/* Version check */
		if( coms.ComBuff[0] < 130 ) {
			sprintf( Msg1, "{[h\tg̃o[Wグĉ" );
			MessageList( Msg1 );
		} else {
			ProgLoadStart();	/* Versionꂽ̂Ŏ̏s */
		}
		break;
	case	EV_PROG:
		if( coms.ComBuff[0] == 0 ) {
			MessageList( "ȈՌAbv[h" );
			ButtonEnable();
			AutoExecute();
		} else {
			MessageList( "ȈՌAbv[hs" );
		}
		TimeOutSet( 0 );
		WaitAnswer = 0;
		ListBox1->Color = clWhite;
		break;
	case	EV_EXEC:
		if( coms.ComBuff[0] == 0 ) {
			if( coms.ComBuff[1] == 0 ) {
				MessageList( "ȈՌsw" );
			} else {
				MessageList( "ȈՌsws" );
			}
			TimeOutSet( 0 );
		} else if( coms.ComBuff[0] == 1 ) {
			WaitAnswer = 0;
			ListBox1->Color = clWhite;
			if( coms.ComBuff[1] == 0 ) {
				MessageList( "ȈՌsI" );
				AutoExecute();
			} else {
				MessageList( "ȈՌsُI" );
			}
		} else {
			sprintf( Msg1, "ȈՌI( %d )", coms.ComBuff[1] );
			MessageList( Msg1 );
			WaitAnswer = 0;
			ListBox1->Color = clWhite;
			if( coms.ComBuff[1] == 0 ) {
				AutoExecute();
			}
		}
		break;
	case	EV_DATA:	// f[^v
		length  = (unsigned int)coms.ComBuff[1]<<8;
		length += (unsigned int)coms.ComBuff[2];
		TransmitData( (int)coms.ComBuff[0], length );
		break;
	case	EV_LOAD:	// I[oCvOv
		TransmitProg( (int)coms.ComBuff[0] );
		break;
	}
	coms.status = 0;
	coms.length = 0;
	coms.event = 0;
}
//---------------------------------------------------------------------------
int __fastcall TForm1::WriteComm( char *buff, int len )
{
#ifdef	COMMX
	return( CommX1->TransBlock( buff, len ) );
#else
	return( WriteRs232c( Cid, buff, len ) );
#endif
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Rs232cRecData(void)
{
	int		cd;
	unsigned	long	i;
	unsigned	char	dt;
	char	buff[20];
	COMSTAT	cs;
#ifndef	COMMX
	DWORD	dwLength, dwError;
#endif

	// ʐMf[^̗LmF
#ifdef	COMMX
	cs.cbInQue = CommX1->GetReceiveLength();
#else
	cs.cbInQue = 0;
	ClearCommError( (HANDLE)Cid, &dwError, &cs );
#endif
	while( cs.cbInQue ) {
		/* cs.cbInQue oCg̃f[^obt@ɑ݂ */
#ifdef	COMMX
		if( (cd=CommX1->ReceiveChar()) == -1 ) {
			return;		// G[̓^CAEgɔC
		}
		dt = (unsigned char)cd;
//sprintf( Msg1, "Rec[%02X] (%c)", dt, dt );
//MessageList( Msg1 );
#else
		if( !ReadFile((HANDLE)Cid,(char *)&dt,1,&dwLength,NULL) ) {
			return;		// G[̓^CAEgɔC
		}
#endif
		switch( coms.status ) {
		case	0:	// headerM
			if( dt == '+' ) {
				coms.length++;
				if( coms.length == 3 ) {
					coms.status++;	// f[^MɑJ
					coms.length = 0;
					coms.event = 0;
				}
			} else {
				coms.length = 0;
			}
			break;
		default:	// f[^M
			switch( coms.event ) {
			case	0:	// ܂Cxgm肵ĂȂ
				coms.event = (unsigned int)dt;
				coms.length = 0;
				if( coms.event == EV_DUMPEND ) {
					// ̃Cxĝ݌pf[^݂Ȃ
					ComsAnalyze();
				}
				break;
			case	EV_STR:
				coms.ComBuff[coms.length++] = (unsigned char)dt;
				if( dt == 0 ) {	// MH
					ComsAnalyze();
				}
				break;
			case	EV_CODE:
				coms.ComBuff[coms.length++] = (unsigned char)dt;
				if( coms.length == 2 ) {
					ComsAnalyze();
				}
				break;
			case	EV_DUMP:
//     XXXXXXXX XXXX XX`XX XXXX  AhX + f[^ + f[^ + SUM
				coms.ComBuff[coms.length++] = (unsigned char)dt;
				if( coms.length > 6 ) {
					if( coms.length == coms.alllength ) {
						ComsAnalyze();
					} else {
						i = coms.length-6;
						if( (i%0x40) == 0 ) {
							sprintf( buff, "%ld/%ld", coms.address+i, coms.address+coms.datalength );
							StatusBar1->Panels->Items[1]->Text = buff;
						}
						// \s킹
						Application->ProcessMessages();
					}
				} else if( coms.length == 6 ) {
					// MKvȑf[^
					coms.address  = (unsigned long)coms.ComBuff[0]<<24;
					coms.address += (unsigned long)coms.ComBuff[1]<<16;
					coms.address += (unsigned long)coms.ComBuff[2]<<8;
					coms.address += (unsigned long)coms.ComBuff[3];
					coms.datalength  = (unsigned long)coms.ComBuff[4]<<8;
					coms.datalength += (unsigned long)coms.ComBuff[5];
					if( coms.datalength == 0 ) {
						coms.datalength = 0x10000;
					}
					// MׂSf[^ݒ
					coms.alllength = coms.datalength + 4 + 2 + 2;	// address+length+sum
				}
				break;
			case	EV_VER:
				coms.ComBuff[coms.length++] = (unsigned char)dt;
				if( coms.length == 5 ) {
					ComsAnalyze();
				}
				break;
			case	EV_PROG:
				coms.ComBuff[coms.length++] = (unsigned char)dt;
				ComsAnalyze();
				break;
			case	EV_EXEC:
				coms.ComBuff[coms.length++] = (unsigned char)dt;
				if( coms.length == 5 ) {
					ComsAnalyze();
				}
				break;
			case	EV_DATA:	// f[^v
//     XX XXXX                       tO + ő]f[^
				coms.ComBuff[coms.length++] = (unsigned char)dt;
				if( coms.length == 3 ) {
					ComsAnalyze();
				}
				break;
			case	EV_LOAD:	// I[oCvOv
//     XX                        y[W(1`15)
				coms.ComBuff[coms.length++] = (unsigned char)dt;
				if( coms.length == 1 ) {
					ComsAnalyze();
				}
				break;
			default:
				break;
			}
			break;
		}
		cs.cbInQue--;	// 1oCgǂݏo
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B1Click(TObject *Sender)
{
	FuncExecuteSub( FunctionPage*PAGE_MAX );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B2Click(TObject *Sender)
{
	FuncExecuteSub( FunctionPage*PAGE_MAX+1 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B3Click(TObject *Sender)
{
	FuncExecuteSub( FunctionPage*PAGE_MAX+2 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B4Click(TObject *Sender)
{
	FuncExecuteSub( FunctionPage*PAGE_MAX+3 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B5Click(TObject *Sender)
{
	FuncExecuteSub( FunctionPage*PAGE_MAX+4 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B6Click(TObject *Sender)
{
	FuncExecuteSub( FunctionPage*PAGE_MAX+5 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B7Click(TObject *Sender)
{
	FuncExecuteSub( FunctionPage*PAGE_MAX+6 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B8Click(TObject *Sender)
{
	FuncExecuteSub( FunctionPage*PAGE_MAX+7 );
}//---------------------------------------------------------------------------
void __fastcall TForm1::FuncExecuteSub(int ptr)
{
	char	buff[256];

	if( WaitAnswer != 0 ) { /* ̌ʂ҂Ă邩 */
		MessageList( "wʑ҂Ă܂" );
		return;
	}
	if( Func[ptr].fcheck & 0x01 ) {
		// ǂݏot@CLmF
		strcpy( buff, StatusBar1->Panels->Items[2]->Text.c_str() );
		if( *buff == 0 ) {
			Application->MessageBox(
				"ǂݏot@Cw肳Ă܂",
				"t@CmF", MB_OK );
			return;
		}
		if( access( buff, 0 ) != 0 ) {
			Application->MessageBox(
				"ǂݏot@C܂",
				"t@CmF", MB_OK );
			return;
		}
	}

	if( Func[ptr].fcheck & 0x02 ) {
		// ݃t@CLmF
		strcpy( buff, StatusBar1->Panels->Items[2]->Text.c_str() );
		if( *buff == 0 ) {
			Application->MessageBox(
				"݃t@Cw肳Ă܂",
				"t@CmF", MB_OK );
			return;
		}
		if( access( buff, 0 ) == 0 ) {
			if( Application->MessageBox(
				"㏑Ă낵łH",
				"t@CmF", MB_OKCANCEL + MB_DEFBUTTON1 ) != IDOK ) {
				return;
			}
		}
	}

	if( Func[ptr].flg ) {
		if( Application->MessageBox(
			"sĂ낵łH",
			"smF", MB_OKCANCEL + MB_DEFBUTTON1 ) != IDOK ) {
			return;
		}
	}
	if( Func[ptr].adr == 0 ) {
		MessageList( "sJnAhXݒ肳Ă܂" );
		return;
	}
	StatusBar1->Panels->Items[1]->Text = "";
	sprintf( (char *)buff, "%s(%s)s܂", Func[ptr].com.c_str(), Func[ptr].func.c_str() );
	MessageList( buff );

	/* compile */
	sprintf( buff, "+++%c%c%c%c%c%c%c%c%c", EV_EXEC,
		(unsigned char)(Func[ptr].adr>>16),
		(unsigned char)((Func[ptr].adr>>8)&0xff),
		(unsigned char)(Func[ptr].adr&0xff),
		(unsigned char)(ProgSum>>8),
		(unsigned char)(ProgSum&0xff),
		0, 0, 0 );

	WriteComm( buff, 12 );
	ExeStatus = S_EXECUTE;
	WaitAnswer = 1;
	ListBox1->Color = clInfoBk;
	TimeOutSet( 3 );
	Timer1->Enabled = true;
	ListBox1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditorClick(TObject *Sender)
{
	if( *EditFile ) {
		ShellExecute( Handle, NULL, EditFile, NULL, NULL, SW_SHOWNORMAL );
	}
	ListBox1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditDataClick(TObject *Sender)
{
	char	name[1024];

	strcpy( name, StatusBar1->Panels->Items[2]->Text.c_str() );
	if( *name && access( name, 0 ) == 0 ) {
		ShellExecute( Handle, NULL, name, NULL, NULL, SW_SHOWNORMAL );
	}
	ListBox1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyPress(TObject *Sender, char &Key)
{
	int		cd;
	char	key, buff[10];

	if( KeyOnOff->ItemIndex == 0 ) {
		ListBox1->SetFocus();
		key = (char)Key;
		if( KeyMode->ItemIndex == 0 ) {
			if( key >= 0x20 && key < 0x7f ) {
				sprintf( Msg1, "char(%d:%c)", key, key );
			} else {
				sprintf( Msg1, "char(%d)", key );
			}
			StatusBar1->Panels->Items[0]->Text = Msg1;
			if( Cid != -1 ) {
				WriteComm( &key, 1 );
			}
		} else {
			if( isxdigit( Key ) ) {
				if( HexKey == 0 ) {
					HexKey = toupper(key);
					sprintf( Msg1, "hex(%c_)", HexKey );
				} else {
					buff[0] = (char)HexKey;
					HexKey = 0;
					buff[1] = (char)toupper(key);
					buff[2] = 0;
					sscanf( buff, "%x", &cd );
					sprintf( Msg1, "hex(%02X)", cd );
					key = (char)cd;
					if( Cid != -1 ) {
						WriteComm( &key, 1 );
					}
				}
				StatusBar1->Panels->Items[0]->Text = Msg1;
			}
		}
		Key = 0;
	}
}
//---------------------------------------------------------------------------
int	__fastcall  TForm1::FmtCheck(char *name)
{
/* 0:\[Xt@CA1:o̓t@C */
	int		i, r;
	FILE	*fp;
	char	buff[256];

	if( (fp=fopen(name,"r")) == NULL ) {
		return(1);
	}
	/* QseǂݏoătH[}bgmF */
	for( r=0; r<2; r++ ) {
		if( fgets(buff,256, fp ) == NULL ) {
			fclose( fp );
			return(1);
		}
		if( buff[0] != ':' ) {
			fclose( fp );
			return(0);
		}
		for( i=1; i<(int)strlen(":10000000"); i++ ) {
			if( !isxdigit(buff[i]) ) {
				fclose( fp );
				return(0);
			}
		}
	}
	fclose( fp );
	return(1);
}
//---------------------------------------------------------------------------
void	__fastcall  TForm1::WMDropFiles( TWMDropFiles &Msg )
{
	char	FileName[ MAX_PATH ];
	int	FileCount;

	FileCount = DragQueryFile( (HDROP)Msg.Drop, 0xFFFFFFFF, NULL, MAX_PATH );
//	for( i=0; i<FileCount; i++ ) {
//		DragQueryFile( (HDROP)Msg.Drop, i, FileName, MAX_PATH );
	if( FileCount ) {
		DragQueryFile( (HDROP)Msg.Drop, 0, FileName, MAX_PATH );
		if( FmtCheck(FileName) == 0) {
			strcpy( EditFile, FileName );

//			for( i=0; i<DeviceCount; i++ ) {
//				if( Device[DeviceCount].FileName == AnsiString(EditFile) ) {
//					break;
//				}
//			}
//			if( i == DeviceCount ) {
//				ComboBox1->Items->Add( EditFile );
//				Device[DeviceCount].FileName = EditFile;
//				Device[DeviceCount].DeviceName = EditFile;
//				DeviceCount++;
//			}
//			ComboBox1->Style = Stdctrls::csSimple;
//			ComboBox1->Style = Stdctrls::csOwnerDrawVariable;
			ComboBox1->Style = Stdctrls::csDropDown;
ComboBox1->ItemIndex = -1;
//			ComboBox1->Text = AnsiString(EditFile);
			Target->Caption = AnsiString(EditFile);
			ComboBox1->Text = "";
			ComboBox1->Style = Stdctrls::csDropDownList;
			ListBox1->Items->Clear();
			image_ptr = 0;
			if( ProgLoad() == 0 ) {
				FunctionPage = 0;
				FunctionDisp();
				ButtonDisable();
				StatusBar1->Panels->Items[1]->Text = "";
				if( AutoUpload->Checked == True ) {
					uploadClick( NULL );
				}
			} else {
				if( *InfFile && access( InfFile, 0 ) == 0 ) {
					unlink( InfFile );
				}
				if( *RomFile && access( RomFile, 0 ) == 0 ) {
					unlink( RomFile );
				}
				*InfFile = *RomFile = 0;
				image_ptr = 0;
			}
		} else {
			StatusBar1->Panels->Items[2]->Text = FileName;
		}
	}
//POINT pt;
//DragQueryPoint( (HDROP)Msg.Drop, &pt );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VersionV1Click(TObject *Sender)
{
    AboutBox->Show();
    Form1->Enabled = false;
}
//---------------------------------------------------------------------------
/* t@C̐V֌WȂ[Ԃ */
int __fastcall TForm1::NewFile( char *oldfile, char *newfile )
{
	struct	ffblk	oldffblk, newffblk;

	if( findfirst(oldfile,&oldffblk,FA_RDONLY|FA_SYSTEM|FA_ARCH) != 0 ) {
		return(-1);
	}
	if( findfirst(newfile,&newffblk,FA_RDONLY|FA_SYSTEM|FA_ARCH) != 0 ) {
		return(-1);
	}
	if( oldffblk.ff_fdate > newffblk.ff_fdate ) {
		return(-1);
	}
	if( oldffblk.ff_fdate == newffblk.ff_fdate ) {
		if( oldffblk.ff_ftime > newffblk.ff_ftime ) {
			return(-1);
		}
	}
	return(0);
}
//---------------------------------------------------------------------------
/* fBNg̃c[ƃt@C̃c[ */
void __fastcall TForm1::SearchSource( char *ext )
{
	FILE	*fp;
	struct	ffblk	ffblk;
	int		done;
	char	t[300], buff[256], *p;
	char	buffer[MAXPATH+15];

	DeviceCount = 0;
	ComboBox1->Items->Clear();
	sprintf( t, "*%s", ext );
//	done=findfirst(t,&ffblk,FA_RDONLY|FA_HIDDEN|FA_SYSTEM|FA_DIREC|FA_ARCH);
	done=findfirst(t,&ffblk,FA_RDONLY|FA_SYSTEM|FA_ARCH);
	while (!done) {
		if( ffblk.ff_name[0] != '.' && ffblk.ff_fsize ) {
			if( (fp=fopen(ffblk.ff_name,"r")) != NULL ) {
				while( fgets( buff, 256, fp ) != NULL ) {
					if( strnicmp( buff, "[TITLE]", 7 ) == 0 ) {
						if( fgets( buff, 256, fp ) == NULL ) {
							break;
						}
						if( (p=strchr(buff,'\n')) != NULL ) {
							*p = 0;
						}
						ComboBox1->Items->Add( buff );
						getcwd( buffer, MAXPATH );
						strcat( buffer, "\\" );
						strcat( buffer, ffblk.ff_name );
						Device[DeviceCount].FileName = buffer;
						Device[DeviceCount].DeviceName = buff;
						DeviceCount++;
						break;
					}
					if( strnicmp( buff, "[CODE]", 6 ) == 0 ) {
						break;
					}
				}
				fclose( fp );
			}
		}
		done = findnext(&ffblk);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonEnable(void)
{
	B1->Enabled = true;
	B2->Enabled = true;
	B3->Enabled = true;
	B4->Enabled = true;
	B5->Enabled = true;
	B6->Enabled = true;
	B7->Enabled = true;
	B8->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonDisable(void)
{
	B1->Enabled = false;
	B2->Enabled = false;
	B3->Enabled = false;
	B4->Enabled = false;
	B5->Enabled = false;
	B6->Enabled = false;
	B7->Enabled = false;
	B8->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::HEXMODE1Click(TObject *Sender)
{
	HEXMODE1->Checked = true;
	setprofilestring( CONTROL_DATA, "Setting", "HEX", "1" );
	ihex_mode( 1 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::HEXMODE2Click(TObject *Sender)
{
	HEXMODE2->Checked = true;
	setprofilestring( CONTROL_DATA, "Setting", "HEX", "2" );
	ihex_mode( 2 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::HEXMODE3Click(TObject *Sender)
{
	HEXMODE3->Checked = true;
	setprofilestring( CONTROL_DATA, "Setting", "HEX", "3" );
	ihex_mode( 3 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::HEXMODE4Click(TObject *Sender)
{
	HEXMODE4->Checked = true;
	setprofilestring( CONTROL_DATA, "Setting", "HEX", "4" );
	ihex_mode( 4 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CommX1Receive(TObject *Sender, int ReceiveSize)
{
	Rs232cRecData();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AsmMode0Click(TObject *Sender)
{
	AsmMode0->Checked = true;
	setprofilestring( CONTROL_DATA, "Setting", "AsmMode", "0" );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AsmMode1Click(TObject *Sender)
{
	AsmMode1->Checked = true;
	setprofilestring( CONTROL_DATA, "Setting", "AsmMode", "1" );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AsmMode2Click(TObject *Sender)
{
	AsmMode2->Checked = true;
	setprofilestring( CONTROL_DATA, "Setting", "AsmMode", "2" );
}
//---------------------------------------------------------------------------
int __fastcall TForm1::RunChild(char *exec)
{
	DWORD	dwExitCode;
	char	szBuff[512];
	char	tmpname[512], *p;
	STARTUPINFO		si;
	PROCESS_INFORMATION	pi;
	HANDLE	hOutput;	// _CNgt@C
	FILE	*fp;

	tmpnam(tmpname);
	hOutput = CreateFile(tmpname, GENERIC_READ | GENERIC_WRITE,
			0, NULL, CREATE_ALWAYS,
			FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (hOutput == INVALID_HANDLE_VALUE) {
		// dwErrorCode = GetLastError();
		ListBox1->Items->Add( "e|t@C쐬ł܂ł" );
		return(-1);
	}

	memset(&si, 0, sizeof(si));
	memset(&pi, 0, sizeof(pi));
	si.cb = sizeof(si);
	si.dwFlags     = STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;
	si.wShowWindow = SW_HIDE;	// EBhE\ɂ

	si.hStdOutput = hOutput;						// Wo͂_CNg
	si.hStdError  = GetStdHandle(STD_ERROR_HANDLE);	// W̓nhZbg
	si.hStdInput  = GetStdHandle(STD_INPUT_HANDLE);	// W̓nhZbg

	if (!CreateProcess(NULL, exec, NULL, NULL, FALSE, 0,
			NULL, NULL, &si, &pi)) {
		// dwErrorCode = GetLastError();
		ListBox1->Items->Add( "vOsł܂ł" );
		ListBox1->Items->Add( exec );
		CloseHandle(hOutput);
		unlink(tmpname);
		return(-1);
	}
	WaitForSingleObject(pi.hProcess, INFINITE);
	GetExitCodeProcess(pi.hProcess, &dwExitCode);
	CloseHandle(hOutput);
	// sʂXg{bNXɕ\
	if( (fp=fopen(tmpname,"r")) != NULL ) {
		while( fgets( szBuff, 512, fp ) != NULL ) {
			if( (p=strrchr(szBuff,'\n')) != NULL ) {
				*p = 0;
			}
			ListBox1->Items->Add( szBuff );
		}
		fclose(fp);
	}
	unlink(tmpname);
	return( dwExitCode );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::InitStatusI1Click(TObject *Sender)
{
	sprintf( Msg1, "wʑ҂܂" );
	MessageList( Msg1 );
	WaitAnswer = 0;
	ListBox1->Color = clWhite;
	coms.status = 0;
	coms.length = 0;
	coms.event = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::compileC1Click(TObject *Sender)
{
	OptionBox->Show();
	Form1->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::On1Click(TObject *Sender)
{
	On1->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Off1Click(TObject *Sender)
{
	Off1->Checked = true;
}
//---------------------------------------------------------------------------
