/* ȈՌC^v^ */
/*  Version 1999/09/28 */
/* 2000/07/09 Version 1.00 J */
/* 2000/07/15 Version 1.10 RS232C̑M҂ǉȂ */
/* 2000/07/21 Version 1.11 24LC64ANZX̃oOC */
/* 2000/11/08 Version 1.20 RpCΉ */
/* 2000/11/20 Version 1.21 #PORTϐ̍9bitȏ̓̓oOC */
/* 2001/01/07 Version 1.22 I[oCΉȂ */
/* 2001/06/23 Version 1.30 D/Ao͂A/D͂ŒA֐ǉ */

#include "control.h"
#include "h8regs.h"

/* control.c */
unsigned	int	Wait(unsigned int w1, unsigned int w2);
unsigned	int	GetTimer(void);
unsigned	int	SetTimer(unsigned int w1, unsigned int w2);
void	small_wait(void);
void	ee_data_high(void);
void	ee_data_low(void);
void	ee_clock_high(void);
void	ee_clock_low(void);
void	start_condition(void);
void	stop_condition(void);
unsigned	char	ee_write_data(unsigned char data);
unsigned	char	ee_read_data(void);
void	ee_start(unsigned char dev);
unsigned	char	ee_read(unsigned int adr, unsigned char dev);
unsigned	char	ee_write(unsigned int adr, unsigned char data, unsigned char dev);
unsigned	int	GetClock(void);
unsigned	int	SetClock(unsigned int w);
unsigned	int	time_cmp(unsigned char *data1, unsigned char *data2);
unsigned	int	time_update(unsigned char *data, unsigned char updown);
void	time_rstcarry(unsigned char *data);
unsigned	int	time_set(unsigned char *data, unsigned char flg, unsigned int dt);
unsigned	int	time_get(unsigned char *data, unsigned char flg);
void	initcomAD(void);
void	initcom(void);
void	SendByte(int ch);
void	initvolt(void);
void	VccVolt(int d);
void	VppVolt(int d);
int	RecByte(void);
int	NwRecByte(void);
void	SendEvent(int id);
void	SendCode(unsigned int num );
unsigned	int	PageLoadFromRs232c(int page);
unsigned	char	ee_prog(void);
unsigned	int	LoadFromRom(unsigned int page);
void	StartDump(unsigned int adH,unsigned int adL,unsigned int size);
void	DataDump(unsigned char data);
void	EndDump(void);
int	DataReq(unsigned int flg, unsigned char *adrH, unsigned char *adrL, unsigned char *data, unsigned char *len);
unsigned	int	WaitExecEvent(void);
void	Message(char *msg);
int		GetNumber(unsigned long *adr, int len);
void	SendHex(unsigned char d);
void	SendNum2Str(unsigned int fmt, unsigned int dt);
unsigned	int	PageLoad(unsigned int page);
int	hex2bin(int c);
void	monitor(void);
void	WaitHeader(void);
void	main(void);

/* execute.c */
extern	void	inittable(void);
extern	void	initio(void);
extern	void	ResetOverlay(void);
extern	unsigned	int	PageCheck(void);
extern	int	execute(void);

/* execute2.c */
extern	unsigned	int	fGetExitCode();


#define	VER	130		/* Version 110 -> 1.10 ő 2.55܂ */

#define	ERREND	0xffff
#define	NODATA	0xfffe

/* ȈՌ֘Åi[GA */
volatile	unsigned	char	image[PROG_MAX];
volatile	unsigned	int		ProgSum, WorkSum, WorkCount;
volatile	unsigned	int		ProgExec, ProgSave, ProgLen, RsWait;
volatile	unsigned	int		MemAdr, EeAdr, FrameLen;
volatile	unsigned	char	VppAdj[3], VccAdj[3];

extern	volatile	unsigned	char	TRISM[9];
extern	volatile	unsigned	char	*TRIS[9], *DATA[9];
extern	volatile	unsigned	char	ExeMode;	/* 0:PCsA1:EEPROMs */
extern	volatile	unsigned	int		ProgPage;	/* ǂݍłvÕy[W */

/* ^C}[֘A̕ϐ */
volatile	unsigned	int	Timer, MsCount, ClockCount;

/* }Vꃋ[`R[֘A */
volatile	unsigned	long	sp_save;	/* X^bN|C^̕ۑp */
volatile	unsigned	long	userfunc;	/* [U}Vꃋ[`JnAhX */
extern	void	usercall();
extern	volatile	unsigned	int		p0w;

unsigned	int	Wait(unsigned int w1, unsigned int w2)
{
	if( w2 == 0 ) {
		Timer = w1/20;
		while( Timer != 0 );
	} else if( w1 <= 1310 ) {
		Timer = w1*50;
		while( Timer != 0 );
	} else {
		Timer = 0;
		return(ERREND);
	}
	return(0);
}

unsigned	int	GetTimer(void)
{
	return( Timer );
}

unsigned	int	SetTimer(unsigned int w1, unsigned int w2)
{
	if( w2 == 0 ) {
		Timer = w1/20;
	} else if( w1 <= 1310 ) {
		Timer = w1*50;
	} else {
		Timer = 0;
		return(ERREND);
	}
	return(0);
}

void	small_wait(void)
{
	unsigned	char	i;

	for( i=0; i<20; i++ ) {
		;
	}
}

void	ee_data_high(void)
{
	/* P6-6͂ɂpullupRɂhigh */
	TRISM[5] &= ~0x40;
	*TRIS[5] = TRISM[5];
	small_wait();
}

void	ee_data_low(void)
{
	*DATA[5] &= ~0x40;
	TRISM[5] |= 0x40;
	*TRIS[5] = TRISM[5];
	*DATA[5] &= ~0x40;
	small_wait();
}

void	ee_clock_high(void)
{
	*DATA[5] |= 0x20;	/* bit5 */
	small_wait();
}

void	ee_clock_low(void)
{
	*DATA[5] &= ~0x20;	/* bit5 */
	small_wait();
}

void	start_condition(void)
{
	ee_data_high();		/* CLK=?  DAT=1 */
	ee_clock_high();	/* CLK=1  DAT=1 */
	ee_data_low();		/* CLK=1  DAT=0 */
	ee_clock_low();		/* CLK=0  DAT=0 */
}

void	stop_condition(void)
{
	ee_data_low();
	ee_clock_high();
	ee_data_high();
}

unsigned	char	ee_write_data(unsigned char data)
{
	unsigned	char	mask, ack;

	mask = 0x80;
	do {
		if( data & mask ) {
			ee_data_high();
		} else {
			ee_data_low();
		}
		ee_clock_high();
		ee_clock_low();
		mask = mask >> 1;
	} while( mask );
	ee_data_high();		/* SDA͂ɂ */
	ee_clock_high();	/* ACKpɃNbNhigh */
	if( *DATA[5] & 0x40 ) {
		ack = 1;
	} else {
		ack = 0;
	}
	ee_clock_low();		/* ACK̃NbNI */
	ee_data_low();
	return(ack);
}

unsigned	char	ee_read_data(void)
{
	unsigned	char	mask, data;

	mask = 0x80;
	ee_data_high();		/* SDA̓[hɂ */
	data = 0;
	do {
		ee_clock_high();
		if( *DATA[5] & 0x40 ) {
			data = data | mask;
		}
		ee_clock_low();
		mask = mask >> 1;
	} while( mask );
	ee_data_low();
	return( data );
}

void	ee_start(unsigned char dev)
{
	unsigned	char	ack;

	/* 2000/07/20 SDAHIGHɂɂ͓̓[hɂ */
	/* P6-6:SDA, P6-5:SCL */
	TRISM[5] |= 0x20;	/* P6-5:SCL output */
	*TRIS[5] = TRISM[5];
	ee_data_high();
	ee_clock_high();

	do {
		start_condition();
		ack = ee_write_data( 0xa0+(dev<<1) );	/* 1010xxx0 ݎw */
	} while( ack != 0 );
}

unsigned	char	ee_read(unsigned int adr, unsigned char dev)
{
	unsigned	char	data;

	ee_start(dev);	/* EEPROMANZXJn */

	ee_write_data(adr>>8);		/* AhXʂWrbg */
	ee_write_data(adr&0xff);	/* AhXʂWrbg */

	start_condition();

	ee_write_data( 0xa1+(dev<<1) );	/* 1010xxx1 ǂݍݎw */

	data = ee_read_data();
	/* no ack */
	ee_data_high();
	ee_clock_high();
	ee_clock_low();
	ee_data_low();

	stop_condition();
	return(data);
}

unsigned	char	ee_write(unsigned int adr, unsigned char data, unsigned char dev)
{
	ee_start(dev);	/* EEPROMANZXJn */

	ee_write_data(adr>>8);		/* AhXʂWrbg */
	ee_write_data(adr&0xff);	/* AhXʂWrbg */

	ee_write_data(data);
	stop_condition();
	return( ee_read(adr,dev) );
}

unsigned	int	GetClock(void)
{
	return( ClockCount );
}

unsigned	int	SetClock(unsigned int w)
{
	if( w > 59999 ) {
		return(ERREND);
	}
	MsCount = 0;
	ClockCount = w;
	return(0);
}


/* t֐ */
#define	CARRY	data[11]
#define	HHMM_H	data[12]
#define	HHMM_L	data[13]
#define	SSMM_H	data[14]
#define	SSMM_L	data[15]
#define	OLD_H	data[16]
#define	OLD_L	data[17]
/* f[^` */
/* 012345678901234567 */
/* XX:XX:XX.XXCHMSSWW */
/* XX:XX:XX.XX = `̃f[^ */
/* C           = L[Lꍇ1ݒ  */
/* HM          =  */
/* SS          = b */
/* WW          = oߎԌvZp[N */
/* 2̓tr */
unsigned	int	time_cmp( unsigned char *data1, unsigned char *data2 )
{
	int		i;

	/* 01234567890 */
	/* XX:XX:XX.XX */
	for( i=0; i<11; i++ ) {
		if( data1[i] < data2[i] ) {
			if( i > 8 ) {
				return( 4 );	/* 1/100bႤ : ŏ̃f[^ */
			} else if( i > 5 ) {
				return( 3 );	/* bႤ : ŏ̃f[^ */
			} else if( i > 2 ) {
				return( 2 );	/* Ⴄ : ŏ̃f[^ */
			} else {
				return( 1 );	/* Ⴄ : ŏ̃f[^ */
			}
		} else if( data1[i] > data2[i] ) {
			if( i > 8 ) {
				return( 8 );	/* 1/100bႤ : ̃f[^ */
			} else if( i > 5 ) {
				return( 7 );	/* bႤ : ̃f[^ */
			} else if( i > 2 ) {
				return( 6 );	/* Ⴄ : ̃f[^ */
			} else {
				return( 5 );	/* Ⴄ : ̃f[^ */
			}
		}
	}
	return(0);	/* SɈv */
}

/* ZAZ̋ʃTu[` */
unsigned	int	time_update( unsigned char *data, unsigned char updown )
{
	unsigned	int	passed_tick;	/* oߎԌvZp */
	unsigned	int	old_tick;		/* oߎԌvZp */
	unsigned	int	work1, work2;

	old_tick = ((unsigned int)OLD_H<<8) + OLD_L;
	work1 = ClockCount/10;		/* 1/100bPʂŏ */

	/* oߕb̌vZ */
	if( work1 < old_tick ) {
		passed_tick = 6000 + work1 - old_tick;
	} else {
		passed_tick = work1 - old_tick;
	}
	OLD_H = work1>>8;
	OLD_L = work1&0xff;

	/* f[^̍XV */
	work1 = ((unsigned int)SSMM_H<<8) + SSMM_L;
	work2 = ((unsigned int)HHMM_H<<8) + HHMM_L;
	switch( updown ) {
	case	0:
		/* Z */
		work1 += passed_tick;
		if( work1 >= 6000 ) {
			work1 -= 6000;
			work2++;
			if( work2 >= 1440 ) {
				work2 -= 1440;
				CARRY = 1;			/* L[ */
			}
			HHMM_H = work2>>8;
			HHMM_L = work2&0xff;
		}
		break;
	case	1:
		/* Z */
		if( work1 <= passed_tick ) {
			if( !work2 ) {
				/* [̏ꍇ */
				if( work1 ) {
					CARRY = 1;	/* Z̓[ɂȂ_ŃL[Zbg */
				}
				work1 = 0;
			} else if( work1 == passed_tick ) {
				work1 = 0;
			} else {
				work1 =work1 + 6000 - passed_tick;
				work2--;
				HHMM_H = work2>>8;
				HHMM_L = work2&0xff;
			}
		} else {
			work1 -= passed_tick;
		}
		break;
	case	2:
		/* ZC^[o */
		if( work1 <= passed_tick ) {
			if( !work2 ) {
				/* [̏ꍇ */
				if( work1 ) {
					/* bJE^̌vZŃ[ɂȂꍇ */
					CARRY = 1;	/* Z̓[ɂȂ_ŃL[Zbg */
					/* JE^Đݒ */
					work2 = (data[0] - '0')*10 + (data[1] - '0');
					work2 = work2*60 + (data[3] - '0')*10 + (data[4] - '0');
					HHMM_H = work2>>8;
					HHMM_L = work2&0xff;
					work2 = (data[6] - '0')*10 + (data[7] - '0');
					work2 = work2*100 + (data[9] - '0')*10 + (data[10] - '0');
					/* [̏ */
					if( work1 != passed_tick ) {
						/* [ */
						if( (work1+work2) >= passed_tick ) {
							work1 = work1 + work2 - passed_tick;
						} else {
							/* Đݒ肵ČZA܂CARRY鎖܂ł͖Ή */
							work1 = work1 + work2 + 6000 - passed_tick;
							if( HHMM_L == 0 ) {
								HHMM_L = 0xff;
								HHMM_H--;
							} else {
								HHMM_L--;
							}
						}
					} else {
						work1 = work2;
					}
				}
			} else if( work1 == passed_tick ) {
				work1 = 0;
			} else {
				work1 =work1 + 6000 - passed_tick;
				work2--;
				HHMM_H = work2>>8;
				HHMM_L = work2&0xff;
			}
		} else {
			work1 -= passed_tick;
		}
		SSMM_H = work1>>8;
		SSMM_L = work1&0xff;
		/* \`f[^͍ĐݒpȂ̂ōXVȂ */
		return( CARRY );
	}
	SSMM_H = work1>>8;
	SSMM_L = work1&0xff;

	/* sprintf()ƃX^bN𑽂ĝŉL̗lɕϊ */
	work1 = work2/60;
	data[0] = (work1/10) + '0';
	data[1] = (work1%10) + '0';
	data[2] = ':';

	work1 = work2%60;
	data[3] = (work1/10) + '0';
	data[4] = (work1%10) + '0';
	data[5] = ':';

	work2 = ((unsigned int)SSMM_H<<8) + SSMM_L;
	work1 = work2/100;
	data[6] = (work1/10) + '0';
	data[7] = (work1%10) + '0';
	data[8] = '.';

	work1 = work2%100;
	data[9] = (work1/10) + '0';
	data[10]= (work1%10) + '0';

	return( CARRY );
}

/* ԕϐ̃L[NA */
void	time_rstcarry( unsigned char *data )
{
	CARRY = 0;
}

unsigned	int	time_set( unsigned char *data, unsigned char flg, unsigned int dt )
{
	unsigned	int	rc;

	CARRY = 0;
	switch( flg ) {
	case	0:
		rc = ((unsigned int)HHMM_H<<8)+HHMM_L;
		rc = dt*60+(rc%60);
		HHMM_H = rc>>8;
		HHMM_L = rc&0xff;
		data[0] = (dt/10) + '0';
		data[1] = (dt%10) + '0';
		return( 0 );
	case	1:
		rc = ((unsigned int)HHMM_H<<8)+HHMM_L;
		rc = (rc/60)*60+dt;
		HHMM_H = rc>>8;
		HHMM_L = rc&0xff;
		data[3] = (dt/10) + '0';
		data[4] = (dt%10) + '0';
		return( 0 );
	case	2:
		rc = ((unsigned int)SSMM_H<<8)+SSMM_L;
		rc = dt*100+(rc%100);
		data[6] = (dt/10) + '0';
		data[7] = (dt%10) + '0';
		break;
	case	3:
		rc = ((unsigned int)SSMM_H<<8)+SSMM_L;
		rc = (rc/100)*100+dt;
		data[9] = (dt/10) + '0';
		data[10] = (dt%10) + '0';
		break;
	default:
		/* LȊO̓[NA@\Ƃ */
		HHMM_H = 0;
		HHMM_L = 0;
		SSMM_H = 0;
		SSMM_L = 0;
		rc= ClockCount/10;		/* 1/100bPʂŏ */
		OLD_H = rc>>8;
		OLD_L = rc&0xff;
		time_update( data, 1 );	/* xR[ĕ\pf[^쐬 */
		return( 0 );
	}
	/* bȉݒ肵̓[ŇoߕbvZGA */
	SSMM_H = rc>>8;
	SSMM_L = rc&0xff;
	rc= ClockCount/10;		/* 1/100bPʂŏ */
	OLD_H = rc>>8;
	OLD_L = rc&0xff;
	return( 0 );
}

unsigned	int	time_get( unsigned char *data, unsigned char flg )
{
	unsigned	int	rc;

	switch( flg ) {
	case	0:
		rc = ((unsigned int)data[12]<<8)+data[13];
		return( rc/60 );
	case	1:
		rc = ((unsigned int)data[12]<<8)+data[13];
		return( rc%60 );
	case	2:
		rc = ((unsigned int)data[14]<<8)+data[15];
		return( rc/100 );
	case	3:
		rc = ((unsigned int)data[14]<<8)+data[15];
		return( rc%100 );
	default:
		return( ERREND );
	}
}

void	initcomAD(void)
{
	/* InitVolt()ȂĂAxdo͂ł悤Ɏlŏ */
	/* lȂ̂ŁARn[hɂقȂ */
	/* ʏInitVolt()鎖ŏlȂĂ薳 */
	VccAdj[0] = 39;		/* 5.0Vo͎D/ARo[^o͒l */
	VccAdj[1] = 139;	/* 12.5Vo͎D/ARo[^o͒l */
	VccAdj[2] = 255;	/* 21.0Vo͎D/ARo[^o͒l */

	VppAdj[0] = 39;		/* 5.0Vo͎D/ARo[^o͒l */
	VppAdj[1] = 139;	/* 12.5Vo͎D/ARo[^o͒l */
	VppAdj[2] = 255;	/* 21.0Vo͎D/ARo[^o͒l */
}

/* ʕ̏ */
void	initcom(void)
{
	int		n;

	RsWait = 0;
	*scr1 = 0;		/* clear all flags  */
	*smr1 = 0;		/* Ascnc, 8bit, NoParity, (Even), stop1, 1/1 */
/*	*brr1 = 51;	*/	/* 9600 baud (CPU=16MHz) */
/*	*brr1 = 25;	*/	/* 19200 baud (CPU=16MHz) */
	*brr1 = 12;		/* 38400 baud (CPU=16MHz) */
	Wait( 60, 0 );	/* 26uS(1/38400sec) */
	*scr1 = 0x30;	/* scr=0011 0000 (TE=1,RE=1) */
	n = *ssr1;		/* Dummy Read */
	*ssr1 = 0x80;	/* Clear Error Flag (TDRE=1) */

	*dacr = 0xff;	/* D/ARo[^o͂ɐݒ */
	*dadr0 = 0;
	*dadr1 = 0;

	initcomAD();
}

void	SendByte(int ch)
{
	while( (*ssr1 & 0x80) == 0 );	/* TDRE == 0 Ȃ҂ */
	*tdr1 = ch;
	*ssr1 &= ~0x80;
	Wait( RsWait, 0 );
}

void	initvolt(void)
{
	int		i;

	/* initcomAD() ̒lƈĂxݒ肵Ă̂ōĐݒ肵Ȃ */
	/* ̂ */
	if( VccAdj[0] != 39 || VccAdj[1] != 139 || VccAdj[2] != 255 ) {
		return;
	}
	if( VppAdj[0] != 39 || VppAdj[1] != 139 || VppAdj[2] != 255 ) {
		return;
	}

	*adcsr = 0x35;	/* XL[hAN4,AN5gp */
	/* VPP/VCC̓dl𑪒肷 */
	VccAdj[0] = 0;
	VccAdj[1] = 0;
	VccAdj[2] = 0;
	VppAdj[0] = 0;
	VppAdj[1] = 0;
	VppAdj[2] = 0;
	for( i=36; i<256; i++ ) {
		*dadr0 = i;
		*dadr1 = i;
		Wait( 25, 1 );	/* d肷܂ŏ҂ */
#define	V50_AD	46		/*  46 =  5.0V *(22/122) /5 *256 */
#define	V125_AD	115		/* 115 = 12.5V *(22/122) /5 *256 */
#define	V21_AD	198		/* 194 = 21.0V *(22/122) /5 *256 */
						/* 194 -> 198 lɍ킹Ď኱ */
		/* 22/122  = A/DRo[^̕l */
		/* /5 *256 = 10bit A/DRo[^̏8bitg5VXP[ɊZ */
		if( VccAdj[0] == 0 ) {
			if( *addrah >= V50_AD ) {
				VccAdj[0] = i;
			}
			if( i >= 56 ) {
				initcomAD();	/* ftHglLɂĊ֐͏I */
				*dadr0 = 0;
				*dadr1 = 0;
				return;	/* A/DRo[^ڑĂȂƔf */
			}
		} else if( VccAdj[1] == 0 ) {
			if( *addrah >= V125_AD ) {
				VccAdj[1] = i;
			}
		} else if( VccAdj[2] == 0 ) {
			if( *addrah >= V21_AD ) {
				VccAdj[2] = i;
			}
		}
		if( VppAdj[0] == 0 ) {
			if( *addrbh >= V50_AD ) {
				VppAdj[0] = i;
			}
		} else if( VppAdj[1] == 0 ) {
			if( *addrbh >= V125_AD ) {
				VppAdj[1] = i;
			}
		} else if( VppAdj[2] == 0 ) {
			if( *addrbh >= V21_AD ) {
				VppAdj[2] = i;
			}
		}
		if( VccAdj[0] != 0 && VppAdj[0] != 0 && i < 92 ) {
			i = 92;	/* ̂߃XLbv */
		}
		if( VccAdj[1] != 0 && VppAdj[1] != 0 && i < 155 ) {
			i = 155;	/* ̂߃XLbv */
		}
		if( VccAdj[2] != 0 && VppAdj[2] != 0 ) {
			break;
		}
	}
	*dadr0 = 0;
	*dadr1 = 0;
	if( VppAdj[0] == 0 ) {
		initcomAD();	/* ftHglLɂĊ֐͏I */
		return;
	}
	if( VccAdj[2] == 0 || VppAdj[2] == 0 ) {
		VccAdj[2] = 255;	/* őd܂łłȂ̂ŉɍőlݒ */
		VppAdj[2] = 255;
	}
}

/* d=0-255(255=25.5V) */
void	VccVolt(int d)
{
	unsigned	int	a1, a2;

	if( d < 125 ) {
		/* VccAdj[0],VccAdj[1] ŌvZ */
		a1 = VccAdj[1] - VccAdj[0];
		a2 = 75;	/* 125-50 */
		a1 = ( (a1 * d) / a2 ) + VccAdj[0] - ( (a1 * 50) / a2 );
	} else {
		/* VccAdj[1],VccAdj[2] ŌvZ */
		a1 = VccAdj[2] - VccAdj[1];
		a2 = 85;	/* 210-125 */
		a1 = ( (a1 * d) / a2 ) + VccAdj[1] - ( (a1 * 125) / a2 );
	}
	if( a1 < 256 ) {
		*dadr0 = a1;
	} else {
		*dadr0 = 255;
	}
}

void	VppVolt(int d)
{
	int		a1, a2;

	if( d < 125 ) {
		/* VppAdj[0],VppAdj[1] ŌvZ */
		a1 = VppAdj[1] - VppAdj[0];
		a2 = 75;	/* 125-50 */
		a1 = ( (a1 * d) / a2 ) + VppAdj[0] - ( (a1 * 50) / a2 );
	} else {
		/* VppAdj[1],VppAdj[2] ŌvZ */
		a1 = VppAdj[2] - VppAdj[1];
		a2 = 85;	/* 210-125 */
		a1 = ( (a1 * d) / a2 ) + VppAdj[1] - ( (a1 * 125) / a2 );
	}
	if( a1 < 256 ) {
		*dadr1 = a1;
	} else {
		*dadr1 = 255;
	}
}

int	RecByte(void)
{
	int		ch;

	while( (*ssr1 & 0x78) == 0 );	/* RDRF=ORER=FER=PER=0 */
	if( (*ssr1 & 0x40) == 0 ) {
		ch = ERREND;						/* error */
		*ssr1 = 0x80;
	} else {
		ch = *rdr1;
		*ssr1 &= ~0x40;
	}
	return( ch );
}

int	NwRecByte(void)
{
	int		ch;

	if( (*ssr1 & 0x78) == 0 ) {
		return(NODATA);
	}
	if( (*ssr1 & 0x40) == 0 ) {
		ch = ERREND;						/* error */
		*ssr1 = 0x80;
	} else {
		ch = *rdr1;
		*ssr1 &= ~0x40;
	}
	return( ch );
}

void	SendEvent(int id )
{
	/* R}hJn}[N */
	SendByte( '+' );
	SendByte( '+' );
	SendByte( '+' );
	/* R}hʂ̑M */
	SendByte( id );
}

/* bZ[WԍM */
void	SendCode(unsigned int num)
{
	SendEvent( EV_CODE );	/* bZ[WԍM */
	SendByte( num>>8 );		/* bZ[Wԍ */
	SendByte( num&0xff );		/* bZ[Wԍ */
}

unsigned	int	PageLoadFromRs232c(int page)
{
	unsigned	int	i, sumd;

	/* R}hM */
	SendEvent( EV_LOAD );
	SendByte( page );
	/* wb_M */
	if( RecByte() != '+' ) return(ERREND);
	if( RecByte() != '+' ) return(ERREND);
	if( RecByte() != '+' ) return(ERREND);
	if( RecByte() != EV_LOAD ) return(ERREND);
	WorkSum = 0;
	/* [̃AhX */
	MemAdr  = RecByte();
	WorkSum += MemAdr;
	i    = RecByte();
	MemAdr = (MemAdr<<8) + i;
	WorkSum += i;
	/* EEPROM̃AhX */
	EeAdr  = RecByte();
	WorkSum += EeAdr;
	i    = RecByte();
	EeAdr = (EeAdr<<8) + i;
	WorkSum += i;
	/* f[^ */
	FrameLen  = RecByte();
	WorkSum += FrameLen;
	i    = RecByte();
	FrameLen = (FrameLen<<8) + i;
	WorkSum += i;
	/* f[^ */
	if( FrameLen == 0 ) {
		/* `FbNTMĐ탊^[ */
		RecByte();
		RecByte();
		return(0);
	}
	for( i=0; i<FrameLen; i++ ) {
		image[MemAdr+i] = (unsigned char)RecByte();
		WorkSum += (unsigned int)image[MemAdr+i];
	}
	/* `FbNT̎M */
	sumd  = RecByte() << 8;
	sumd += RecByte();
	if( WorkSum != sumd ) {
		return(ERREND);
	}
	return(0);
}

/* EEPROMփvO */
unsigned	char	ee_prog(void)
{
	unsigned	int	i, j;

	/* 12bitɃVtgf[^ */
	for( i=0; i<16; i++ ) {
		if( PageLoadFromRs232c(i) != 0 ) {
			return(ERREND);
		}
		if( FrameLen == 0 ) {
			/* vÔߏݕsv */
			break;
		}
		/* [ɓǂݍ񂾂̂EEPROMɏ */
		j = i*4;	/* wb_[̃AhXvZ */
		/* EEPROM̊i[JnAhX */
		if( ee_write( j, (EeAdr>>8), 0 ) != (EeAdr>>8) ) {
			return(ERREND);
		}
		if( ee_write( j+1, (EeAdr&0xff), 0 ) != (EeAdr&0xff) ) {
			return(ERREND);
		}
		/* vOf[^ */
		if( ee_write( j+2, (FrameLen>>8), 0 ) != (FrameLen>>8) ) {
			return(ERREND);
		}
		if( ee_write( j+3, (FrameLen&0xff), 0 ) != (FrameLen&0xff) ) {
			return(ERREND);
		}
		/* vOf[^ */
		for( j=0; j<FrameLen; j++ ) {
			if( ee_write( EeAdr+j, image[MemAdr+j], 0 ) != image[MemAdr+j] ) {
				return(ERREND);
			}
		}
	}
	/* ŏɓǂݍłt[ɖ߂Ă畜A */
	if( ProgPage ) {
		if( PageLoadFromRs232c(ProgPage) != 0 ) {
			return(ERREND);
		}
	}
	return( 0 );
}

/* 2byte:EEPROM̊i[JnAhXA2byte:  ->  16擪Ɋi[ */
/* ̌vO16t[i[ */
unsigned	int	LoadFromRom(unsigned int page)
{
	unsigned	int		base, adr, len;

	if( page == 0 ) {
		/* page 0 ̎́Aimage̊i[JnAhX̓[ */
		base = 0;
	} else {
		/* page 0 ̒image̊i[JnAhX𓾂 */
		base = ee_read(2,0);
		base <<= 8;
		base += ee_read(3,0);
	}
	/* EEPROM̊i[ĂAhX𓾂 */
	page *= 4;
	adr = ee_read(page,0);
	adr <<= 8;
	adr += ee_read(page+1,0);
	if( adr >= OVERLAY_MAX ) {
		return(ERREND);
	}
	/* vOf[^𓾂 */
	len = ee_read(page+2,0);
	len <<= 8;
	len += ee_read(page+3,0);
	if( len >= PROG_MAX ) {
		return(ERREND);
	}

	/* EEPROMadrlenoCg̃f[^baseɓǂݍ */
	ee_start(0);	/* EEPROMANZXJn */

	ee_write_data(adr>>8);	/* AhXʂWrbg */
	ee_write_data(adr&0xff);	/* AhXʂWrbg */

	start_condition();

	ee_write_data( 0xa1 );	/* 1010xxx1 ǂݍݎw */

	while( len ) {
		image[base++] = ee_read_data();
		len--;
		if( len ) {
			/* ack */
			ee_data_low();
			ee_clock_high();
			ee_clock_low();
		}
	}
	/* no ack */
	ee_data_high();
	ee_clock_high();
	ee_clock_low();
	ee_data_low();
	stop_condition();
	return(0);
}

/* f[^̃_vJn */
void	StartDump(unsigned int adH,unsigned int adL,unsigned int size)
{
	WorkSum = 0;			/* [Np`FbNT */
	SendEvent( EV_DUMP );	/* f[^̃_vJn */

	WorkSum += (adH >> 8);
	SendByte( adH >> 8 );

	WorkSum += (adH & 0xff);
	SendByte( adH & 0xff );

	WorkSum += (adL >> 8);
	SendByte( adL >> 8 );

	WorkSum += (adL & 0xff);
	SendByte( adL & 0xff );

	WorkSum += (size >> 8);
	SendByte( size >> 8 );

	WorkSum += (size & 0xff);
	SendByte( size & 0xff );

	WorkCount = size;
}
/* f[^̃_v */
void	DataDump(unsigned char data)
{
	WorkSum += data;
	SendByte( data );

	WorkCount--;
	if( WorkCount == 0 ) {
		SendByte( WorkSum >> 8 );
		SendByte( WorkSum & 0xff );
	}
}
/* f[^̃_vI */
void	EndDump(void)
{
	SendEvent( EV_DUMPEND );
}

/* f[^Mvs */
int	DataReq(unsigned int flg, unsigned char *adrH, unsigned char *adrL, unsigned char *data, unsigned char *len)
{
	unsigned	int	i, j, sumd;

	/* R}hM */
	SendEvent( EV_DATA );
	SendByte( flg&0xff );
	SendByte( len[0] );
	SendByte( len[1] );
	/* wb_M */
	if( RecByte() != '+' ) return(ERREND);
	if( RecByte() != '+' ) return(ERREND);
	if( RecByte() != '+' ) return(ERREND);
	if( RecByte() != EV_DATA ) return(ERREND);
	WorkSum = 0;
	/* AhX */
	adrH[0] = RecByte();
	adrH[1] = RecByte();
	WorkSum += adrH[0];
	WorkSum += adrH[1];
	adrL[0] = RecByte();
	adrL[1] = RecByte();
	WorkSum += adrL[0];
	WorkSum += adrL[1];
	/* f[^ */
	len[0] = RecByte();
	len[1] = RecByte();
	WorkSum += len[0];
	WorkSum += len[1];
	/* f[^ */
	j = ((unsigned int)len[0]<<8) + (unsigned int)len[1];
	for( i=0; i<j; i++ ) {
		data[i] = (unsigned char)RecByte();
		WorkSum += (unsigned int)data[i];
	}
	/* `FbNT̎M */
	sumd  = RecByte() << 8;
	sumd += RecByte();
	if( WorkSum == sumd ) {
		return(0);
	}
	return(ERREND);
}

unsigned	int	WaitExecEvent(void)
{
	unsigned	int	adr, sum;

	/* wb_M */
	if( RecByte() != '+' ) return(ERREND);
	if( RecByte() != '+' ) return(ERREND);
	if( RecByte() != '+' ) return(ERREND);
	if( RecByte() != EV_EXEC ) return(ERREND);

	RecByte();		/* 擪̂PoCg͖ */
	adr  = RecByte() << 8;
	adr += RecByte();
	sum  = RecByte() << 8;
	sum += RecByte();
	RecByte();		/* \GARoCg */
	RecByte();
	RecByte();
	if( ProgSum != sum || ProgSave != adr ) {
		return(ERREND);
	}
	return(0);
}

void	Message(char *msg)
{
	while( *msg ) {
		SendByte( *msg );
		msg++;
	}
}

int		GetNumber(unsigned long *adr, int len)
{
	int		i, j;
	unsigned	long	n;

	n = 0xffffffff;
	j = 0;
	for( ;; ) {
		i = RecByte();
		if( i != 0x1b ) {
			SendByte( i );	/* GR[obN */
		}
		i = toupper(i);
		if( i >= '0' && i <= '9' ) {
			if( n == 0xffffffff ) {
				n = 0;
			}
			n <<= 4;	/* 4bitVtg */
			n += (i-'0');
		} else if( i >= 'A' && i <= 'F' ) {
			if( n == 0xffffffff ) {
				n = 0;
			}
			n <<= 4;	/* 4bitVtg */
			n += (i-'A'+10);
		} else {
			*adr = n;
			return( i );
		}
		j++;
		if( j == len && len != 0 ) {
			*adr = n;
			return( i );
		}
	}
}

void	SendHex(unsigned char d)
{
	unsigned char	c;

	c = (d>>4)&0xf;
	if( c < 10 ) {
		SendByte( c+'0' );
	} else {
		SendByte( c+'A'-10 );
	}
	c = d&0xf;
	if( c < 10 ) {
		SendByte( c+'0' );
	} else {
		SendByte( c+'A'-10 );
	}
}

/* B:0-9:wA10-19:[߂ƌ(0-9)w */
void	SendNum2Str(unsigned int fmt, unsigned int dt)
{
	char	buff[6];
	int		i;

	buff[0] = dt/10000+'0';
	buff[1] = ((dt/1000)%10)+'0';
	buff[2] = ((dt/100)%10)+'0';
	buff[3] = ((dt/10)%10)+'0';
	buff[4] = (dt%10)+'0';
	buff[5] = 0;
	if( fmt < 10 ) {
		for( i=0; i<4; i++ ) {
			if( buff[i] == '0' ) {
				buff[i] = ' ';
			} else {
				break;
			}
		}
	}
	fmt %= 10;
	i = 5 - fmt;
	if( i < 0 ) {
		return;
	}
	if( i == 5 ) {
		for( i=0; i<4; i++ ) {
			if( buff[i] != ' ' && buff[i] != '0' ) {
				break;
			}
		}
	}
	while( buff[i] ) {
		SendByte( buff[i] );
		i++;
	}
}

unsigned	int	PageLoad(unsigned int page)	/* I[oCy[W̓ǂݍ */
{
	unsigned	int	adr, ee_adr, len, d, i, sumd;

	if( ExeMode == 0 ) {	/* 0:PCsA1:EEPROMs */
		return(PageLoadFromRs232c(page));
	} else {
		return(LoadFromRom(page));
	}
}

int	hex2bin(int c)
{
	if( isdigit( c ) ) {
		return( c - '0' );
	}
	return( toupper( c ) - 'A' + 10 );
}

void	monitor(void)
{
	int		len, cmd, cd, i, j;
	unsigned	long	lend, seg;
	volatile	unsigned	char	*adr;
/*	void	(*Func)();	*/

	adr = 0;
	seg = 0;
	Message( "\r\nH8 monitor Ver.1.10 Copyright (C) T.Sagae 2000\r\n" );
	for( ;; ) {
		SendByte( '>' );
		cmd = RecByte();
		cmd = toupper( cmd );
		SendByte( cmd );		/* GR[obN */
		switch( cmd ) {
		case	'?':
Message( "\r\n" );
Message( "Maddress : Memory set       Daddress,length : Memory dump\r\n" );
Message( "Caddress : Call asm         Q               : Quit monitor\r\n" );
Message("     P1(8) P2(8) P3(8) P4(8) P5(4) P6(7) P7(8) P8(5) P9(6) PA(8) PB(8)\r\n");
Message("DIR  fffc0 fffc1 fffc4 fffc5 fffc8 fffc9 ----- fffcd fffd0 fffd1 fffd4\r\n");
Message("DATA fffc2 fffc3 fffc6 fffc7 fffca fffcb fffce fffcf fffd2 fffd3 fffd6\r\n");
Message("ROM 00000-1FFFF     DADR0 fffdc\r\n" );
Message("RAM FEF10-FFF0F     DADR1 fffdd    image[] top = " );
			SendByte( 'F' );
			SendHex( ((unsigned long)image>>8)&0xff );
			SendHex( (unsigned long)image&0xff );
			SendByte( '\r' );
			SendByte( '\n' );
Message("I/O FFF1C-FFFFF     DACR  fffde\r\n" );
			break;
		case	':':
Message("loading...\r\n" );
			len  = hex2bin( RecByte() ) << 4;
			len += hex2bin( RecByte() );
			lend  = hex2bin( RecByte() ) << 12;
			lend += hex2bin( RecByte() ) << 8;
			lend += hex2bin( RecByte() ) << 4;
			lend += hex2bin( RecByte() );
			cmd  = hex2bin( RecByte() ) << 4;
			cmd += hex2bin( RecByte() );
			switch( cmd ) {
			case	0:	/* f[^R[h */
				lend += seg;
				adr = (unsigned char *)lend;
				for( i=0; i<len; i++ ) {
					cd  = hex2bin( RecByte() ) << 4;
					cd += hex2bin( RecByte() );
					/* wAhXɃf[^ */
					*adr = (unsigned char)cd;
					adr++;
				}
				RecByte();	/* p`FbNTǂݎ̂Ă */
				RecByte();
				break;
			case	1:	/* IR[h */
				seg  = 0;
				RecByte();	/* p`FbNTǂݎ̂Ă */
				RecByte();
				break;
			case	2:	/* ZOg */
				seg  = 0;
				for( i=0; i<len; i++ ) {
					cd  = hex2bin( RecByte() ) << 4;
					cd += hex2bin( RecByte() );
					seg <<= 8;
					seg += (unsigned char)cd;
				}
				seg <<= 4;
				RecByte();	/* p`FbNTǂݎ̂Ă */
				RecByte();
				break;
			case	4:	/* ZOg */
				seg  = 0;
				for( i=0; i<len; i++ ) {
					cd  = hex2bin( RecByte() ) << 4;
					cd += hex2bin( RecByte() );
					seg <<= 8;
					seg += (unsigned char)cd;
				}
				seg <<= 16;
				RecByte();	/* p`FbNTǂݎ̂Ă */
				RecByte();
				break;
			case	3:	/* s */
				lend  = 0;
				for( i=0; i<len; i++ ) {
					cd  = hex2bin( RecByte() ) << 4;
					cd += hex2bin( RecByte() );
					lend <<= 8;
					lend += (unsigned char)cd;
				}
				RecByte();	/* p`FbNTǂݎ̂Ă */
				RecByte();
				userfunc = lend;
				usercall();
				break;
			}
			break;
		case	'C':
			cd = GetNumber( &lend, 5 );
			SendByte( '\r' );
			SendByte( '\n' );
			if( cd == 0x1b || lend == 0xffffffff ) {
				break;
			}
			if( lend > 0xfffff ) {
				Message( "address = 0 -> fffff\r\n" );
				break;
			}
			userfunc = lend;
			usercall();
/*
			Func = (void *)lend;
			Func();
*/
			break;
		case	'M':
			cd = GetNumber( &lend, 5 );
			SendByte( '\r' );
			SendByte( '\n' );
			if( cd == 0x1b || lend == 0xffffffff ) {
				break;
			}
			if( lend > 0xfffff ) {
				Message( "address = 0 -> fffff\r\n" );
				break;
			}
			adr = (unsigned char *)lend;
			for( ;; ) {
				/* AhXo */
				SendHex( ((unsigned long)adr>>16)&0xff );
				SendHex( ((unsigned long)adr>>8)&0xff );
				SendHex( (unsigned long)adr&0xff );
				SendByte( ' ' );
				/* eo */
				SendHex( *adr );
				SendByte( '-' );
				cd = GetNumber( &lend, 2 );
				SendByte( '\r' );
				SendByte( '\n' );
				if( cd == 0x1b ) {
					break;
				}
				if( cd == 0x08 ) {
					adr--;
					continue;
				}
				if( lend == 0xffffffff ) {
					adr++;
					continue;
				}
				if( lend < 0x100 ) {
					*adr = (unsigned char)lend;
					continue;
				}
			}
			break;
		case	'D':
			cd = GetNumber( &lend, 0 );
			if( cd == 0x1b || lend == 0xffffffff ) {
				SendByte( '\r' );
				SendByte( '\n' );
				break;
			}
			if( lend > 0xfffff ) {
				Message( "address = 0 -> fffff\r\n" );
				break;
			}
			adr = (unsigned char *)lend;
			if( cd == ',' ) {
				GetNumber( &lend, 5 );
				if( cd == 0x1b || lend == 0xffffffff ) {
					SendByte( '\r' );
					SendByte( '\n' );
					break;
				}
			} else {
				lend = 256;
			}
			SendByte( '\r' );
			SendByte( '\n' );
			len = lend;
			for( i=0; i<len; i++ ) {
				if( (i%16) == 0 ) {
					/* AhXo */
					SendHex( (((unsigned long)adr+i)>>16)&0xff );
					SendHex( (((unsigned long)adr+i)>>8)&0xff );
					SendHex( ((unsigned long)adr+i)&0xff );
				}
				SendByte( ' ' );
				SendHex( *(adr+i) );
				if( (i%16) == 15 ) {
					SendByte( ' ' );
					for( j=i-15; j<=i; j++ ) {
						if( *(adr+j) >= ' ' && *(adr+j) <= 0x7f ) {
							SendByte( *(adr+j) );
						} else {
							SendByte( 0x7f );
						}
					}
					SendByte( '\r' );
					SendByte( '\n' );
				}
			}
			if( (i%16) != 0 ) {
				do {
					SendByte( ' ' );
					SendByte( ' ' );
					SendByte( ' ' );
					i++;
				} while( (i%16) != 0 );
				SendByte( ' ' );
				for( j=i-15; j<=len; j++ ) {
					if( *(adr+j) >= ' ' && *(adr+j) <= 0x7f ) {
						SendByte( *(adr+j) );
					} else {
						SendByte( 0x7f );
					}
				}
				SendByte( '\r' );
				SendByte( '\n' );
			}
			break;
		case	0x0d:
			SendByte( '\r' );
			SendByte( '\n' );
			break;
		case	'Q':
			return;
		default:
			break;
		}
	}
	return;
}

/* R}hwb_̎M */
void	WaitHeader(void)
{
	int		len, ch;

	/* R}hJn}[N +++ ҂ */
	len = 0;
	for( ;; ) {
		ch = RecByte();
		if( ch == '+' ) {
			len++;
			if( len == 3 ) {
				break;
			}
		} else {
			len = 0;
		}
	}
}

void	main(void)
{
	unsigned	int	i, sum;
	unsigned	long	exe;

	inittable();	/* ԊǗe[ȕ */
	ResetOverlay();	/* I[oCŎgĂ̏ */
	initio();		/* I/O|[g̏ */
	initcom();		/* ʕ̏ */

	/* ̎_őSẴ|[g͓͏ԂɂȂĂ */
	if( (*DATA[5]) & 0x40 ) {
		/* P6-6 HIGH̏ꍇ24LC64ڑĂƔ肷 */
		/* P6-6:SDA,P6-5:SCL */
		ExeMode = 1;	/* 0:PCsA1:EEPROMs */
		image[60] = 0x55;	/* 0,1ȊOŏ */
		LoadFromRom(0);
		if( image[60] == 0 ) {
			/* C^v^ */
			ProgExec = 62;
			execute();
		} else if( image[60] == 1 ) {
			/* RpC */
			p0w = image[63];
			fOverlayStart();	/* R[̃I[oCĂy[W̊mFƐ؂ւ */
			image[63] &= 0xf;
			userfunc = (unsigned long)&image[62];
			usercall();
			fOverlayEnd();		/* ^[̃I[oCĂy[W̊mFƐ؂ւ */
		}
	}
	ExeMode = 0;	/* 0:PCsA1:EEPROMs */
	ProgLen = 0;
	for( ;; ) {
		/* R}hwb_M */
		WaitHeader();
		/* R}hɃf[^M */
		switch( RecByte() ) {
		case	EV_VER:		/* t@[EFAo[Wv */
			SendEvent( EV_VER );
			SendByte( VER );
			/* Ver.1.30 ϊe[up~̂łPŒ */
			SendByte( 1 );	/* {[h */
			SendByte( ((unsigned long)image>>16)&0xff );	/* ȈՌGÃAhX */
			SendByte( ((unsigned long)image>>8)&0xff );
			SendByte( (unsigned long)image&0xff );
			break;
		case	EV_SPEED:		/* RS232C]҂Ԏw(ʕb) */
			RsWait  = RecByte() << 8;
			RsWait += RecByte();
			break;
		case	EV_PROG:		/* ȈՌ_E[h */
			/* f[^̎M */
			ProgLen  = RecByte() << 8;
			ProgLen += RecByte();
			/* f[^mF */
			if( ProgLen > PROG_MAX ) {
				SendEvent( EV_PROG );
				SendByte( 1 );	/* 1:NG */
				ProgLen = 0;
				break;
			}
			/* f[^̎MAi[ */
			sum = 0;
			for( i=0; i<ProgLen; i++ ) {
				image[i] = (unsigned char)RecByte();
				sum += (unsigned int)image[i];
			}
			sum &= 0xffff;
			/* sumf[^̎M */
			ProgSum  = (unsigned int)RecByte()<<8;
			ProgSum += (unsigned int)RecByte();
			/* Me̊mFƊmFʂ̕ԑ */
			SendEvent( EV_PROG );
			if( ProgSum == sum ) {
				SendByte( 0 );	/* 0:OK */
			} else {
				SendByte( 1 );	/* 1:NG */
				ProgSum = 0;
			}
			ProgPage = 0x0000;	/* ǂݍłvÕy[W */
/*			initio();	*/	/* I/O|[g̏ */
			break;
		case	EV_EXEC:		/* ȈՌs */
			exe  = (unsigned long)RecByte();
			exe <<= 8L;
			exe += (unsigned long)RecByte();
			exe <<= 8L;
			exe += (unsigned long)RecByte();
			sum  = (unsigned int)RecByte()<<8;
			sum += (unsigned int)RecByte();
			RecByte();	/* \GÂRoCgǂݍ */
			RecByte();
			RecByte();
			SendEvent( EV_EXEC );
			SendByte( 0 );	/* w */
			if( ProgSum != sum ) {
				SendByte( 1 );	/* 1:NG */
				SendByte( 0 );	/* \GÂRoCg */
				SendByte( 0 );
				SendByte( 0 );
				break;
			}
			SendByte( 0 );	/* 0:OK */
			SendByte( 0 );	/* \GÂRoCg */
			SendByte( 0 );
			SendByte( 0 );

			ProgExec = (exe & 0xffff);
			ProgSave = (exe & 0xffff);		/* ̎sJnʒuL */
			ResetOverlay();		/* I[oCŎgĂ̏ */
			if( image[60] == 0 ) {
				/* C^v^ */
				i = execute();
			} else {
				/* RpC */
				p0w = (unsigned int)(exe>>16);
				fOverlayStart();	/* R[̃I[oCĂy[W̊mFƐ؂ւ */
				userfunc = (exe&0xfffff);
				usercall();
				fOverlayEnd();		/* ^[̃I[oCĂy[W̊mFƐ؂ւ */
				i = fGetExitCode() & 0xff;	/* ^[R[h̎o */
			}
			/* RpCɂcmd̂܂܂Ɠeۏ؂ĂȂ */
			/* ̂ŒEV_EXECw肷BCB 2000/10/30 */
			SendEvent( EV_EXEC );
			/*SendEvent( cmd );*/
			if( i == 0 ) {
				SendByte( 1 );	/* 0x01:sI */
				SendByte( 0 );	/*  */
			} else if( i == 0x300 ) {
				SendByte( 1 );	/* 0x01:sI */
				SendByte( 1 );	/* ُ */
			} else {
				SendByte( 3 );	/* exit()ł̏I */
				SendByte( i );
			}
			SendByte( 0 );	/* \GÂRoCg */
			SendByte( 0 );
			SendByte( 0 );
			break;
		case	'M':
		case	'm':
			monitor();
			break;
		default:
			break;
		}
	}
}
