#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	"control.h"

#include	"sym.h"
#include	"sym2.h"


/* control.c */
#ifndef	DEBUG
extern	unsigned	int	Wait(unsigned int w1, unsigned int w2);
extern	unsigned	int	GetTimer(void);
extern	unsigned	int	SetTimer(unsigned int w1, unsigned int w2);
extern	unsigned	char	ee_read(unsigned int adr, unsigned char dev);
extern	unsigned	char	ee_write(unsigned int adr, unsigned char data, unsigned char dev);
extern	unsigned	int	GetClock(void);
extern	unsigned	int	SetClock(unsigned int w);
extern	unsigned	int	time_cmp(unsigned char *data1, unsigned char *data2);
extern	unsigned	int	time_update(unsigned char *data, unsigned char updown);
extern	void	time_rstcarry(unsigned char *data);
extern	unsigned	int	time_set(unsigned char *data, unsigned char flg, unsigned int dt);
extern	unsigned	int	time_get(unsigned char *data, unsigned char flg);
extern	void	SendByte(int ch);
extern	void	initvolt(void);
extern	void	VccVolt(int d);
extern	void	VppVolt(int d);
extern	int	RecByte(void);
extern	int	NwRecByte(void);
extern	void	SendEvent(int id);
extern	void	SendCode(unsigned int num );
extern	unsigned	char	ee_prog(void);
extern	void	StartDump(unsigned int adH,unsigned int adL,unsigned int size);
extern	void	DataDump(unsigned char data);
extern	void	EndDump(void);
extern	int	DataReq(unsigned int flg, unsigned char *adrH, unsigned char *adrL, unsigned char *data, unsigned char *len);
extern	unsigned	int	WaitExecEvent(void);
extern	void	SendHex(unsigned char d);
extern	void	SendNum2Str(unsigned int fmt, unsigned int dt);
extern	unsigned	int	PageLoad(unsigned int page);
#endif

/* execute.c */
void	inittable(void);
void	initio(void);
void	ResetOverlay(void);
void	inc_port_data(unsigned int adr);
void	inc_port_tris(unsigned int adr);
void	dec_port_data(unsigned int adr);
void	dec_port_tris(unsigned int adr);
void	set_port_sub_data(unsigned int adr, unsigned int data);
void	set_port_sub_tris(unsigned int adr, unsigned int data);
void	set_port(unsigned char type, unsigned int data);
unsigned	int	get_port_sub(unsigned int adr);
unsigned	int	get_port_data(unsigned char type);
unsigned	int	peekdata(unsigned char type);
unsigned	int	FuncWait(void);
unsigned	int	FuncSetClock(void);
unsigned	int	FuncDataReq(void);
void	value_calc_sub(unsigned int adr, unsigned int type);
unsigned	int	PageCheck(void);
int	execute(void);

/* execute2.c */


#define	MATH_OFFSET		MATH_START-M_START

volatile	unsigned	int		Nest_adr[NEST_MAX];
volatile	unsigned	char	Nest;

/* f[^ANZXp|C^ */
volatile	unsigned	char	*TRIS[9];
volatile	unsigned	char	*DATA[9];
/* rbgPʂœo͂ςẴ|[gɉey΂Ȃ悤ɂ */
volatile	unsigned	int		TRISC;
volatile	unsigned	int		ProgPage;	/* ǂݍłvÕy[W */
volatile	unsigned	char	ExeMode;	/* 0:PCsA1:EEPROMs */
volatile	unsigned	char	TRISM[9];

volatile	unsigned	int	p0w, p1w, p2w, p3w, p4w;

volatile	int		_stk_ptr;
volatile	unsigned	int	_stk_dat[STACK_MAX];

/* f[^ANZXp|C^ */
#ifdef	DEBUG
volatile	int		ProgExec;
volatile	unsigned	char	image[PROG_MAX];
#else
extern	volatile	int	ProgExec;
extern	volatile	unsigned	char	image[PROG_MAX];
extern	void	c_start(), c_end();
#endif


void	inittable(void)
{
	TRIS[0] = (unsigned char *)0xfffc0;	/* P1 */
	TRIS[1] = (unsigned char *)0xfffc1;	/* P2 */
	TRIS[2] = (unsigned char *)0xfffc4;	/* P3 */
	TRIS[3] = (unsigned char *)0xfffc5;	/* P4 */
	TRIS[4] = (unsigned char *)0xfffc8;	/* P5 */
	TRIS[5] = (unsigned char *)0xfffc9;	/* P6 */
	/* TRIS[ ] = (unsigned char *)0xfffff; P7(input only) */
	TRIS[6] = (unsigned char *)0xfffcd;	/* P8 */
	/* TRIS[ ] = (unsigned char *)0xfffd0; P9(SCI) */
	TRIS[7] = (unsigned char *)0xfffd1;	/* PA */
	TRIS[8] = (unsigned char *)0xfffd4;	/* PB */

	DATA[0] = (unsigned char *)0xfffc2;	/* P1(0-7) */
	DATA[1] = (unsigned char *)0xfffc3;	/* P2(0-7) */
	DATA[2] = (unsigned char *)0xfffc6;	/* P3(0-7) */
	DATA[3] = (unsigned char *)0xfffc7;	/* P4(0-7) */
	DATA[4] = (unsigned char *)0xfffca;	/* P5(0-3) */
	DATA[5] = (unsigned char *)0xfffcb;	/* P6(0-6) */
	/* DATA[ ] = (unsigned char *)0xfffce; P7(0-7,input only) */
	DATA[6] = (unsigned char *)0xfffcf;	/* P8(0-4) */
	/* DATA[ ] = (unsigned char *)0xfffd2; P9(0-5,SCI) */
	DATA[7] = (unsigned char *)0xfffd3;	/* PA(0-7) */
	DATA[8] = (unsigned char *)0xfffd6;	/* PB(0-7) */
}

void	initio(void)
{
	/* Sē͏Ԃɂ */
	*TRIS[0] = 0;
	*TRIS[1] = 0;
	*TRIS[2] = 0;
	*TRIS[3] = 0;
	*TRIS[4] = 0;
	*TRIS[5] = 0;
	*TRIS[6] = 0;
	*TRIS[7] = 0;
	*TRIS[8] = 0;
	/* oŊǗł悤Ƀ[ */
	TRISM[0] = 0;
	TRISM[1] = 0;
	TRISM[2] = 0;
	TRISM[3] = 0;
	TRISM[4] = 0;
	TRISM[5] = 0;
	TRISM[6] = 0;
	TRISM[7] = 0;
	TRISM[8] = 0;
	TRISC = 0;
	*DATA[0] = 0;
	*DATA[1] = 0;
	*DATA[2] = 0;
	*DATA[3] = 0;
	*DATA[4] = 0;
	*DATA[5] = 0;
	*DATA[6] = 0;
	*DATA[7] = 0;
	*DATA[8] = 0;
}

void	ResetOverlay(void)	/* I[oCŎgĂ̏ */
{
	ProgPage = 0;	/* ǂݍłvÕy[W */
	Nest = 0;
}

void	inc_port_data(unsigned int adr)
{
	unsigned	int	port, bit, i, data, padr;
	unsigned	char	d;

	padr = adr+4;
	/* incÕf[^擾 */
	data = ((unsigned int)image[adr]<<8) + (unsigned int)image[adr+1];
	/* incf[^ۑ */
	if( (++image[adr+1]) == 0 ) {
		++image[adr];
	}
	for( i=0; i<16; i++ ) {
		if( (d=image[padr+i]) == 0xff ) {
			return;
		}
		port = (d>>3)&0xf;
		bit = d&0x7;
		if( data & (1<<i) ) {
			*DATA[port] &= ~(1<<bit);
		} else {
			*DATA[port] |=  (1<<bit);
			return;
		}
	}
}

void	inc_port_tris(unsigned int adr)
{
	unsigned	int	port, bit, i, data, padr;
	unsigned	char	d;

	padr = adr+2;
	/* incÕf[^擾 */
	data = ((unsigned int)image[adr]<<8) + (unsigned int)image[adr+1];
	/* incf[^ۑ */
	if( (++image[adr+1]) == 0 ) {
		++image[adr];
	}
	TRISC = 0;
	for( i=0; i<16; i++ ) {
		if( (d=image[padr+i]) == 0xff ) {
			break;
		}
		port = (d>>3)&0xf;
		bit = d&0x7;
		TRISC |= (1<<port);
		if( data & (1<<i) ) {
			TRISM[port] &= ~(1<<bit);
		} else {
			TRISM[port] |=  (1<<bit);
			break;
		}
	}
	for( i=0; i<9; i++ ) {
		if( TRISC & (1<<i) ) {
			*TRIS[i] = TRISM[i];
		}
	}
}

void	dec_port_data(unsigned int adr)
{
	unsigned	int	port, bit, i, data, padr;
	unsigned	char	d;

	padr = adr+4;
	/* decÕf[^擾 */
	data = ((unsigned int)image[adr]<<8) + (unsigned int)image[adr+1];
	/* decf[^ۑ */
	if( (--image[adr+1]) == 0xff ) {
		--image[adr];
	}
	for( i=0; i<16; i++ ) {
		if( (d=image[padr+i]) == 0xff ) {
			return;
		}
		port = (d>>3)&0xf;
		bit = d&0x7;
		if( data & (1<<i) ) {
			*DATA[port] &= ~(1<<bit);
			return;
		} else {
			*DATA[port] |=  (1<<bit);
		}
	}
}

void	dec_port_tris(unsigned int adr)
{
	unsigned	int	port, bit, i, data, padr;
	unsigned	char	d;

	padr = adr+2;
	/* decÕf[^擾 */
	data = ((unsigned int)image[adr]<<8) + (unsigned int)image[adr+1];
	/* decf[^ۑ */
	if( (--image[adr+1]) == 0xff ) {
		--image[adr];
	}
	TRISC = 0;
	for( i=0; i<16; i++ ) {
		if( (d=image[padr+i]) == 0xff ) {
			break;
		}
		port = (d>>3)&0xf;
		bit = d&0x7;
		TRISC |= (1<<port);
		if( data & (1<<i) ) {
			TRISM[port] &= ~(1<<bit);
			break;
		} else {
			TRISM[port] |=  (1<<bit);
		}
	}
	for( i=0; i<9; i++ ) {
		if( TRISC & (1<<i) ) {
			*TRIS[i] = TRISM[i];
		}
	}
}

void	set_port_sub_data(unsigned int adr, unsigned int data)
{
	unsigned	int	port, bit, i, padr;
	unsigned	char	d;

	padr = adr+4;
	image[adr]   = (unsigned char)((data>>8)&0xff);
	image[adr+1] = (unsigned char)(data&0xff);
	for( i=0; i<16; i++ ) {
		if( (d=image[padr+i]) == 0xff ) {
			return;
		}
		port = (d>>3)&0xf;
		bit = d&0x7;
		if( data & (1<<i) ) {
#ifdef	DEBUG
printf( "DATA %d (port %d, bit %d ) = 1\n", d, port, bit );
#else
			*DATA[port] |=  (1<<bit);
#endif
		} else {
#ifdef	DEBUG
printf( "DATA %d (port %d, bit %d ) = 0\n", d, port, bit );
#else
			*DATA[port] &= ~(1<<bit);
#endif
		}
	}
}

void	set_port_sub_tris(unsigned int adr, unsigned int data)
{
	unsigned	int	port, bit, i, padr;
	unsigned	char	d;

	padr = adr+2;
	image[adr]   = (unsigned char)((data>>8)&0xff);
	image[adr+1] = (unsigned char)(data&0xff);
	TRISC = 0;
	for( i=0; i<16; i++ ) {
		if( (d=image[padr+i]) == 0xff ) {
			break;
		}
		port = (d>>3)&0xf;
		bit = d&0x7;
		TRISC |= (1<<port);
		if( data & (1<<i) ) {
#ifdef	DEBUG
printf( "TRIS %d (port %d, bit %d ) = 1\n", d, port, bit );
#else
			TRISM[port] |=  (1<<bit);
#endif
		} else {
#ifdef	DEBUG
printf( "TRIS %d (port %d, bit %d ) = 0\n", d, port, bit );
#else
			TRISM[port] &= ~(1<<bit);
#endif
		}
	}
	for( i=0; i<9; i++ ) {
		if( TRISC & (1<<i) ) {
#ifndef	DEBUG
			*TRIS[i] = TRISM[i];
#endif
		}
	}
}

void	set_port(unsigned char type, unsigned int data)
{
	int		i, j, k, port, bit;
	unsigned	int	offset;
	unsigned	char	d;

	switch( type ) {
	case	A_DT:	set_port_sub_data( 0, data );	return;
	case	A_DIR:	set_port_sub_tris( 2, data );	return;
	case	B_DT:	set_port_sub_data( 20, data );	return;
	case	B_DIR:	set_port_sub_tris( 22, data );	return;
	case	C_DT:	set_port_sub_data( 40, data );	return;
	case	C_DIR:	set_port_sub_tris( 42, data );	return;
	default:
		if( type < 80 ) {
			port = (type>>3)&0xf;
			bit = type&0x7;
			if( data & 0x01 ) {
#ifdef	DEBUG
printf( "DATA %d (port %d, bit %d ) = 1\n", type, port, bit );
#else
				*DATA[port] |=  (1<<bit);
#endif
			} else {
#ifdef	DEBUG
printf( "DATA %d (port %d, bit %d ) = 0\n", type, port, bit );
#else
				*DATA[port] &= ~(1<<bit);
#endif
			}
			offset = 0;
		} else {
			type -= 80;
			port = (type>>3)&0xf;
			bit = type&0x7;
			if( data & 0x01 ) {
#ifdef	DEBUG
printf( "TRIS %d (port %d, bit %d ) = 1\n", type, port, bit );
#else
				TRISM[port] |=  (1<<bit);
#endif
			} else {
#ifdef	DEBUG
printf( "TRIS %d (port %d, bit %d ) = 0\n", type, port, bit );
#else
				TRISM[port] &= ~(1<<bit);
#endif
			}
			offset = 2;
#ifndef	DEBUG
			*TRIS[port] = TRISM[port];
#endif
		}
#if 0
		/* check point RpCɃ`FbN[`ǉ */
		/* portϐŎgĂ|[g͌ʂɎwłȂdlɂ */
		/* łȂ葬xオ߂ */
		for( j=0; j<3; j++ ) {
			for( i=0; i<16; i++ ) {
				k = j * 20;
				d = image[k+4+i];
				if( d == 0xff ) {
					break;
				}
				if( d == type ) {
					if( i < 8 ) {
						/* ʃoCg */
						if( data & 0x01 ) {
							image[k+offset+1] |=  (1<<i);
						} else {
							image[k+offset+1] &= ~(1<<i);
						}
					} else {
						/* ʃoCg */
						if( data & 0x01 ) {
							image[k+offset] |=  (1<<(i-8));
						} else {
							image[k+offset] &= ~(1<<(i-8));
						}
					}
				}
			}
		}
#endif
		return;
	}
}

unsigned	int	get_port_sub(unsigned int adr)
{
	int		i, port, bit;
	unsigned	char	d;

	/* 2000/11/19 bitɑ΂ݒoOCƍ */
	/* 8bit̏ */
	for( i=0; i<8; i++ ) {
		/* if( !(image[adr+3]&(1<<i)) ) { */
		if( (d=image[adr+4+i]) == 0xff ) {
			break;
		}
		port = (d>>3)&0xf;
		bit = d&0x7;
#ifndef	DEBUG
		if( *DATA[port] & (1<<bit) ) {
			image[adr+1] |=  (1<<i);
		} else {
			image[adr+1] &= ~(1<<i);
		}
#endif
		/* } */
	}
	/* 8bit̏ */
	for( i=0; i<8; i++ ) {
		/* if( !(image[adr+2]&(1<<i)) ) { */
		if( (d=image[adr+12+i]) == 0xff ) {
			break;
		}
		port = (d>>3)&0xf;
		bit = d&0x7;
#ifndef	DEBUG
		if( *DATA[port] & (1<<bit) ) {
			image[adr] |=  (1<<i);
		} else {
			image[adr] &= ~(1<<i);
		}
#endif
		/* } */
	}
	return( ((unsigned int)image[adr]<<8) + (unsigned int)image[adr+1] );
}

unsigned	int	get_port_data(unsigned char type)
{
	unsigned	int	port, bit;

	switch( type ) {
	case	A_DT:
		return( get_port_sub( 0 ) );
	case	A_DIR:
		return( ((unsigned int)image[2]<<8) + (unsigned int)image[3] );
	case	B_DT:
		return( get_port_sub( 20 ) );
	case	B_DIR:
		return( ((unsigned int)image[22]<<8) + (unsigned int)image[23] );
	case	C_DT:
		return( get_port_sub( 40 ) );
	case	C_DIR:
		return( ((unsigned int)image[42]<<8) + (unsigned int)image[43] );
	default:
		port = (type>>3)&0xf;
		bit = type&0x7;
		return( ((*DATA[port])>>bit)&1 );
	}
}

unsigned	int	peekdata(unsigned char type)
{
	int		i, j, k;
	unsigned	int	adr, ans, port, bit;
	unsigned	char	d;

	switch( type ) {
	case	A_DT:
		return( get_port_sub( 0 ) );
/*
	case	A_DIR:
		return( ((unsigned int)image[2]<<8) + (unsigned int)image[3] );
*/
	case	B_DT:
		return( get_port_sub( 20 ) );
/*
	case	B_DIR:
		return( ((unsigned int)image[22]<<8) + (unsigned int)image[23] );
*/
	case	C_DT:
		return( get_port_sub( 40 ) );
/*
	case	C_DIR:
		return( ((unsigned int)image[42]<<8) + (unsigned int)image[43] );
*/
	case	CONST1:			/* xx                         PoCg萔 */
		ans = (unsigned int)image[ProgExec++];
		return( ans );
	case	CONST2:			/* xxxx                       QoCg萔 */
		ans = ((unsigned int)image[ProgExec]<<8) + (unsigned int)image[ProgExec+1];
		ProgExec++;
		ProgExec++;
		return( ans );
	case	VAL1:			/* xxxx(adr,byte)             PoCgϐ */
		adr = ((unsigned int)image[ProgExec]<<8) + (unsigned int)image[ProgExec+1];
		ans = (unsigned int)image[ adr ];
		ProgExec++;
		ProgExec++;
		return( ans );
	case	VAL2:			/* xxxx(adr,word)             QoCgϐ */
		adr = ((unsigned int)image[ProgExec]<<8) + (unsigned int)image[ProgExec+1];
		ans = ((unsigned int)image[adr]<<8) + (unsigned int)image[adr+1];
		ProgExec++;
		ProgExec++;
		return( ans );
	case	ARRAY:			/* 萔/ϐ(z̈ʒu)    MbuffQ */
	case	ARRAYW:			/* 萔/ϐ(z̈ʒu)    MbuffQ */
		/* z̃x[XAhX擾 */
		adr = ((unsigned int)image[ProgExec]<<8) + (unsigned int)image[ProgExec+1];
		ProgExec++;
		ProgExec++;
		i = image[ProgExec++];
		ans = peekdata( i );
		if( type == ARRAY ) {
			adr += ans;
			ans = (unsigned int)image[adr];
#ifdef	DEBUG
printf( "ARRAY READ image[%d] -> %d\n", adr, ans );
#endif
		} else {
			adr += (ans<<2);
			ans = ((unsigned int)image[adr]<<8) + (unsigned int)image[adr+1];
#ifdef	DEBUG
printf( "ARRAYW READ image[%d,%d] -> %d\n", adr, adr+1, ans );
#endif
		}
		return( ans );
	default:
		port = (type>>3)&0xf;
		bit = type&0x7;
#ifdef	DEBUG
printf( "READ DATA %d (port %d, bit %d )\n", type, port, bit );
#else
		ans = ((*DATA[port])>>bit)&1;
#endif
#if 0
		/* check point ǂݏo̎portϐ܂ōXVKv͂Ȃ͂ */
		/* łȂ葬xオ߂ */
		for( j=0; j<3; j++ ) {
			for( i=0; i<16; i++ ) {
				k = j * 20;
				d = image[k+4+i];
				if( d == 0xff ) {
					break;
				}
				if( d == type ) {
					if( i < 8 ) {
						/* ʃoCg */
						if( ans & 0x01 ) {
							image[k+1] |=  (1<<i);
						} else {
							image[k+1] &= ~(1<<i);
						}
					} else {
						/* ʃoCg */
						if( ans & 0x01 ) {
							image[k] |=  (1<<(i-8));
						} else {
							image[k] &= ~(1<<(i-8));
						}
					}
				}
			}
		}
#endif
		return( ans );
	}
}

unsigned	int	FuncWait(void)
{
	unsigned	char	d;
	unsigned	int		ans1, ans2;

	d = image[ProgExec++];
	ans1 = peekdata( d );
	d = image[ProgExec++];
	ans2 = peekdata( d );
#ifdef	DEBUG
printf( "Wait( %d, %d )\n", ans1, ans2 );
	return(0);
#else
	return( Wait( ans1, ans2 ) );
#endif
}

unsigned	int	FuncSetClock(void)
{
	unsigned	char	d;
	unsigned	int		ans;

	d = image[ProgExec++];
	ans = peekdata( d );
#ifdef	DEBUG
printf( "SetClock( %d )\n", ans );
	return(0);
#else
	return( SetClock( ans ) );
#endif
}

unsigned	int	FuncDataReq(void)	/* f[^v */
{
	unsigned	char	d;
	unsigned	int		w0, w1, w2, w3, w4;

	d = image[ProgExec++];
	w0 = peekdata( d );
	d = image[ProgExec++];
	w1 = peekdata( d );
	ProgExec++;
	w2 = ((unsigned int)image[ProgExec]<<8) + (unsigned int)image[ProgExec+1];
	ProgExec++;	ProgExec++;
	ProgExec++;
	w3 = ((unsigned int)image[ProgExec]<<8) + (unsigned int)image[ProgExec+1];
	ProgExec++;	ProgExec++;
	ProgExec++;
	w4 = ((unsigned int)image[ProgExec]<<8) + (unsigned int)image[ProgExec+1];
	ProgExec++;	ProgExec++;
#ifdef	DEBUG
printf( "DataReq( %d, %d, %d, %d, %d )\n", w0, w1, w2, w3, w4 );
	return(0);
#else
	return(DataReq( w0, &image[w1], &image[w2], &image[w3], &image[w4] ));
#endif
}

void	value_calc_sub(unsigned int adr, unsigned int type)
{
	switch( type ) {
	case	1:	/* Inc, W, ϐInc() & Dec() (word) */
		/* ɗꍇ͈̏Ӗ̂ŒPȂ鎞ԉ҂ */
		break;
	case	2:	/* Inc, W, ϐ̃CNg(word) */
		image[ adr+1 ]++;
		if( image[ adr+1 ] == 0 ) {
			image[ adr ]++;
		}
		break;
	case	3:	/* Clear, W, ϐ̃[NA(word) */
		image[ adr ] = 0;
		image[ adr+1 ] = 0;
		break;
	case	4:	/* Dec, W, ϐ̃fNg(word) */
		if( image[ adr+1 ] == 0 ) {
			image[ adr ]--;
		}
		image[ adr+1 ]--;
		break;
	case	5:	/* Pulse, W, ϐInc() & Dec() (byte) */
		/* ɗꍇ͈̏Ӗ̂ŒPȂ鎞ԉ҂ */
		break;
	case	6:	/* Inc, W, ϐ̃CNg(byte) */
		image[ adr ]++;
		break;
	case	7:	/* Clear, W, ϐ̃[NA(byte) */
		image[ adr ] = 0;
		break;
	case	8:	/* Dec, W, ϐ̃fNg(byte) */
		image[ adr ]--;
		break;
	}
}

unsigned	int	PageCheck(void)	/* I[oCĂy[W̊mFƐ؂ւ */
{
	unsigned	int	page;

	page = ProgExec>>12;
	if( page ) {
		/* page 1-15̏ꍇ(page 0 ͏Ƀ[hĂ) */
		if( ProgPage != page ) {
			/* XbvAʂ̃y[Wǂݍ */
			ProgPage = page;
#ifndef	DEBUG
			if( PageLoad(ProgPage) != 0 ) {
				return(0x300);
			}
#endif
		}
		ProgExec &= 0xfff;
	}
	return(0);
}

/* C^v^ł̃vO */
/* s^[R[h */
/* 0-FF:exit()̃R[h */
/* 0x100:vȌI */
/* 0x300:vÖُI */
int	execute(void)
{
	volatile	unsigned	char	*io;
	volatile	unsigned	int	*iow;
	unsigned	char	i, n, d, type;
	unsigned	int		adr, let_adr, lv1, lv2, ans, skip;
	void	(*Func)();
#ifdef	DEBUG
	char	buff[256];
#endif

	if( PageCheck() != 0 ) {	/* I[oCy[W̏ */
		return(0x300);
	}
	while(1) {
		type = image[ProgExec++];
#ifdef	DEBUG
printf( "T:%d  Adr:%d  > ", type, ProgExec-1 );
#endif
		switch( type ) {
		case	LET:	/*  p[^ vZe... */
			let_adr = ProgExec;
			d = image[ProgExec++];
			switch( d ) {
			case	VAL1:	/* xxxx(adr,byte)             PoCgϐ */
			case	VAL2:	/* xxxx(adr,word)             QoCgϐ */
				ProgExec++;
				ProgExec++;
				break;
			case	ARRAY:
			case	ARRAYW:
				/* x[XAhXi[i߂ */
				ProgExec++;
				ProgExec++;
				d = image[ProgExec++];
				switch( d ) {
				case	CONST1:			/* xx                         PoCg萔 */
					ProgExec++;
					break;
				case	CONST2:			/* xxxx                       QoCg萔 */
				case	VAL1:			/* xxxx(adr,byte)             PoCgϐ */
				case	VAL2:			/* xxxx(adr,word)             QoCgϐ */
					ProgExec++;
					ProgExec++;
					break;
				}
				break;
			default:
				/* |[g̃f[^A|[g̕Aϐ */
				break;
			}
			/* ̂܂܌pČvZs */
		case	JUDGE:	/* p[^ vZe... */
			if( type == JUDGE ) {
				skip  = ((unsigned int)image[ProgExec]<<8);
				ProgExec++;
				skip += (unsigned int)image[ProgExec];
				ProgExec++;
			}
			n = image[ProgExec++];	/* i[擾 */
			/* X^bN̏ */
			_stk_ptr = 0;
			for( i=0; i<n; i++ ) {
				d = image[ProgExec++];
				if( d < LET ) {
					/* ϐ/萔̏ꍇ */
					_stk_dat[_stk_ptr] = peekdata( d );
/*
#ifdef	DEBUG
printf( "Set stack[%d] = %d  ", _stk_ptr, _stk_dat[_stk_ptr] );
#endif
*/
					_stk_ptr++;
				} else if( d == CALLIN ) {
					/* ֐̏ꍇ */
					switch( image[ProgExec++] ) {
					case	06:	/* GetTimer, W ^C}[lǂݏo */
#ifdef	DEBUG
printf( "GetTimer()\n" );	ans = 0;
#else
						ans = GetTimer();
#endif
						break;
					case	07:	/* SetTimer, WWW ^C}[lݒ */
						d = image[ProgExec++];
						adr = peekdata( d );
						d = image[ProgExec++];
						ans = peekdata( d );
#ifdef	DEBUG
printf( "SetTimer( %d, %d )\n", adr, ans );
						ans = 0;
#else
						ans = SetTimer( adr, ans );
#endif
						break;
					case	23:	/* RecByte",    ID_INFUNC ); PoCg */
#ifdef	DEBUG
printf( "RecByte() : " );
gets( buff );
if( (*buff>='0' && *buff<='9') ||
		(toupper(*buff)>='A' && toupper(*buff)<='F') ) {
	sscanf( buff, "%x", &ans );
} else {
	ans = *buff;
}
#else
						ans = RecByte();
#endif
						break;
					case	24:	/* NwRecByte",    ID_INFUNC ); PoCg */
#ifdef	DEBUG
printf( "NwRecByte() : " );
gets( buff );
if( (*buff>='0' && *buff<='9') ||
		(toupper(*buff)>='A' && toupper(*buff)<='F') ) {
	sscanf( buff, "%x", &ans );
} else {
	ans = 0x100;
}
#else
						ans = NwRecByte();
#endif
						break;
					case	25:	/* DataReq,WWWWWW f[^v */
						ans = FuncDataReq();
						break;
					case	27:	/* Wait,  WW w莞Ԃ̑҂ */
						d = image[ProgExec++];
						adr = peekdata( d );
						d = image[ProgExec++];
						ans = peekdata( d );
#ifdef	DEBUG
printf( "Wait( %d, %d )\n", adr, ans );
#else
						ans = Wait( adr, ans );
#endif
						break;
					case	29:	/* mget", WW, ID_INFUNC ǂݏo */
						d = image[ProgExec++];
						adr = peekdata( d );	/* 16bit̃AhX */
						d = image[ProgExec++];
						ans = peekdata( d );	/* 16bit̃AhX */
						io = (volatile unsigned char *)(((unsigned long)adr<<16L) + (unsigned long)ans);
#ifdef	DEBUG
printf( "mget(0x%lx) : ", io );
gets( buff );
if( (*buff>='0' && *buff<='9') ||
		(toupper(*buff)>='A' && toupper(*buff)<='F') ) {
	sscanf( buff, "%x", &ans );
} else {
	ans = *buff;
}
#else
						ans = (unsigned char)(*io);
#endif
						break;
					case	30:	/* mgetw, WW, ID_INFUNC ǂݏo(word) */
						d = image[ProgExec++];
						adr = peekdata( d );	/* 16bit̃AhX */
						d = image[ProgExec++];
						ans = peekdata( d );	/* 16bit̃AhX */
						iow = (volatile unsigned int *)(((unsigned long)adr<<16L) + (unsigned long)ans);
#ifdef	DEBUG
printf( "mget(0x%lx) : ", iow );
gets( buff );
if( (*buff>='0' && *buff<='9') ||
		(toupper(*buff)>='A' && toupper(*buff)<='F') ) {
	sscanf( buff, "%x", &ans );
} else {
	ans = *buff;
}
#else
						ans = (unsigned int)(*iow);
#endif
						break;
					case	31:	/* GetClock, W NbNǂݏo */
#ifdef	DEBUG
printf( "GetClock()\n" );	ans = 0;
#else
						ans = GetClock();
#endif
						break;
					case	32:	/* SetClock, WW NbNݒ */
						ans = FuncSetClock();
						break;
					case	33:	/* WaitExecEvent, W O̎swCxg̎MmF */
#ifdef	DEBUG
printf( "WaitExecEvent()\n" );
						ans = 0;
#else
						ans = WaitExecEvent();
#endif
						break;
					case	35:	/* ee_write,BWBB, 24LC64ւ̏ */
						d = image[ProgExec++];
						adr = peekdata( d );
						d = image[ProgExec++];
						ans = peekdata( d );
						d = image[ProgExec++];
#ifdef	DEBUG
printf( "ee_write( %d, %d, %d )\n", adr, ans, peekdata( d ) );
						ans = 0;
#else
						ans = ee_write( adr, ans, (unsigned char)peekdata( d ) );
#endif
						break;
					case	36:	/* ee_read,BWB, 24LC64ǂݏo */
						d = image[ProgExec++];
						adr = peekdata( d );
						d = image[ProgExec++];
						ans = peekdata( d );
#ifdef	DEBUG
printf( "ee_read( %d, %d )\n", adr, ans );
						ans = 0;
#else
						ans = ee_read( adr, (unsigned char)ans );
#endif
						break;
					case	37:	/* ee_prog,B, 24LC64vO~O */
#ifdef	DEBUG
printf( "ee_prog()\n" );
#else
						ans = ee_prog();
#endif
						break;
					case	41:	/* time_set,WABW, ̐ݒ */
						d = image[ProgExec++];
						adr = peekdata( d );
						d = image[ProgExec++];
						ans = peekdata( d );
						d = image[ProgExec++];
#ifdef	DEBUG
printf( "time_set()\n" );
						peekdata( d );
						ans  = 0;
#else
						ans = time_set( &image[adr], ans, peekdata( d ) );
#endif
						break;
					case	42:	/* time_get,WAB, ̎擾 */
						d = image[ProgExec++];
						adr = peekdata( d );
						d = image[ProgExec++];
						ans = peekdata( d );
#ifdef	DEBUG
printf( "time_get()\n" );
						ans  = 0;
#else
						ans = time_get( &image[adr], ans );
#endif
						break;
					case	43:	/* time_cmp,WAA, ̔r */
						d = image[ProgExec++];
						adr = peekdata( d );
						d = image[ProgExec++];
						ans = peekdata( d );
#ifdef	DEBUG
printf( "time_cmp()\n" );
						ans  = 0;
#else
						ans = time_cmp( &image[adr], &image[ans] );
#endif
						break;
					case	44:	/* time_update,WAB, ̃JEgAbv */
						d = image[ProgExec++];
						adr = peekdata( d );
						d = image[ProgExec++];
						ans = peekdata( d );
#ifdef	DEBUG
printf( "time_update()\n" );
						ans  = 0;
#else
						ans = time_update( &image[adr], ans );
#endif
						break;
					}
					_stk_dat[_stk_ptr] = ans;
/*
#ifdef	DEBUG
printf( "Set stack[%d] = %d  ", _stk_ptr, _stk_dat[_stk_ptr] );
#endif
*/
					_stk_ptr++;
				} else if( d <= M_NOT+MATH_OFFSET ) {
					/* PvZ */
					lv1 = _stk_ptr-1;
					switch( d ) {
					case	M_INC+MATH_OFFSET:		/*  ++  */
						_stk_dat[ lv1 ]++;
						break;
					case	M_DEC+MATH_OFFSET:		/*  --  */
						_stk_dat[ lv1 ]--;
						break;
					case	M_BITREV+MATH_OFFSET:	/*  ~   */
						_stk_dat[ lv1 ] = ~_stk_dat[ lv1 ];
						break;
					case	M_NOT+MATH_OFFSET:		/*  !   */
						_stk_dat[ lv1 ] = !_stk_dat[ lv1 ];
						break;
					}
				} else {
					/* QvZ */
					lv1 = _stk_ptr-2;
					lv2 = _stk_ptr-1;
					switch( d ) {
					case	M_PLUS+MATH_OFFSET:		/*  +   */
						_stk_dat[ lv1 ] += _stk_dat[ lv2 ];
						break;
					case	M_MINUS+MATH_OFFSET:	/*  -   */
						_stk_dat[ lv1 ] -= _stk_dat[ lv2 ];
						break;
					case	M_SLASH+MATH_OFFSET:	/*  /   */
						_stk_dat[ lv1 ] /= _stk_dat[ lv2 ];
						break;
					case	M_TIMES+MATH_OFFSET:	/*  *   */
						_stk_dat[ lv1 ] *= _stk_dat[ lv2 ];
						break;
					case	M_MOD+MATH_OFFSET:		/*  %   */
						_stk_dat[ lv1 ] %= _stk_dat[ lv2 ];
						break;
					case	M_NEQ+MATH_OFFSET:		/*  !=  */
						if( _stk_dat[ lv1 ] != _stk_dat[ lv2 ] ) {
							_stk_dat[ lv1 ] = 1;	/* ^ */
						} else {
							_stk_dat[ lv1 ] = 0;	/* U */
						}
						break;
					case	M_GEQ+MATH_OFFSET:		/*  >=  */
						if( _stk_dat[ lv1 ] >= _stk_dat[ lv2 ] ) {
							_stk_dat[ lv1 ] = 1;	/* ^ */
						} else {
							_stk_dat[ lv1 ] = 0;	/* U */
						}
						break;
					case	M_GTR+MATH_OFFSET:		/*  >   */
						if( _stk_dat[ lv1 ] > _stk_dat[ lv2 ] ) {
							_stk_dat[ lv1 ] = 1;	/* ^ */
						} else {
							_stk_dat[ lv1 ] = 0;	/* U */
						}
						break;
					case	M_LEQ+MATH_OFFSET:		/*  <=  */
						if( _stk_dat[ lv1 ] <= _stk_dat[ lv2 ] ) {
							_stk_dat[ lv1 ] = 1;	/* ^ */
						} else {
							_stk_dat[ lv1 ] = 0;	/* U */
						}
						break;
					case	M_LSS+MATH_OFFSET:		/*  <   */
						if( _stk_dat[ lv1 ] < _stk_dat[ lv2 ] ) {
							_stk_dat[ lv1 ] = 1;	/* ^ */
						} else {
							_stk_dat[ lv1 ] = 0;	/* U */
						}
						break;
					case	M_CMP+MATH_OFFSET:		/*  ==  */
						if( _stk_dat[ lv1 ] == _stk_dat[ lv2 ] ) {
							_stk_dat[ lv1 ] = 1;	/* ^ */
						} else {
							_stk_dat[ lv1 ] = 0;	/* U */
						}
						break;
					case	M_SHIFTL+MATH_OFFSET:	/*  <<  */
						_stk_dat[ lv1 ] <<= _stk_dat[ lv2 ];
						break;
					case	M_SHIFTR+MATH_OFFSET:	/*  >>  */
						_stk_dat[ lv1 ] >>= _stk_dat[ lv2 ];
						break;
					case	M_AND+MATH_OFFSET:		/*  &&  */
						if( _stk_dat[ lv1 ] && _stk_dat[ lv2 ] ) {
							_stk_dat[ lv1 ] = 1;	/* ^ */
						} else {
							_stk_dat[ lv1 ] = 0;	/* U */
						}
						break;
					case	M_BITAND+MATH_OFFSET:	/*  &   */
						_stk_dat[ lv1 ] &= _stk_dat[ lv2 ];
						break;
					case	M_OR+MATH_OFFSET:		/*  ||  */
						if( _stk_dat[ lv1 ] || _stk_dat[ lv2 ] ) {
							_stk_dat[ lv1 ] = 1;	/* ^ */
						} else {
							_stk_dat[ lv1 ] = 0;	/* U */
						}
						break;
					case	M_BITOR+MATH_OFFSET:	/*  |   */
						_stk_dat[ lv1 ] |= _stk_dat[ lv2 ];
						break;
					}
/*
#ifdef	DEBUG
printf( "Set stack[%d] = %d  ", lv1, _stk_dat[lv1] );
#endif
*/
					_stk_ptr--;
				}
			}
			_stk_ptr--;		/* ʕ̃X^bNɖ߂ */
			switch( type ) {
			case	LET:	/* ϐɃf[^ */
				d = image[let_adr++];
				switch( d ) {
				case	VAL1:	/* xxxx(adr,byte)             PoCgϐ */
					adr = ((unsigned int)image[let_adr]<<8) + (unsigned int)image[let_adr+1];
					image[ adr ] = (unsigned char)_stk_dat[ _stk_ptr ];
#ifdef	DEBUG
printf( "image[%d] = %d\n", adr, image[adr] );
#endif
					break;
				case	VAL2:	/* xxxx(adr,word)             QoCgϐ */
					adr = ((unsigned int)image[let_adr]<<8) + (unsigned int)image[let_adr+1];
					image[ adr ] = (unsigned char)(_stk_dat[ _stk_ptr ]>>8);
					image[ adr+1 ] = (unsigned char)(_stk_dat[ _stk_ptr ]&0xff);
#ifdef	DEBUG
printf( "image[%d+0] = %d  ", adr, image[adr] );
printf( "image[%d+1] = %d\n", adr, image[adr+1] );
#endif
					break;
				case	ARRAY:	/* 萔/ϐ(z̈ʒu) */
				case	ARRAYW:	/* 萔/ϐ(z̈ʒu) */
					/* x[XAhX̎擾(lv1ɋL) */
					lv1 = ((unsigned int)image[let_adr]<<8) + (unsigned int)image[let_adr+1];
					let_adr++;
					let_adr++;
					switch( image[let_adr++] ) {
					case	CONST1:			/* xx                         PoCg萔 */
						adr = (unsigned int)image[let_adr];
						break;
					case	CONST2:			/* xxxx                       QoCg萔 */
						adr = ((unsigned int)image[let_adr]<<8) + (unsigned int)image[let_adr+1];
						break;
					case	VAL1:			/* xxxx(adr,byte)             PoCgϐ */
						/* 2001/06 bug fix */
						ans = ((unsigned int)image[let_adr]<<8) + (unsigned int)image[let_adr+1];
						adr = (unsigned int)image[ans];
						break;
					case	VAL2:			/* xxxx(adr,word)             QoCgϐ */
						ans = ((unsigned int)image[let_adr]<<8) + (unsigned int)image[let_adr+1];
						adr = ((unsigned int)image[ans]<<8) + (unsigned int)image[ans+1];
						break;
					}
					if( d == ARRAYW ) {
						adr <<= 1;
						adr += lv1;
						image[ adr ] = (unsigned char)_stk_dat[ _stk_ptr ]>>8;
						image[ adr+1 ] = (unsigned char)_stk_dat[ _stk_ptr ]&0xff;
#ifdef	DEBUG
printf( "image[%d](word) = %d\n", adr, (image[adr]<<8)+image[adr+1] );
#endif
					} else {
						adr += lv1;
						image[ adr ] = (unsigned char)_stk_dat[ _stk_ptr ];
#ifdef	DEBUG
printf( "image[%d] = %d\n", adr, image[adr] );
#endif
					}
					break;
				default:
					set_port( d, _stk_dat[ _stk_ptr ] );
#ifdef	DEBUG
printf( "set_port( %d, %d )\n", d, _stk_dat[ _stk_ptr ] );
#endif
					break;
				}
				break;
			case	JUDGE:
				if( _stk_dat[ _stk_ptr ] == 0 ) {
					ProgExec = skip;
					if( PageCheck() != 0 ) {	/* I[oCy[W̏ */
						return(0x300);
					}
				}
#ifdef	DEBUG
if( _stk_dat[ _stk_ptr ] == 0 ) {
	printf( "if() skip\n" );
} else {
	printf( "if() exec\n" );
}
#endif
				break;
			}
			break;
		case	GOTO:	/* AhX                */
			adr  = ((unsigned int)image[ProgExec++]<<8);
			adr += (unsigned int)image[ProgExec++];
#ifdef	DEBUG
printf( "goto %d\n", adr );
#endif
			ProgExec = adr;
			if( PageCheck() != 0 ) {	/* I[oCy[W̏ */
				return(0x300);
			}
			break;
		case	CALL:	/* AhX               ֐Ăяo */
			adr  = ((unsigned int)image[ProgExec++]<<8);
			adr += (unsigned int)image[ProgExec++];
			Nest_adr[Nest] = (ProgPage<<12)+ProgExec;	/* ߂AhXi[ */
			Nest++;
#ifdef	DEBUG
printf( "call %d\n", adr );
#endif
			ProgExec = adr;
			if( PageCheck() != 0 ) {	/* I[oCy[W̏ */
				return(0x300);
			}
			break;
		case	CALLIN:	/* ֐ 萔/ϐ...  ֐Ăяo */
			switch( image[ProgExec++] ) {
			case	1:	/* Pulse, W, ϐInc() & Dec() */
			case	2:	/* Inc, W, ϐ̃CNg */
			case	3:	/* Clear, W, ϐ̃[NA */
			case	4:	/* Dec, W, ϐ̃fNg */
				lv2 = image[ProgExec-1];	/* ֐ʂLĂ */
				d = image[ProgExec++];
				switch( d ) {
				case	VAL1:	/* xxxx(adr,byte)             PoCgϐ */
					adr = ((unsigned int)image[ProgExec]<<8) + (unsigned int)image[ProgExec+1];
					value_calc_sub( adr, lv2+4 );
					ProgExec++;
					ProgExec++;
					break;
				case	VAL2:	/* xxxx(adr,word)             QoCgϐ */
					adr = ((unsigned int)image[ProgExec]<<8) + (unsigned int)image[ProgExec+1];
					value_calc_sub( adr, lv2 );
					ProgExec++;
					ProgExec++;
					break;
				default:
					switch( lv2 ) {
					case	1:	/* Pulse */
						switch( d ) {
						case	A_DT:
							inc_port_data(  0 );
							dec_port_data(  0 );
							break;
						case	A_DIR:
							inc_port_tris(  2 );
							dec_port_tris(  2 );
							break;
						case	B_DT:
							inc_port_data( 20 );
							dec_port_data( 20 );
							break;
						case	B_DIR:
							inc_port_tris( 22 );
							dec_port_tris( 22 );
							break;
						case	C_DT:
							inc_port_data( 40 );
							dec_port_data( 40 );
							break;
						case	C_DIR:
							inc_port_tris( 42 );
							dec_port_tris( 42 );
							break;
						default:
							lv1 = get_port_data( d );
							set_port( d, lv1+1 );
							set_port( d, lv1 );
							break;
						}
						break;
					case	2:	/* Inc */
						switch( d ) {
						case	A_DT:	inc_port_data(  0 );	break;
						case	A_DIR:	inc_port_tris(  2 );	break;
						case	B_DT:	inc_port_data( 20 );	break;
						case	B_DIR:	inc_port_tris( 22 );	break;
						case	C_DT:	inc_port_data( 40 );	break;
						case	C_DIR:	inc_port_tris( 42 );	break;
						default:
							lv1 = get_port_data( d );
							lv1++;
							set_port( d, lv1 );
							break;
						}
						break;
					case	3:	/* Clear */
						set_port( d, 0 );
						break;
					case	4:	/* Dec */
						switch( d ) {
						case	A_DT:	dec_port_data(  0 );	break;
						case	A_DIR:	dec_port_tris(  2 );	break;
						case	B_DT:	dec_port_data( 20 );	break;
						case	B_DIR:	dec_port_tris( 22 );	break;
						case	C_DT:	dec_port_data( 40 );	break;
						case	C_DIR:	dec_port_tris( 42 );	break;
						default:
							lv1 = get_port_data( d );
							lv1--;
							set_port( d, lv1 );
							break;
						}
						break;
					}
					break;
				}
				break;
			case	5:	/* DataDump, B, f[^̃_v */
				d = image[ProgExec++];
#ifdef	DEBUG
printf( "DataDump( %d )\n", peekdata( d ) );
#else
				DataDump( peekdata( d ) );
#endif
				break;
			case	6:	/* GetTimer, W ^C}[lǂݏo */
#ifdef	DEBUG
printf( "GetTimer()\n" );
#else
				GetTimer();
#endif
				break;
			case	7:	/* SetTimer, WWW ^C}[lݒ */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "SetTimer( %d, %d )\n", adr, ans );
#else
				SetTimer( adr, ans );
#endif
				break;
			case	8:	/* StartDump, WWW f[^̃_vJn */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
				d = image[ProgExec++];
				lv1 = peekdata( d );
#ifdef	DEBUG
printf( "StartDump(0x%x,0x%x,%d)\n",adr,ans,lv1 );
#else
				StartDump(adr,ans,lv1);
#endif
				break;
			case	9:	/* EndDump, f[^̃_vI */
#ifdef	DEBUG
printf( "EndDump()\n" );
#else
				EndDump();
#endif
				break;
			case	10:	/* return,   ֐̏I */
#ifdef	DEBUG
printf( "return()\n" );
#endif
				if( Nest <= 0 ) {
					return(0);	/* sI */
				}
				Nest--;
				ProgExec = Nest_adr[Nest];
				if( PageCheck() != 0 ) {	/* I[oCy[W̏ */
					return(0x300);
				}
				break;
			case	11:	/* exit" ); ȈՌI */
				d = image[ProgExec++];
#ifdef	DEBUG
printf( "exit(%d)\n", peekdata( d ) );
#endif
				return(peekdata( d ));	/* sI */
			case	12:	/* SendByte, B PoCgo */
				d = image[ProgExec++];
#ifdef	DEBUG
printf( "SendByte( %d )\n", peekdata( d ) );
#else
				SendByte( peekdata( d ) );
#endif
				break;
			case	13:	/* SendWord, W QoCgo */
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "SendWord( %d )\n", ans );
#else
				SendByte( (ans>>8)&0xff );
				SendByte( ans&0xff );
#endif
				break;
			case	14:	/* SendHex, B PoCgóiPUiQj */
				d = image[ProgExec++];
#ifdef	DEBUG
printf( "SendHex( %02X )\n", peekdata( d ) );
#else
				SendHex( peekdata( d ) );
#endif
				break;
			case	15:	/* SendCode, W Xg{bNX\p̃bZ[Wԍ𑗐M */
				d = image[ProgExec++];
#ifdef	DEBUG
printf( "SendCode( %d )\n", peekdata( d ) );
#else
				SendCode( peekdata( d ) );
#endif
				break;
			case	16:	/* StartMsg,  񑗐M̊Jnʒm */
#ifdef	DEBUG
printf( "StartMsg()\n" );
#else
				SendEvent( EV_STR );
#endif
				break;
			case	17:	/* SendMsg, S 񑗐M */
#ifdef	DEBUG
printf( "SendMsg( %s )\n", &image[ProgExec] );
				while( image[ProgExec] ) {
					ProgExec++;
				}
#else
				while( image[ProgExec] ) {
					SendByte( image[ProgExec++] );
				}
#endif
				ProgExec++;
				break;
			case	18:	/* EndMsg, 񑗐M̏Iʒm */
#ifdef	DEBUG
printf( "EndMsg()\n" );
#else
				SendByte(0);
#endif
				break;
			case	19:	/* SendNum2Str, BW lɂďo */
				/* B:0-9:wA10-19:[߂ƌ(0-9)w */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "SendNum2Str( %d, %d )\n", adr, ans );
#else
				SendNum2Str( adr, ans );
#endif
				break;
			case	20:	/* InitIo I/Ȍ */
				/* Sē͏Ԃɂ */
#ifdef	DEBUG
printf( "InitIo()\n" );
#else
				initio();
#endif
				break;
			case	21:	/* VppVolt, F VPP̐ݒ */
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "VppVolt( %d )\n", ans );
#else
				VppVolt( ans );
#endif
				break;
			case	22:	/* VccVolt, F VCC̐ݒ */
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "VccVolt( %d )\n", ans );
#else
				VccVolt( ans );
#endif
				break;
			case	23:	/* RecByte PoCg */
#ifdef	DEBUG
printf( "RecByte()\n" );
#else
				RecByte();
#endif
				break;
			case	24:	/* NwRecByte PoCg(no wait) */
#ifdef	DEBUG
printf( "NwRecByte()\n" );
#else
				NwRecByte();
#endif
				break;
			case	25:	/* DataReq,WWWWWW f[^v */
				FuncDataReq();
				break;
			case	27:	/* Wait,  WWW w莞Ԃ̑҂ */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "Wait( %d, %d )\n", adr, ans );
#else
				Wait( adr, ans );
#endif
				break;
			case	28:	/* mset, WWB ւ̏ */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
				io = (volatile unsigned char *)(((unsigned long)adr<<16L) + (unsigned long)ans);
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "mset( %ld, %d )\n", io, ans );
#else
				*io = (unsigned char)ans;
#endif
				break;
/* ̕ӂ̊֐̓^[lgȂƒPɎԉ҂ł̗pƂȂ */
			case	29:	/* mget", WW, ID_INFUNC ǂݏo */
				d = image[ProgExec++];
				adr = peekdata( d );	/* 16bit̃AhX */
				d = image[ProgExec++];
				ans = peekdata( d );	/* 16bit̃AhX */
				break;
			case	30:	/* mgetw, WW, ID_INFUNC ǂݏo(word) */
				d = image[ProgExec++];
				adr = peekdata( d );	/* 16bit̃AhX */
				d = image[ProgExec++];
				ans = peekdata( d );	/* 16bit̃AhX */
				break;
			case	31:	/* GetClock, W NbNǂݏo */
#ifdef	DEBUG
printf( "GetClock()\n" );
#else
				GetClock();
#endif
				break;
			case	32:	/* SetClock, WW NbNݒ */
				FuncSetClock();
				break;
			case	33:	/* WaitExecEvent, W O̎swCxg̎MmF */
#ifdef	DEBUG
printf( "WaitExecEvent()\n" );
#else
				WaitExecEvent();
#endif
				break;
			case	34:	/* Message, S 񑗐M(header܂) */
#ifdef	DEBUG
printf( "Message( %s )\n", &image[ProgExec] );
				while( image[ProgExec] ) {
					ProgExec++;
				}
#else
				SendEvent( EV_STR );
				while( image[ProgExec] ) {
					SendByte( image[ProgExec++] );
				}
				SendByte(0);
#endif
				ProgExec++;
				break;
			case	35:	/* ee_write,BWBB, 24LC64ւ̏ */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
				d = image[ProgExec++];
#ifdef	DEBUG
printf( "ee_write( %d, %d, %d )\n", adr, ans, peekdata( d ) );
#else
				ee_write( adr, ans, (unsigned char)peekdata( d ) );
#endif
				break;
			case	36:	/* ee_read,BWBB, 24LC64ǂݏo */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "ee_read( %d, %d )\n", adr, ans );
#else
				ee_read( adr, (unsigned char)ans );
#endif
				break;
			case	37:	/* ee_prog,B, 24LC64vO~O */
#ifdef	DEBUG
printf( "ee_prog()\n" );
#else
				ee_prog();
#endif
				break;
			case	38:	/* ClockStart, , NbN荞ݍĊJ */
#ifdef	DEBUG
printf( "ClockStart()\n" );
#else
				c_start();
#endif
				break;
			case	39:	/* ClockStop, , NbN荞ݒ~ */
#ifdef	DEBUG
printf( "ClockStop()\n" );
#else
				c_stop();
#endif
				break;
			case	40:	/* InitVolt, , VPP/VCCd */
#ifdef	DEBUG
printf( "InitVolt()\n" );
#else
				initvolt();
#endif
				break;
			case	41:	/* time_set,WABW, ̐ݒ */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
				d = image[ProgExec++];
#ifdef	DEBUG
printf( "time_set()\n" );
				peekdata( d );
#else
				time_set( &image[adr], ans, peekdata( d ) );
#endif
				break;
			case	42:	/* time_get,WAB, ̎擾 */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "time_get()\n" );
#else
				time_get( &image[adr], ans );
#endif
				break;
			case	43:	/* time_cmp,WAA, ̔r */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "time_cmp()\n" );
#else
				time_cmp( &image[adr], &image[ans] );
#endif
				break;
			case	44:	/* time_update,WAB, ̃JEgAbv */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
#ifdef	DEBUG
printf( "time_update()\n" );
#else
				time_update( &image[adr], ans );
#endif
				break;
			case	45:	/* time_rstcarry, A, ̃L[tONA */
				d = image[ProgExec++];
				adr = peekdata( d );
#ifdef	DEBUG
printf( "time_rstcarry()\n" );
#else
				time_rstcarry( &image[adr] );
#endif
				break;
			case	46:	/* memcpy, AAW, memcpy( dst, src, length ) */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
				d = image[ProgExec++];
#ifdef	DEBUG
printf( "memcpy()\n" );
#else
				memcpy( &image[adr], &image[ans], peekdata( d ) );
#endif
				break;
			case	50:	/* call, , }VR[ */
				d = image[ProgExec++];
				adr = peekdata( d );
				d = image[ProgExec++];
				ans = peekdata( d );
				Func = (void *)(((unsigned long)adr<<16L)+(unsigned long)ans);
#ifdef	DEBUG
printf( "call(0x%x)\n", (unsigned long)Func );
#else
				Func();
#endif
				break;
			}
			break;
		case	FUNC_END:	/*                        ֐̏I */
			if( Nest <= 0 ) {
#ifdef	DEBUG
printf( "sI\n" );
#endif
				return(0);		/* sI */
			}
			Nest--;
			ProgExec = Nest_adr[Nest];
			if( PageCheck() != 0 ) {	/* I[oCy[W̏ */
				return(0x300);
			}
#ifdef	DEBUG
printf( "֐I\n" );
#endif
			break;
		case	PROG_END:	/* vȌI */
#ifdef	DEBUG
printf( "vȌI\n" );
#endif
			return(0);
		default:
#ifdef	DEBUG
printf( "default: type = %d\n", type );
#endif
			return(0x300);
		}
	}
}

#ifdef	DEBUG
int	str2byte(char *buff)
{
	int		rc;
	char	temp[3];

	memcpy( temp, buff, 2 );
	temp[2] = 0;
	sscanf( temp, "%x", &rc );
	return(rc);
}

int	bin_convert(unsigned char *dst, char *src)
{
	if( *src != ':' ) {
		return(-1);
	}
	if( strlen( src ) < 11 ) {
		return(-1);
	}
	src++;
	while( isalnum(*src) ) {
		*dst = (unsigned char)str2byte( src );
		dst++;
		src += 2;
	}
	return(0);
}

int	ReadData(FILE *fp)
{
	char	buff[256];
	unsigned char	bin[128];
	int		i, type, datalen;
	long	adr;
	long	segment;

	segment = 0;
	for( ;; ) {
		if( fgets( buff, 256, fp ) == NULL ) {
			break;
		}
		if( bin_convert( bin, buff ) != 0 ) {
			continue;
		}
		/* :LLAAAATTDD..DDSS */
		datalen = bin[0];
		adr = segment;
		adr += (long)(bin[1])<<8;
		adr += (long)bin[2];
		type = bin[3];
		if( type == 0 ) {		/* f[^ */
			for( i=0; i<datalen; i++ ) {
				if( (adr+i) <= 1 ) {
					continue;	/* Ŝ̃f[^XLbv */
				}
				image[adr+i-2] = bin[i+4];
			}
		} else if( type == 1 ) {	/* f[^̏I */
			return(0);
		} else if( type == 2 ) {	/* gAhXw */
			segment = 0;
			for( i=0; i<datalen; i++ ) {
				segment <<= 8;
				segment += (unsigned long)bin[i+4];
			}
			segment *= 16;
		} else {
			return(-1);		/* tH[}bgُ */
		}
	}
	return(0);
}

int	main(int ar, char *av[])
{
	int		d;
	FILE	*fp;

	printf( "ȈՌg[T Ver.1.0 Copyright (C) 2000 T.Sagae\n" );
	if( ar != 2 ) {
		printf( "t@C͂ĉ\n" );
		return(0);
	}
	if( (fp=fopen(av[1],"rb")) == NULL ) {
		printf( "[ %s ] I[vł܂\n", av[1] );
		return(0);
	}
	if( ReadData( fp ) != 0 ) {
		fclose( fp );
		printf( "f[^ǂݍ݃G[\n" );
		return(0);
	}
	fclose( fp );
	ProgExec = 60;
	printf( "JnAhX %d \n", ProgExec );
	printf( "execude() = %d\n", execute() );
	return(0);
}
#endif
