#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<io.h>
#include	<ctype.h>

#define	VER	"The optimization tool Version 1.00 Copyright (C) 2000 T.Sagae"

typedef	unsigned	char	uchar;
#include	"opt_pro.h"

#define	BUFF_MAX	10
#define	BUFF_LEN	256
char	table[512];						/* ϊe[u */
char	*source;						/* \[Xt@C */
char	*backup;						/* obNAbv */
char	buff1[BUFF_LEN], buff2[BUFF_LEN], buff3[BUFF_LEN], buff4[BUFF_LEN];
char	r_buff1[BUFF_MAX][BUFF_LEN];	/*	sǂݍ݃obt@			*/
char	r_buff2[BUFF_MAX][BUFF_LEN];	/*	폜obt@	*/
char	r_buff3[BUFF_MAX][BUFF_LEN];	/*	#NUM ̒lij			*/
char	check[BUFF_MAX];				/*	ϊmFstO			*/
int		ptr, ptr_cnt;					/*	f[^i[s̋Lp		*/
int		l_min = 999, l_max = 0;
int		debug;
FILE	*fp, *out_fp;

void	help(char *exe)							/*	gp@\				*/
{
	if( strstr( exe, "32" ) != NULL ) {
		printf( "optim32.exe table target_file backup_file\n\n" );
	} else {
		printf( "optim.exe table target_file backup_file\n\n" );
	}
}

void	opt_init()						/*						*/
{
	char	tmp1[BUFF_LEN], tmp2[BUFF_LEN], tmp3[BUFF_LEN], *pt;
	int		n, cnt, line, num_flg;

	if( (fp=fopen( table, "r" )) == NULL ) {
		printf( "File open error [%s]\n", table );
		exit( -1 );
	}
	for( n=0; n<BUFF_MAX; n++ ) {
		r_buff1[n][0] = 0x00;
		r_buff2[n][0] = 0x00;
		check[n] = 0;					/*	ϊmFstO			*/
	}
	line = 0;
	num_flg = 0;						/*	#NUM wȂ				*/
	while( fgets( buff1, BUFF_LEN, fp ) != NULL ) {
		line++;
		if( buff1[1] != ':' && buff1[0] != '#' ) {
			continue;
		}
		if( tolower( buff1[0] ) != 'o' ) {
			printf( "[%d] o w̃f[^܂\n", line );
			exit(-1);
		}
		cust_dt( buff1, tmp1, tmp2 );	/*	f[^̐`	*/
		cnt = 1;						/*	Aǂݍݍs		*/
		strcpy( buff2, &tmp1[2] );
		while( 1 ) {
			if( fgets( buff1, BUFF_LEN, fp ) == NULL ) {
				printf( "[%d] rŃf[^I܂\n", line );
				exit(-1);
			}
			line++;
			if( buff1[1] != ':' && buff1[0] != '#' ) {
				continue;
			}
			if( tolower( buff1[0] ) != 'o' ) {
				break;
			}
			cust_dt( buff1, tmp1, tmp2 );	/*	f[^̐`	*/
			cnt++;						/*	Aǂݍݍs		*/
			if( cnt > l_max ) {
				l_max = cnt;
			}
			strcat( buff2, &tmp1[2] );
		}
		if( (pt = strchr( buff2, '#' )) != NULL ) {
			if( strncmp( pt, "#NUM", 4 ) == 0 ) {
				pt++;
				if( (pt = strchr( pt, '#' )) != NULL ) {
					if( strncmp( pt, "#NUM", 4 ) == 0 ) {
						printf( "[%d] #NUM  o: sɂPgpo܂\n",
								line );
						exit(-1);
					}
				}
			}
		}
		do {
			if( tolower( buff1[0] ) == 'c' ) {
				strcpy( buff3, &buff1[2] );
				while( 1 ) {
					if( fgets( buff1, BUFF_LEN, fp ) == NULL ) {
						printf( "[%d] rŃf[^I܂\n", line );
						exit(-1);
					}
					line++;
					if( buff1[1] != ':' && buff1[0] != '#' ) {
						continue;
					}
					if( tolower( buff1[0] ) != 'c' ) {
						break;
					}
					strcat( buff3, &buff1[2] );
				}
				if( cnt < l_min ) {
					l_min = cnt;
				}
				if( num_flg ) {
					sprintf( tmp2, "#%s#%s", tmp3, buff2 );
					if( debug ) {
						printf("L[ݒ %s = %s\n", tmp2, buff3 );
					}
					str_set( tmp2, buff3, 'c' );
					num_flg = 0;
				} else {
					if( debug ) {
						printf("L[ݒ %s = %s\n", buff2, buff3 );
					}
					str_set( buff2, buff3, 'c' );
				}
				check[cnt] = 1;				/*	ϊmFstO			*/
			} else if( tolower( buff1[0] ) == 'd' ) {
				strcpy( buff3, "##del##" );
				if( num_flg ) {
					sprintf( tmp2, "#%s#%s", tmp3, buff2 );
					if( debug ) {
						printf("L[ݒ %s = %s\n", tmp2, buff3 );
					}
					str_set( tmp2, buff3, 'd' );
					num_flg = 0;
					buff3[0] = 0x00;
				} else {
					if( debug ) {
						printf("L[ݒ %s = %s\n", buff2, buff3 );
					}
					str_set( buff2, buff3, 'd' );
				}
				check[cnt] = 1;				/*	ϊmFstO			*/
				if( fgets( buff1, BUFF_LEN, fp ) == NULL ) {
					printf( "[%d] rŃf[^I܂\n", line );
					exit(-1);
				}
			} else if( tolower( buff1[0] ) == '#' ) {
				if( num_flg ) {
					printf( "[%d] #NUM QspĂ܂\n",line);
					exit(-1);
				}
				cust_dt( buff1, tmp1, tmp2 );	/*	f[^̐`	*/
				if( strcmp( tmp1, "#NUM = #NUM" ) == 0 ) {
					num_flg = 1;
					strcpy( tmp3, tmp2 );
					if( fgets( buff1, BUFF_LEN, fp ) == NULL ) {
						printf( "[%d] rŃf[^I܂\n", line );
						exit(-1);
					}
				} else if( strcmp( tmp1, "#NUM = *" ) == 0 ) {
					num_flg = 1;
					strcpy( tmp3, "*" );
					if( fgets( buff1, BUFF_LEN, fp ) == NULL ) {
						printf( "[%d] rŃf[^I܂\n", line );
						exit(-1);
					}
				} else {
					printf( "[%d] #NUM w̃f[^ɊԈႢ܂\n",line);
					exit(-1);
				}
			} else {
				printf( "[%d] ُȃf[^Ă܂\n", line );
				exit(-1);
			}
		} while( strncmp( buff1, "#END", 4 ) != 0 );
	}
	fclose( fp );
	if( debug ) {
		printf( "rŏs = %d  ős = %d\n", l_min, l_max );
	}
	if( l_min == 999 ) {
		l_min = l_max;
	}
	if( l_min < 1 || l_max < 1 ) {
		printf( "f[^tH[}bgɈُ킪܂\n" );
		printf( "rf[^Z܂\n" );
		exit(-1);
	}
	if( l_min >= BUFF_MAX || l_max >= BUFF_MAX ) {
		printf( "f[^tH[}bgɈُ킪܂\n" );
		printf( "rf[^܂\n" );
		exit(-1);
	}
	if( l_min > l_max ) {
		printf( "rf[^܂\n" );
		exit(-1);
	}
	ptr = 0;							/*	f[^i[Jnʒu			*/
	ptr_cnt = 0;						/*	f[^i[				*/
	if( (fp=fopen( backup, "r" )) == NULL ) {
		printf( "File open error [%s]\n", backup );
		exit( -1 );
	}
	if( (out_fp=fopen( source, "w" )) == NULL ) {
		printf( "File open error [%s]\n", source );
		fclose( fp );
		exit( -1 );
	}
	return;
}

void	opt_end()						/*	I					*/
{
	int		n;

	while( ptr_cnt != 0 ) {
		n = ptr - ptr_cnt;
		if( n < 0 ) {
			n += BUFF_MAX;
		}
		fprintf( out_fp, "%s", r_buff1[n] );
		ptr_cnt--;
	}
	fclose( fp );
	fclose( out_fp );
}

void	cust_dt(char *src, char *dst1, char *dst2)	/*	Rg폜ʃe[uɕۑ*/
{
	char	*pt, *ptr_dst, tmp[80];
	int		n, m;

	n = m = 0;
	while( 1 ) {
		if( src[n] == ' ' || src[n] == '\t' ) {
			dst1[m++] = ' ';
			n++;
		}
		while( src[n] == ' ' || src[n] == '\t' ) {
			n++;
		}
		if( src[n] == 0x00 ) {
			break;
		}
		while( src[n] != ' ' && src[n] != '\t' ) {
			if( src[n] == 0x00 ) {
				break;
			}
			dst1[m++] = src[n++];
		}
		if( src[n] == 0x00 ) {
			break;
		}
	}
	dst1[m] = 0x00;
	if( m > 0 ) {
		if( strchr( dst1, ';' ) != NULL ) {/*	Rg	*/
			*(strchr( dst1, ';' )) = 0x00;
			n = strlen( dst1 );
			while( n > 0 ) {
				if( dst1[n-1] == ' ' || dst1[n-1] == '\t' ) {
					dst1[n-1] = 0x00;
				} else {
					break;
				}
			}
		} else {
			if( dst1[m-1] == 0xd || dst1[m-1] == 0xa ) {
				dst1[m-1] = 0x00;
			}
			if( m > 1 ) {
				if( dst1[m-2] == 0xd || dst1[m-2] == 0xa ) {
					dst1[m-2] = 0x00;
				}
			}
		}
	}
	strcpy( tmp, dst1 );
	pt = tmp;
	ptr_dst = dst1;
	dst2[0] = 0x00;
	while( *pt != 0x00 ) {
		if( isdigit( *pt ) && !isalnum( *(pt-1) ) &&
				*(pt-1) != '_' && *(pt-1) != '.' ) {
			n = 0;
			while( ( isdigit( *pt ) ||
					( toupper( *pt ) >= 'A' && toupper( *pt ) <='F' ) ) &&
					*pt != 0x00 ) {
				dst2[n++] = *pt;
				dst2[n] = 0x00;
				pt++;
			}
			if( toupper( *pt ) == 'H' ) {
				dst2[n++] = 'H';	/*	PUiw	*/
				dst2[n] = 0x00;
				pt++;
			}
			*ptr_dst++ = '#';
			*ptr_dst++ = 'N';
			*ptr_dst++ = 'U';
			*ptr_dst++ = 'M';
			*ptr_dst++ = *pt;
			if( *pt == 0x00 ) {
				break;
			}
			pt++;
		} else {
			*ptr_dst++ = *pt++;
		}
	}
	*ptr_dst = 0x00;
	if( debug ) {
		printf("(cust_dt) dst1 [%s]  dst2 = [%s]\n", dst1, dst2 );
	}
}

int		get_data( int n )					/*	w̃f[^擾	*/
{
	int		m, k, p;

	p = 0;
	buff1[0] = 0x00;
	m = ptr-1;
	if( m < 0 ) {
		m+=10;
	}
	if( r_buff2[m][0] == 0x00 ) {
		return -1;
	}
	buff4[0] = 0x00;
	for( k=0; k<n; k++ ) {
		m = ptr-1-k-p;
		if( m < 0 ) {
			m+=10;
		}
		if( r_buff2[m][0] == 0x00 ) {	/*	NULL ͓ǂݔ΂	*/
			p++;
			if( p >= ptr_cnt ) {
				return -1;
			}
			k--;
			continue;
		}
		strcpy( buff3, buff1 );
		strcpy( buff1, r_buff2[m] );
		if( r_buff3[m][0] != 0x00 ) {
			strcpy( buff4, r_buff3[m] );
		}
		strcat( buff1, buff3 );
	}
	return m;
}

void	check_data()	/*	Kvɂ폜^ύX̎s*/
{
	char	*pt;
	int		n, rc, rc2, m;

	for( n=l_min; (n<=l_max) && (n<=ptr_cnt);n++ ) {
		if( !(check[n]) ) {				/*	ϊmFstO			*/
			continue;
		}
		rc = get_data( n );				/*	w̃f[^擾	*/
		if( rc != -1 ) {
			if( buff4[0] != 0x00 ) {
				sprintf( buff2, "#%s#%s", buff4, buff1 );
				strcpy( buff1, buff2 );
				if( debug ) {
					printf( "f[^ = %s\n", buff1 );
				}
				rc2 = str_srh( buff1, buff2, 1 );
				if( rc2 == -1 ) {
					buff1[1] = '*';
					strcpy( &buff1[2], strchr( &buff1[1], '#' ) );
					if( debug ) {
						printf( "f[^ = %s\n", buff1 );
					}
					rc2 = str_srh( buff1, buff2, 1 );
				}
			} else {
				if( debug ) {
					printf( "f[^ = %s\n", buff1 );
				}
				rc2 = str_srh( buff1, buff2, 1 );
			}
			switch( rc2 ) {
				case	'c':			/*	ύX	*/
					if( debug ) {
						printf( "f[^ύXO ptr %d ptr_cnt = %d\n",
								ptr, ptr_cnt );
					}
					if( ptr > rc ) {
						ptr_cnt -= (ptr-rc);
					} else {
						ptr_cnt -= (ptr+10-rc);
					}
					ptr = rc;
					strcpy( r_buff1[ptr], buff2 );
					if( buff4[0] != 0x00 ) {
						while( (pt = strchr( buff2, '#' )) != NULL ) {
							if( strncmp( pt, "#NUM", 4 ) == 0 ) {
								*pt = 0x00;
								strcpy( r_buff1[ptr], buff2 );
								strcat( r_buff1[ptr], buff4 );
								strcat( r_buff1[ptr], (char *)(pt+4) );
								break;
							}
						}
					}
					strcpy( r_buff2[ptr], buff2 );
					ptr++;
					if( ptr >= BUFF_MAX ) {
						ptr = 0;
					}
					ptr_cnt++;
					if( debug ) {
						printf( "f[^ύX ptr %d ptr_cnt = %d\n",
								ptr, ptr_cnt );
					}
					break;
				case	'd':			/*	폜	*/
					if( debug ) {
						printf( "f[^폜O ptr %d ptr_cnt = %d\n",
								ptr, ptr_cnt );
					}
					if( ptr > rc ) {
						ptr_cnt -= (ptr-rc);
					} else {
						ptr_cnt -= (ptr+10-rc);
					}
					ptr = rc;
					if( debug ) {
						printf( "f[^폜 ptr %d ptr_cnt = %d\n",
								ptr, ptr_cnt );
					}
					break;
				default:				/*	ύX	*/
					break;
			}
		}
	}
}

void	push_data( char *dt )	/*	ǂݍ񂾃f[^i[	*/
{
	int		n;

	if( ptr_cnt == BUFF_MAX ) {
		n = ptr - ptr_cnt;
		if( n < 0 ) {
			n += BUFF_MAX;
		}
		fprintf( out_fp, "%s", r_buff1[n] );
		ptr_cnt--;
	}
	strcpy( r_buff1[ptr], dt );
	cust_dt( r_buff1[ptr], r_buff2[ptr], r_buff3[ptr] );
	ptr++;
	ptr_cnt++;
	if( ptr >= BUFF_MAX ) {
		ptr = 0;
	}
	if( ptr_cnt >= l_min ) {
		check_data();
	}
}

void	opt_main()						/*	C					*/
{
	opt_init();
	while( fgets( buff1, BUFF_LEN, fp ) != NULL ) {
		push_data( buff1 );
	}
	opt_end();
}

int	main( int argc, char *argv[] )
{
	int		i;
	char	*p;

	printf( "%s\n\n", VER );
	if( argc < 4 ) {
		help(argv[0]);
		exit(-1);
	}
	/* e[ut@C̏ */
	if( access( argv[1], 0 ) == 0 ) {
		strcpy( table, argv[1] );
	} else {
		strcpy( table, argv[0] );
		if( (p=strrchr(table,'\\')) != NULL ) {
			*(p+1) = 0;
		}
		strcat( table, argv[1] );
		if( access( table, 0 ) != 0 ) {
			printf( "File not found [ %s ]\n", table );
			return(-1);
		}
	}
	/* ̓t@C̗L`FbN */
	if( access( argv[2], 0 ) != 0 ) {
		printf( "File not found [ %s ]\n", argv[2] );
		return(-1);
	}
	source = argv[2];
	backup = argv[3];

	if( access( backup, 0 ) == 0 ) {
		unlink( backup );
	}
	rename( source, backup );

	opt_main();
	return(0);
}
