//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit4.h"
#include "profile.h"
#include "control.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOptionBox *OptionBox;
//---------------------------------------------------------------------------
__fastcall TOptionBox::TOptionBox(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TOptionBox::BitBtn1Click(TObject *Sender)
{
	char	ans[256];

	getprofilestring( CONTROL_DATA, "Setting", "Compiler", ans, "" );
	if( strcmp( CompilerCommand->Text.c_str(), ans ) != 0 ) {
		setprofilestring( CONTROL_DATA, "Setting", "Compiler", CompilerCommand->Text.c_str() );
	}
	getprofilestring( CONTROL_DATA, "Setting", "Makeasm", ans, "" );
	if( strcmp( MakeasmCommand->Text.c_str(), ans ) != 0 ) {
		setprofilestring( CONTROL_DATA, "Setting", "Makeasm", MakeasmCommand->Text.c_str() );
	}
	getprofilestring( CONTROL_DATA, "Setting", "Assembler", ans, "" );
	if( strcmp( AssemblerCommand->Text.c_str(), ans ) != 0 ) {
		setprofilestring( CONTROL_DATA, "Setting", "Assembler", AssemblerCommand->Text.c_str() );
	}
	getprofilestring( CONTROL_DATA, "Setting", "Optimize", ans, "" );
	if( strcmp( OptimizeCommand->Text.c_str(), ans ) != 0 ) {
		setprofilestring( CONTROL_DATA, "Setting", "Optimize", OptimizeCommand->Text.c_str() );
	}
	getprofilestring( CONTROL_DATA, "Setting", "OptimizeStatus", ans, "on" );
	if( toupper(ans[0]) == 'O' && toupper(ans[1]) == 'N' && ans[2] == 0 ) {
		if( Optimize->ItemIndex != 0 ) {
			setprofilestring( CONTROL_DATA, "Setting", "OptimizeStatus", "off" );
		}
	} else {
		if( Optimize->ItemIndex != 1 ) {
			setprofilestring( CONTROL_DATA, "Setting", "OptimizeStatus", "on" );
		}
	}
	getprofilestring( CONTROL_DATA, "Setting", "SymbolUpdate", ans, "" );
	if( strcmp( SymbolUpdateCommand->Text.c_str(), ans ) != 0 ) {
		setprofilestring( CONTROL_DATA, "Setting", "SymbolUpdate", SymbolUpdateCommand->Text.c_str() );
	}
    OptionBox->Close();
}
//---------------------------------------------------------------------------
void __fastcall TOptionBox::BitBtn2Click(TObject *Sender)
{
	char	ans[256];

   	getprofilestring( CONTROL_DATA, "Setting", "Compiler", ans, "h8cc32 $0.c" );
   	CompilerCommand->Text = ans;
   	getprofilestring( CONTROL_DATA, "Setting", "Makeasm", ans, "h8cc32 $0.c -a" );
   	MakeasmCommand->Text = ans;
   	getprofilestring( CONTROL_DATA, "Setting", "Assembler", ans, "aasm32 -m -m3048.mac -l -s $0.asm" );
   	AssemblerCommand->Text = ans;
   	getprofilestring( CONTROL_DATA, "Setting", "Optimize", ans, "optim32 3048.dat $0.asm $0.as1" );
   	OptimizeCommand->Text = ans;
   	getprofilestring( CONTROL_DATA, "Setting", "OptimizeStatus", ans, "on" );
   	if( toupper(ans[0]) == 'O' && toupper(ans[1]) == 'N' && ans[2] == 0 ) {
   		Optimize->ItemIndex = 0;
   	} else {
   		Optimize->ItemIndex = 1;
   	}
   	getprofilestring( CONTROL_DATA, "Setting", "SymbolUpdate", ans, "h8cc32 $0.hex" );
   	SymbolUpdateCommand->Text = ans;
    OptionBox->Close();
}
//---------------------------------------------------------------------------
void __fastcall TOptionBox::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	Form1->Enabled = true;
}
//---------------------------------------------------------------------------
